import java.io.*;
import java.util.StringTokenizer;

/**
 * @author Roman V Satyukov
 */
public class aisle_rs implements Runnable {
    private final String problemID = getClass().getName().split("_")[0].toLowerCase();
    private BufferedReader in;
    private PrintWriter out;

    private void check(boolean expr, String message) {
        if (!expr) {
            throw new AssertionError(message);
        }
    }
    
    private void solve() throws IOException {
        StringTokenizer st = new StringTokenizer(in.readLine());
        long n = Integer.parseInt(st.nextToken());
        long L = Integer.parseInt(st.nextToken());
        long W = Integer.parseInt(st.nextToken());
        long x = Integer.parseInt(st.nextToken());
        long y = Integer.parseInt(st.nextToken());
        long a = Integer.parseInt(st.nextToken());
        check((1 <= n) && (n <= 10000), "n is not in [1..10^4]");
        check((1 <= L) && (L <= 10000), "L is not in [1..10^4]");
        check((1 <= W) && (W <= 10000), "W is not in [1..10^4]");
        check((1 <= x) && (x <= 10000), "x is not in [1..10^4]");
        check((1 <= y) && (y <= 10000), "y is not in [1..10^4]");
        check((1 <= a) && (a <= 10000), "a is not in [1..10^4]");
        if (L < x) {
            out.println("-1");
            return;
        }
        long rowSize = L / x;
        long rows = (n + rowSize - 1) / rowSize;
        long aisles = (W - rows * y) / a;
        if (aisles < 1) {
            out.println("-1");
            return;
        }
        out.println(Math.min(n, 2 * aisles * rowSize));
    }

    public void run() {
        try {
            in = new BufferedReader(new FileReader(new File(problemID + ".in")));
            out = new PrintWriter(new File(problemID + ".out"));
            solve();
            in.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
    
    public static void main(String[] args) {
        new Thread(new aisle_rs()).start();
    }
}
