import java.io.*;
import java.util.*;
import java.math.*;

public class bridge_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new bridge_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void myAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	void inBounds(long x, long l, long r, String name) {
		myAssert(l <= x && x <= r, name + " is not in bounds [" + l + ".." + r
				+ "]!!!");
	}

	String FNAME = "bridge";

	double eps = 1e-9;

	int INF = (int) Math.round(Math.sqrt(Integer.MAX_VALUE) / 4);

	private void solve() throws IOException {
		Land l1 = nextLand();
		Land l2 = nextLand();
		out.println(l1.distTo(l2));
	}

	private Land nextLand() {
		Land l = new Land(nextInt());
		for (int i = 1; i + 1 < l.p.length; i++) {
			l.p[i] = nextPoint();
		}
		l.p[0] = new Point(l.p[1].x, -INF);
		l.p[l.p.length - 1] = new Point(l.p[l.p.length - 2].x, INF);
		return l;
	}

	private Point nextPoint() {
		return new Point(nextInt(), nextInt());
	}

	class Point {
		public Point(int i, int j) {
			x = i;
			y = j;
		}

		int x, y;

		public double distTo(Segment s) {
			long cos1 = (x - s.p1.x) * (s.p2.x - s.p1.x) + (y - s.p1.y)
					* (s.p2.y - s.p1.y);
			long cos2 = (x - s.p2.x) * (s.p1.x - s.p2.x) + (y - s.p2.y)
					* (s.p1.y - s.p2.y);
			if (cos1 <= 0 || cos2 <= 0) {
				return Math.min(this.distTo(s.p1), this.distTo(s.p2));
			}
			double a = s.p1.y - s.p2.y;
			double b = s.p2.x - s.p1.x;
			double c = -a * s.p1.x - b * s.p1.y;
			double d = Math.sqrt(a * a + b * b);
			a /= d;
			b /= d;
			c /= d;
			if (a < -eps || (Math.abs(a) < eps && b < -eps)) {
				a = -a;
				b = -b;
				c = -c;
			}
			return Math.abs(a * x + b * y + c);
		}

		private double distTo(Point p) {
			return Math.sqrt((x - p.x) * (x - p.x) + (y - p.y) * (y - p.y));
		}
	}

	class Segment {
		public Segment(Point point, Point point2) {
			p1 = point;
			p2 = point2;
		}

		Point p1, p2;
	}

	class Land {
		public Land(int i) {
			p = new Point[i + 2];
		}

		public double distTo(Land l) {
			double ans = Double.POSITIVE_INFINITY;
			for (Point p : this.p) {
				for (Segment s = l.firstSegment(); s != null; s = l.next()) {
					ans = Math.min(ans, p.distTo(s));
				}
			}
			for (Point p : l.p) {
				for (Segment s = this.firstSegment(); s != null; s = this
						.next()) {
					ans = Math.min(ans, p.distTo(s));
				}
			}
			return ans;
		}

		private Segment next() {
			if (q >= p.length) {
				return null;
			}
			Segment ans = new Segment(p[q - 1], p[q]);
			q++;
			return ans;
		}

		private Segment firstSegment() {
			q = 2;
			return new Segment(p[0], p[1]);
		}

		int q;

		Point[] p;
	}
}
