/*  ""
 * 9-      
 *  :  , stankev@rain.ifmo.ru
 *  :  , argentony@gmail.com
 */

import java.io.*;
import java.math.*;
import java.util.*;

public class bridge_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new bridge_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("bridge.in"));
			out = new PrintWriter("bridge.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	final int MAX = 10000;
	
	void solve() throws IOException {
		int m = nextInt();
		myAssert(2 <= m && m <= 100, "m is out of bounds ( " + m + " )");
		BLine bl1 = new BLine(m);
		for (int i = 0; i < m; i++) {
			bl1.x[i] = nextInt();
			myAssert(-MAX <= bl1.x[i] && bl1.x[i] <= MAX, "bl1.x[i] is out of bounds ( " + bl1.x[i] + " )");
			bl1.y[i] = nextInt();
			myAssert(-MAX <= bl1.y[i] && bl1.y[i] <= MAX, "bl1.y[i] is out of bounds ( " + bl1.y[i] + " )");
		}
		int n = nextInt();
		myAssert(2 <= n && n <= 100, "n is out of bounds ( " + n + " )");
		BLine bl2 = new BLine(n);
		for (int i = 0; i < n; i++) {
			bl2.x[i] = nextInt();
			myAssert(-MAX <= bl2.x[i] && bl2.x[i] <= MAX, "bl2.x[i] is out of bounds ( " + bl2.x[i] + " )");
			bl2.y[i] = nextInt();
			myAssert(-MAX <= bl2.y[i] && bl2.y[i] <= MAX, "bl2.y[i] is out of bounds ( " + bl2.y[i] + " )");
		}
		myAssert(!st.hasMoreElements() && br.readLine() == null, "Extra lines!");
		myAssert(bl1.x[0] < bl2.x[0], "First line is righter");
		for (int i = 0; i < bl1.n - 1; i++) {
			myAssert(bl1.x[i] != bl1.x[i + 1] || bl1.y[i] != bl1.y[i + 1], "Equal point in first line");
			for (int j = i + 2; j < bl1.n - 1; j++) {
				myAssert(!cross(new long[][]{{bl1.x[i], bl1.x[i + 1]}, {bl1.x[j], bl1.x[j + 1]}}, 
								new long[][]{{bl1.y[i], bl1.y[i + 1]}, {bl1.y[j], bl1.y[j + 1]}}), "");
			}
			myAssert(!cross(new long[][]{{bl1.x[i], bl1.x[i + 1]}, {bl2.x[0], bl2.x[0]}}, 
							new long[][]{{bl1.y[i], bl1.y[i + 1]}, {bl2.y[0], - 2 * MAX}}), "");
			myAssert(!cross(new long[][]{{bl1.x[i], bl1.x[i + 1]}, {bl2.x[bl2.n - 1], bl2.x[bl2.n - 1]}}, 
							new long[][]{{bl1.y[i], bl1.y[i + 1]}, {bl2.y[bl2.n - 1], 2 * MAX}}), "");
			for (int j = 0; j < bl2.n - 1; j++) {
				myAssert(!cross(new long[][]{{bl1.x[i], bl1.x[i + 1]}, {bl2.x[j], bl2.x[j + 1]}}, 
								new long[][]{{bl1.y[i], bl1.y[i + 1]}, {bl2.y[j], bl2.y[j + 1]}}), "");
			}
		}
		for (int i = 0; i < bl2.n - 1; i++) {
			myAssert(bl2.x[i] != bl2.x[i + 1] || bl2.y[i] != bl2.y[i + 1], "Equal point in second line");
			for (int j = i + 2; j < bl2.n - 1; j++) {
				myAssert(!cross(new long[][]{{bl2.x[i], bl2.x[i + 1]}, {bl2.x[j], bl2.x[j + 1]}}, 
								new long[][]{{bl2.y[i], bl2.y[i + 1]}, {bl2.y[j], bl2.y[j + 1]}}), "");
			}
			myAssert(!cross(new long[][]{{bl2.x[i], bl2.x[i + 1]}, {bl1.x[0], bl1.x[0]}}, 
							new long[][]{{bl2.y[i], bl2.y[i + 1]}, {bl1.y[0], - 2 * MAX}}), "");
			myAssert(!cross(new long[][]{{bl2.x[i], bl2.x[i + 1]}, {bl1.x[bl1.n - 1], bl1.x[bl1.n - 1]}}, 
							new long[][]{{bl2.y[i], bl2.y[i + 1]}, {bl1.y[bl1.n - 1], 2 * MAX}}), "");
		}
			
		out.println(Math.min(getAns(bl1, bl2), getAns(bl2, bl1)));
		
	}
	
	boolean between(long l, long x, long r) {
		return l <= x && x <= r || r <= x && x <= l;
	}
	
	boolean cross(long[][] x, long[][] y) {
		long[] a = new long[2];
		long[] b = new long[2];
		long[] c = new long[2];
		for (int i = 0; i < 2; i++) {
			a[i] = y[i][1] - y[i][0];
			b[i] = x[i][0] - x[i][1];
			c[i] = - a[i] * x[i][0] - b[i] * y[i][0];
		}
		
		long[][] s = new long[2][2];
		for (int i = 0; i < 2; i++) {
			for (int j = 0; j < 2; j++) {
				s[i][j] = Math.round(Math.signum(a[i] * x[1 - i][j] + b[i] * y[1 - i][j] + c[i]));
			}
		}
		
		if (s[0][0] == 0 && s[0][1] == 0) {
			return (between(x[0][0], x[1][0], x[0][1]) && between(y[0][0], y[1][0], y[0][1]) || 
					between(x[0][0], x[1][1], x[0][1]) && between(y[0][0], y[1][1], y[0][1]));
		} else {
			return (s[0][0] * s[0][1] <= 0 && s[1][0] * s[1][1] <= 0);
		}
	}
	
	
	double dist(long x0, long y0, long x1, long y1, long x2, long y2) {
		long a = (x2 - x0) * (x2 - x0) + (y2 - y0) * (y2 - y0);
		long b = (x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0);
		long c = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
		if (a + c >= b && b + c >= a) {
			long aa = y2 - y1;
			long bb = x1 - x2;
			long cc = - aa * x1 - bb * y1;
			return Math.abs(aa * x0 + bb * y0 + cc) / Math.sqrt(aa * aa + bb * bb);
		} else {
			return Math.sqrt(Math.min(a, b));
		}
	}
	
	double getAns(BLine a, BLine b) {
		double ans = Double.POSITIVE_INFINITY;
		for (int i = 0; i < a.n; i++) {
			if (a.y[i] <= b.y[0]) ans = Math.min(ans, Math.abs(a.x[i] - b.x[0]));
			for (int j = 0; j < b.n - 1; j++) {
				ans = Math.min(ans, dist(a.x[i], a.y[i], b.x[j], b.y[j], b.x[j + 1], b.y[j + 1]));
			}
			if (a.y[i] >= b.y[b.n - 1]) ans = Math.min(ans, Math.abs(a.x[i] - b.x[b.n - 1]));
		}
		return ans;
	}
	
	
	class BLine {
		int n;
		long[] x, y;
		
		public BLine(int n) {
			this.n = n;
			x = new long[n];
			y = new long[n];
		}
	}
	
}
