// Задача "Мост"
// IX Всероссийская командная олимпиада школьников по программированию
// Автор задачи: Андрей Станкевич
// Автор решения: Олег Давыдов, burunduk3@gmail.com

#include <algorithm>
#include <cmath>
#include <cstdio>

using namespace std;

typedef long double dbl;

dbl sqr( dbl x )
{
  return x * x;
}

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define eps 1e-11
#define maxn 110

dbl solve( dbl x1, dbl y1, dbl x2, dbl y2, dbl x, dbl y )
{
  dbl res = min(sqrt(sqr(x1 - x) + sqr(y1 - y)), sqrt(sqr(x2 - x) + sqr(y2 - y)));
  if (res < eps)
    return res;
  dbl tmp = (x - x1) * (x2 - x1) + (y - y1) * (y2 - y1);
  tmp /= sqr(x2 - x1) + sqr(y2 - y1);
  if (tmp < 0.0 || tmp > 1.0)
    return res;
  res = min(res, fabs(((x - x1) * (y1 - y2) + (y - y1) * (x2 - x1))) / sqrt(sqr(x2 - x1) + sqr(y2 - y1)));
  return res;
}

namespace burunduk3
{
  int m, n;
  int x1[maxn], y1[maxn], x2[maxn], y2[maxn];
  int main()
  {
    freopen("bridge.in", "r", stdin);
    freopen("bridge.out", "w", stdout);

    scanf("%d", &n);
    forn (i, n)
      scanf("%d%d", &x1[i + 1], &y1[i + 1]);
    scanf("%d", &m);
    forn (i, m)
      scanf("%d%d", &x2[i + 1], &y2[i + 1]);
    x1[0] = x1[1], y1[0] = -100000;
    x1[n + 1] = x1[n], y1[n + 1] = 100000;
    x2[0] = x2[1], y2[0] = -100000;
    x2[m + 1] = x2[m], y2[m + 1] = 100000;
    m += 2, n += 2;

    dbl ans = 1e100;
    forn (i, n)
      forn (j, m)
      {
        if (i < n - 1)
          ans = min(ans, solve(x1[i], y1[i], x1[i + 1], y1[i + 1], x2[j], y2[j]));
        if (j < m - 1)
          ans = min(ans, solve(x2[j], y2[j], x2[j + 1], y2[j + 1], x1[i], y1[i]));
      }
// I hope that sometimes olympiads would be runned under posix operation system, where are no troubles in hard-to-reach places
    printf("%.20lf\n", (double)ans);
    
    return 0;
  }
}

int main()
{
  return burunduk3::main();
}
