import java.io.*;
import java.util.*;

/**
 * @author Roman V Satyukov
 */
public class codes_rs implements Runnable {
    private final String problemID = getClass().getName().split("_")[0].toLowerCase();
    private BufferedReader in;
    private PrintWriter out;
    
    private void check(boolean expr, String message) {
        if (!expr) {
            throw new AssertionError(message);
        }
    }
    
    private void solve() throws IOException {
    	StringTokenizer st = new StringTokenizer(in.readLine());
    	int n = Integer.parseInt(st.nextToken());
    	int k = Integer.parseInt(st.nextToken());
    	check((1 <= n) && (n <= 100000), "n is not in [1..10^5]");
    	check((0 <= k) && (k <= 200), "k is not in [0..200]");
    	String[] words = new String[n];
    	int totalLength = 0;
    	for (int i = 0; i < n; i++) {
    		words[i] = in.readLine();
    		check(words[i].length() <= 200, "Length of some words is not in [0..200]");
    		totalLength += words[i].length();
    	}
    	check(totalLength <= 1000000, "TotalLength is not in [0..10^6]");
    	Arrays.sort(words);
    	String[] answer = new String[n];
    	int count = 0;
    	for (int i = 0; i + 1 < n; i++) {
    		int sz = Math.min(words[i].length(), words[i + 1].length());
    		int pos = -1;
    		for (int j = 0; j < sz; j++) {
    			if (words[i].charAt(j) != words[i + 1].charAt(j)) {
    				pos = j;
    				break;
    			}
    		}
    		if (pos == -1) {
    			check(words[i].length() != words[i + 1].length(), "There is at least one pair of equal words");
    			pos = sz;
    		}
    		if (pos <= k) {
    			answer[count++] = words[i];
    		}
    	}
    	answer[count++] = words[n - 1];
    	out.println(count);
    	for (int i = 0; i < count; i++) {
    		out.println(answer[i]);
    	}
    }

    public void run() {
        try {
            in = new BufferedReader(new FileReader(new File(problemID + ".in")));
            out = new PrintWriter(new File(problemID + ".out"));
            solve();
            in.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
    
    public static void main(String[] args) {
        new Thread(new codes_rs()).start();
    }
}
