/*  " "
 * 9-      
 *  :  , tsarev@rain.ifmo.ru
 *  :  , argentony@gmail.com
 */

import java.io.*;
import java.math.*;
import java.util.*;

public class gems_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new gems_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("gems.in"));
			out = new PrintWriter("gems.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 100000, "n is out of bounds ( " + n + " )");
		int k = nextInt();
		myAssert(1 <= k && k <= 676, "k is out of bounds ( " + k + " )");
		String s = nextToken();
		myAssert(n == s.length(), "!(n == s.length())");
		for (int i = 0; i < s.length(); i++) {
			myAssert('a' <= s.charAt(i) && s.charAt(i) <= 'z', "s.charAt(i) is out of bounds ( " + s.charAt(i) + " )");
		}
		
		char[][] tab = new char[26][26];
		for (int i = 0; i < k; i++) {
			String ts = nextToken();
			myAssert(ts.length() == 2, "!(ts.length() == 2)");
			myAssert('a' <= ts.charAt(0) && ts.charAt(0) <= 'z', "ts.charAt(0) is out of bounds ( " + ts.charAt(0) + " )");
			myAssert('a' <= ts.charAt(1) && ts.charAt(1) <= 'z', "ts.charAt(1) is out of bounds ( " + ts.charAt(1) + " )");
			myAssert(tab[ts.charAt(0) - 'a'][ts.charAt(1) - 'a'] == 0, "duplicate allowed pair");
			tab[ts.charAt(0) - 'a'][ts.charAt(1) - 'a'] = 1;
		}
		myAssert(!st.hasMoreElements() && br.readLine() == null, "Extra lines!");
		long ans = 0;
		int[] cnt = new int[26];
		for (int i = 0; i < n; i++) {
			int c = s.charAt(i) - 'a';
			for (int j = 0; j < 26; j++) {
				ans += cnt[j] * tab[j][c];
			}
			++cnt[c];
		}
		out.println(ans);
	}
}
