import java.io.*;
import java.util.*;

/**
 * @author Roman V Satyukov
 */
public class gems_rs implements Runnable {
	private final String problemID = getClass().getName().split("_")[0].toLowerCase();
	private BufferedReader in;
	private PrintWriter out;
	
	private void check(boolean expr, String message) {
		if (!expr) {
			throw new AssertionError(message);
		}
	}
	
	private void solve() throws IOException {
		StringTokenizer st = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(st.nextToken());
		int k = Integer.parseInt(st.nextToken());
		check((1 <= n) && (n <= 100000), "n is not in [1..10^5]");
		check((1 <= k) && (k <= 676), "k is not in [1..676]");
		String seq = in.readLine();
		boolean[][] good = new boolean[26][26];
		for (int i = 0; i < k; i++) {
			String cur = in.readLine();
			check(cur.length() == 2, "Invalid gem pair description: " + cur);
			int u = cur.charAt(0) - 'a';
			int v = cur.charAt(1) - 'a';
			good[u][v] = true;
		}
		int[] count = new int[26];
		long answer = 0;
		for (int i = 0; i < n; i++) {
			int cur = seq.charAt(i) - 'a';
			for (int u = 0; u < 26; u++) {
				answer += (good[u][cur] ? count[u] : 0);
			}
			count[cur]++;
		}
		out.println(answer);
	}
	
	public static void main(String[] args) {
		new Thread(new gems_rs()).start();
	}

	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File(problemID + ".in")));
			out = new PrintWriter(new File(problemID + ".out"));
			solve();
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
