import java.io.*;
import java.util.*;

/**
 * @author Roman V Satyukov
 */
public class numbers_rs_bug1 implements Runnable {
    private final String problemID = getClass().getName().split("_")[0].toLowerCase();
    private BufferedReader in;
    private PrintWriter out;

    private void check(boolean expr, String message) {
        if (!expr) {
            throw new AssertionError(message);
        }
    }
    
    private long calc(long n, int k) {
        long z = k;
        long answer = 0;
        while (n >= z) {
            long cur = n / z;
            answer += cur - (cur / k);
            z = z * k * k;
        }
        return answer;
    }
    
    private void solve() throws IOException {
        StringTokenizer st = new StringTokenizer(in.readLine());
        long n = Long.parseLong(st.nextToken());
        int k = Integer.parseInt(st.nextToken());
        check((1 <= n) && (n <= 1000000000000000L), "n is not in [1..10^15]");
        check((2 <= k) && (k <= 10), "k is not in [2..10]");
        
        long low = 0;
        long hi = Long.MAX_VALUE / 3;
        while (low + 1 < hi) {
            long middle = (low + hi) / 2;
            if (calc(middle, k) >= n) {
                hi = middle;
            } else {
                low = middle;
            }
        }
        out.println(hi);
    }

    public void run() {
        try {
            in = new BufferedReader(new FileReader(new File(problemID + ".in")));
            out = new PrintWriter(new File(problemID + ".out"));
            solve();
            in.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
    
    public static void main(String[] args) {
        new Thread(new numbers_rs_bug1()).start();
    }
}
