//  ""
// 9-      
//  :  
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class optimize_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new optimize_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	Random random = new Random(this.hashCode());

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "optimize";

	class Work implements Comparable<Work> {
		long t, wt;

		@Override
		public int compareTo(Work o) {
			if (t < o.t)
				return -1;
			if (t > o.t)
				return 1;
			if (wt > o.wt)
				return -1;
			if (wt < o.wt)
				return 1;
			return 0;
		}

	}

	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		int[] t = new int[m];
		for (int i = 0; i < m; i++) {
			t[i] = nextInt();
		}
		long[] sumt = new long[n];
		int[] w = new int[m];
		for (int i = 0; i < n; i++) {
			int c = nextInt();
			while (c-- > 0) {
				int tt = nextInt() - 1;
				sumt[i] += t[tt];
				w[tt] = i;
			}
		}
		Work[] works = new Work[m];
		for (int i = 0; i < m; i++) {
			works[i] = new Work();
			works[i].t = t[i];
			works[i].wt = sumt[w[i]];
		}
		Arrays.sort(works);
		long ans = 0;
		Tree tree = new Tree(works[0].wt - works[0].t);
		for (int i = 1; i < m; i++) {
			ans += calc(tree, works[i].wt - works[i].t);
			tree = add(tree, works[i].wt - works[i].t);
		}
		out.println(ans);
	}

	class Tree {
		int y, lc, rc, c;
		long x;
		Tree l, r;

		Tree(long x) {
			this.x = x;
			y = random.nextInt();
			c = 1;
		}
	}

	boolean inc(Tree t, long x) {
		if (t == null) {
			return false;
		}
		if (t.x < x) {
			if (inc(t.r, x)) {
				t.rc++;
				return true;
			}
			return false;
		} else if (t.x > x) {
			if (inc(t.l, x)) {
				t.lc++;
				return true;
			}
			return false;
		}
		t.c++;
		return true;
	}

	Tree add(Tree t, long x) {
		if (inc(t, x)) {
			return t;
		}
		Tree tt = new Tree(x);
		Tree[] a = split(t, x);
		t = merge(a[0], tt);
		t = merge(t, a[1]);
		return t;
	}

	int calc(Tree t, long x) {
		if (t == null) {
			return 0;
		}
		if (t.x < x) {
			return t.lc + t.c + calc(t.r, x);
		}
		return calc(t.l, x);
	}

	Tree merge(Tree t1, Tree t2) {
		if (t1 == null)
			return t2;
		if (t2 == null)
			return t1;
		if (t1.y < t2.y) {
			t1.r = merge(t1.r, t2);
			t1.rc = t1.r.rc + t1.r.lc + t1.r.c;
			return t1;
		} else {
			t2.l = merge(t1, t2.l);
			t2.lc = t2.l.rc + t2.l.lc + t2.l.c;
			return t2;
		}
	}

	Tree[] split(Tree t, long x) {
		if (t == null) {
			return new Tree[] { null, null };
		}
		if (t.x < x) {
			Tree[] ans = split(t.r, x);
			t.r = ans[0];
			if (t.r == null) {
				t.rc = 0;
			} else {
				t.rc = t.r.lc + t.r.rc + t.r.c;
			}
			ans[0] = t;
			return ans;
		} else {
			Tree[] ans = split(t.l, x);
			t.l = ans[1];
			if (t.l == null) {
				t.lc = 0;
			} else {
				t.lc = t.l.lc + t.l.rc + t.l.c;
			}
			ans[1] = t;
			return ans;
		}
	}

}
