//  ""
//       2008 
//  :  
//  :  , tsarev@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class shelves_ft implements Runnable {

	private final static int INF = (int) 1e9;

	private void myAssert(boolean e, String message) {
		if (!e) {
			throw new Error("Assertion failure!!! " + message);
		}
	}                               


	void solve() throws NumberFormatException, IOException {
		int m = nextInt();
		myAssert(1 <= m && m <= 100000, "m is out of range: " + m);
		int n = nextInt();
		myAssert(1 <= n && n <= 100000, "n is out of range: " + n);
		int[] a = new int[m];
		int[] b = new int[n];
		for (int i = 0; i < m; i++) {
			a[i] = nextInt();
			myAssert(1 <= a[i] && a[i] <= 1000000000, "a[" + i +"] is out of range: " + a[i]);
		}
		for (int i = 0; i < n; i++) {
			b[i] = nextInt();
			myAssert(1 <= b[i] && b[i] <= 1000000000, "b[" + i +"] is out of range: " + b[i]);
		}
		long[] h1 = new long[m + 1];
		h1[0] = 0;
		for (int i = 1; i <= m; i++) {
			h1[i] = h1[i - 1] + a[i - 1];
		}
		long[] h2 = new long[n + 1];
		for (int i = 1; i <= n; i++) {
			h2[i] = h2[i - 1] + b[i - 1];
		}
		HashSet<Long> set = new HashSet<Long>();
		for (long x : h1) {
			set.add(x);
		}
		for (long x : h2) {
			set.add(x);
		}
		ArrayList<Long> list = new ArrayList<Long>();
		for (long x : set) {
			list.add(x);
		}
		Collections.sort(list);
		HashMap<Long, Integer> map = new HashMap<Long, Integer>();
		for (int i = 0; i < list.size(); i++) {
			map.put(list.get(i), i);
		}

		int[][] go = new int[list.size()][2];
		int[][] num = new int[list.size()][2];
		for (int[] arr : go) {
			Arrays.fill(arr, -1);
		}	
		for (int[] arr : num) {
			Arrays.fill(arr, -1);
		}	

		for (int i = 0; i <= m - 1; i++) {
			go[map.get(h1[i])][0] = map.get(h1[i + 1]);
			num[map.get(h1[i])][0] = i + 1;	
		}

		for (int i = 0; i <= n - 1; i++) {
			go[map.get(h2[i])][1] = map.get(h2[i + 1]);
			num[map.get(h2[i])][1] = i + 1;	
		}

		int cnt = list.size();

		int[] val = new int[list.size()];
		int[] pi = new int[cnt];
		int[][] ansAdd = new int[cnt][2];
		Arrays.fill(val, -INF);
		Arrays.fill(pi, -1);
		for (int[] arr : ansAdd) {
			Arrays.fill(arr, -1);
		}
		val[0] = 0;
		for (int i = 0; i < cnt; i++) {
			if (val[i] == -INF) {
				continue;
			}
			if (i < cnt - 1 && val[i + 1] < val[i]) {
				val[i + 1] = val[i];
				pi[i + 1] = i;
				ansAdd[i + 1] = new int[] {-1, -1};
			}
			for (int j = 0; j < 2; j++) {
				if (go[i][j] == -1) {
					continue;
				}
				int next = go[i][j];
				if (val[next] < val[i] + 1) {
					val[next] = val[i] + 1;
					pi[next] = i;
					ansAdd[next] = new int[]{num[i][j], j};
				}
			}
		}

		int upa = map.get(h1[m]);
		int upb = map.get(h2[n]);
		
		ArrayList<Integer> ansLeft = new ArrayList<Integer>();
		ArrayList<Integer> ansRight = new ArrayList<Integer>();
		int cur = -1;
		if (val[upa] > val[upb]) {
			cur = upa;
		} else {
			cur = upb;
		}

		while (pi[cur] != -1) {
			int[] aa = ansAdd[cur];
			if (aa[0] != -1) {
  				if (aa[1] == 0) {
					ansLeft.add(aa[0]);
				} else {
					ansRight.add(aa[0]);
				}
			}
			cur = pi[cur];
		}
		
		Collections.sort(ansLeft);
		Collections.sort(ansRight);

		out.println(ansLeft.size() + " " + ansRight.size());
		for (int x : ansLeft) {
			out.print(x + " ");
		}
		out.println();
		for (int x : ansRight) {
			out.print(x + " ");
		}
		out.println();

	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new Thread(new shelves_ft("shelves")).start();
	}

	private BufferedReader in;
	private StringTokenizer st;
	private PrintWriter out;
	
	public shelves_ft(String fname) throws IOException {
		in = new BufferedReader(new FileReader(fname + ".in"));
		st = new StringTokenizer("");
		out = new PrintWriter(new FileWriter(fname + ".out"));
	}
	
	
	String nextToken() throws IOException {
		while (!st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			apstenu(e);
		} finally {
			out.close();
		}
	}

	private void apstenu(Exception e) {
		e.printStackTrace();
		System.exit(1);
	}
	
}
