import java.io.*;
import java.util.*;

/**
 * @author Roman V Satyukov
 */
public class shelves_rs implements Runnable {
	private final String problemID = getClass().getName().split("_")[0].toLowerCase();
	private BufferedReader in;
	private PrintWriter out;
	
	private void check(boolean expr, String message) {
		if (!expr) {
			throw new AssertionError(message);
		}
	}
	
	private void solve() throws IOException {
		StringTokenizer st = new StringTokenizer(in.readLine());
		int m = Integer.parseInt(st.nextToken());
		int n = Integer.parseInt(st.nextToken());
		check((1 <= m) && (m <= 100000), "m is not in [1..100000]");
		check((1 <= n) && (n <= 100000), "n is not in [1..100000]");
		st = new StringTokenizer(in.readLine());
		int[] a = new int[m];
		for (int i = 0; i < m; i++) {
			a[i] = Integer.parseInt(st.nextToken());
			check((1 <= a[i]) && (a[i] <= 1000000000), "Some of a[i] is not in [1..10^9]");
		}
		st = new StringTokenizer(in.readLine());
		int[] b = new int[n];
		for (int i = 0; i < n; i++) {
			b[i] = Integer.parseInt(st.nextToken());
			check((1 <= b[i]) && (b[i] <= 1000000000), "Some of b[i] is not in [1..10^9]");
		}
		long ha = 0;
		long hb = 0;
		long h = 0;
		int i = 0;
		int j = 0;
		List<Integer> answerA = new ArrayList<Integer>();
		List<Integer> answerB = new ArrayList<Integer>();
		while (i < m && j < n) {
			if (ha < h) {
				ha += a[i++];
				continue;
			}
			if (hb < h) {
				hb += b[j++];
				continue;
			}
			if (ha + a[i] <= hb + b[j]) {
				ha += a[i];
				h = ha;
				answerA.add(i++);
			} else {
				hb += b[j];
				h = hb;
				answerB.add(j++);
			}
		}
		while (i < m) {
			if (ha < h) {
				ha += a[i++];
				continue;
			}
			ha += a[i];
			answerA.add(i++);
		}
		while (j < n) {
			if (hb < h) {
				hb += b[j++];
				continue;
			}
			hb += b[j];
			answerB.add(j++);
		}
		out.println(answerA.size() + " " + answerB.size());
		for (int k = 0; k < answerA.size(); k++) {
			out.print((answerA.get(k) + 1) + " ");
		}
		out.println();
		for (int k = 0; k < answerB.size(); k++) {
			out.print((answerB.get(k) + 1) + " ");
		}
		out.println();
	}
	
	public static void main(String[] args) {
		new Thread(new shelves_rs()).start();
	}

	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File(problemID + ".in")));
			out = new PrintWriter(new File(problemID + ".out"));
			solve();
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
