//  " "
// 9-      
//  :  , ulyantsev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class spiral_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new spiral_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "spiral";
	
	double v, r, w, t;
	
	double countY(double ang) {
		return (v * (ang / w) + r) * Math.sin(ang); 
	}
	
	double countX(double ang) {
		return (v * (ang / w) + r) * Math.cos(ang); 
	}
	
	double getMaxY(double l, double r) {
		if (l < 0) {
			return countY(0);
		}
		for (int i = 0; i < 100; i++) {
			double x1 = countY(l + (r - l) / 3);
			double x2 = countY(l + 2 * (r - l) / 3);
			if (x1 < x2) {
				l += (r - l) / 3;
			} else {
				r -= (r - l) / 3;
			}
		}
		return countY(l);
	}
	
	double getMinY(double l, double r) {
		if (l < 0) {
			return countY(0);
		}
		for (int i = 0; i < 100; i++) {
			double x1 = countY(l + (r - l) / 3);
			double x2 = countY(l + 2 * (r - l) / 3);
			if (x1 > x2) {
				l += (r - l) / 3;
			} else {
				r -= (r - l) / 3;
			}
		}
		return countY(l);
	}
	
	double getMaxX(double l, double r) {
		if (l < 0) {
			return countX(0);
		}
		for (int i = 0; i < 100; i++) {
			double x1 = countX(l + (r - l) / 3);
			double x2 = countX(l + 2 * (r - l) / 3);
			if (x1 < x2) {
				l += (r - l) / 3;
			} else {
				r -= (r - l) / 3;
			}
		}
		return countX(l);
	}
	
	double getMinX(double l, double r) {
		if (l < 0) {
			return countX(0);
		}
		for (int i = 0; i < 100; i++) {
			double x1 = countX(l + (r - l) / 3);
			double x2 = countX(l + 2 * (r - l) / 3);
			if (x1 > x2) {
				l += (r - l) / 3;
			} else {
				r -= (r - l) / 3;
			}
		}
		return countX(l);
	}
	
	public void solve() throws IOException {
		w = Math.toRadians(nextInt());
		v = nextInt();
		r = nextInt();
		t = nextInt();
		double maxa = w * t;
		double maxa2 = (maxa + 1e-9) % (2 * Math.PI);
		double count = Math.floor((maxa + 1e-9) / (2 * Math.PI));
		double maxy = countY(maxa);
		maxy = Math.max(maxy, getMaxY(count * 2 * Math.PI, count * 2 * Math.PI + Math.min(Math.PI, maxa2)));
		maxy = Math.max(maxy, getMaxY((count - 1) * 2 * Math.PI, (count * 2 - 1) * Math.PI));
		double miny = countY(maxa);
		if (maxa2 > Math.PI + 1e-9) {
			miny = Math.min(miny, getMinY((count * 2 + 1) * Math.PI, (count * 2) * Math.PI + maxa2));
		}
		miny = Math.min(miny, getMinY((count - 1) * 2 * Math.PI, count * 2 * Math.PI ));
		double maxx = countX(maxa);
		maxx = Math.max(maxx, getMaxX(count * 2 * Math.PI, count * 2 * Math.PI + Math.min(Math.PI / 2, maxa2)));
		double minx = countX(maxa);
		if (maxa2 > Math.PI + 1e-9) {
			minx = Math.min(minx, getMinX((count * 2 + 1) * Math.PI, count * 2 * Math.PI + maxa2));
		}
		minx = Math.min(minx, getMinX((count * 2 - 1) * Math.PI, count * 2 * Math.PI - Math.PI / 2));
		out.println(minx + " " + miny);
		out.println(maxx + " " + maxy);
	}
}
