//  " "
//       
//   :  , ulyantsev@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

//      

uses
	math;
const
	maxv = 100;
	maxt = 1000;
	inf = 1000000000;
	eps1 = 1e-5;
	eps2 = 1e-9;
var
	v, r, t : longint;
	w : extended;
	fi, fi2, minx, miny, maxx, maxy : extended;

function relax(x : extended; y : extended) : boolean;
begin
	result := false;
	if (x >= maxx) then begin
		maxx := x;
		result := true;
	end;
	if (y >= maxy) then begin
		maxy := y;
		result := true;
	end;
	if (x <= minx) then begin
		minx := x;
		result := true;
	end;
	if (y <= miny) then begin
		miny := y;
		result := true;
	end;
end;

begin
	assign(input, 'spiral.in');
	reset(input);
	assign(output, 'spiral.out');
	rewrite(output);

	read(w, v, r, t);
	assert((1 <= w) and (w <= maxv), 'w is out of bounds');
	assert((1 <= v) and (v <= maxv), 'v is out of bounds');		
	assert((0 <= r) and (r <= maxv), 'r is out of bounds');
	assert((1 <= t) and (t <= maxt), 't is out of bounds');
	minx := inf;
	miny := inf;
	maxx := -inf;
	maxy := -inf;

	//  
	w := w * PI / 180;
	
	//    
	fi := w * t;
	while (fi >= max(w * t - 2 * PI, 0)) do begin
		relax((r + v * fi / w) * cos(fi), (r + v * fi / w) * sin(fi));
		fi := fi - eps1;
	end;
	
	fi := w * t;
	while (fi >= max(w * t - 2 * PI, 0)) do begin
		if (relax((r + v * fi / w) * cos(fi), (r + v * fi / w) * sin(fi))) then begin
			fi2 := min(fi + eps1, w * t);
			while (fi2 >= max(fi - eps1, 0)) do begin
				relax((r + v * fi2 / w) * cos(fi2), (r + v * fi2 / w) * sin(fi2));
				fi2 := fi2 - eps2;
			end;
		end;
		fi := fi - eps1;
	end;
	relax(r, 0);

	writeln(minx:0:10, ' ', miny:0:10);
	writeln(maxx:0:10, ' ', maxy:0:10);
end.
