//  " "
//       
//   :  , ulyantsev@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

//  ,    ,  
//    --- (w * t)

uses
	math;
const
	maxv = 100;
	maxt = 1000;
	inf = 1000000000;
var
	v, r, t : longint;
	w : extended;
	fi, minx, miny, maxx, maxy : extended;

procedure relax(x : extended; y : extended);
begin
	maxx := max(x, maxx);
	maxy := max(y, maxy);
	minx := min(minx, x);
	miny := min(miny, y);
end;

begin
	assign(input, 'spiral.in');
	reset(input);
	assign(output, 'spiral.out');
	rewrite(output);

	read(w, v, r, t);
	assert((1 <= w) and (w <= maxv), 'w is out of bounds');
	assert((1 <= v) and (v <= maxv), 'v is out of bounds');		
	assert((0 <= r) and (r <= maxv), 'r is out of bounds');
	assert((1 <= t) and (t <= maxt), 't is out of bounds');
	minx := inf;
	miny := inf;
	maxx := -inf;
	maxy := -inf;

	//  
	w := w * PI / 180;
	
	fi := 0;
	while (fi <= w * t) do begin
		relax((r + v * fi / w) * cos(fi), (r + v * fi / w) * sin(fi));
		fi := fi + PI / 2;
	end;

	//  
	relax((r + v * t) * cos(w * t), (r + v * t) * sin(w * t));

	writeln(minx:0:10, ' ', miny:0:10);
	writeln(maxx:0:10, ' ', maxy:0:10);
end.
