import java.util.*;
import java.io.*;
import java.math.*;

public class sum_sk2 implements Runnable
{
  int zeroes( BigInteger x )
  {
    System.out.print ("zeroes: ");

    String s = x.toString();

    int i = s.length() - 1, k = 0;
    while (i >= 0 && s.charAt(i) == '0')
      i--;

    System.out.println("ok");
    return s.length() - i - 1; 
  }

  BigInteger shift( BigInteger x, int t )
  {
    System.out.print ("shift: ");

    String s = x.toString();
    StringBuffer tail = new StringBuffer(t);
    while (t-- > 0)
      tail.append('0');

    System.out.println("ok");

    return new BigInteger(s + tail);
  }

  ArrayList<Integer> Solve( ArrayList<BigInteger> a )
  {
    int n = a.size(), t;
    ArrayList<Integer> ans = new ArrayList<Integer>();

    if (n == 1)
    {
      if (a.get(0).compareTo(BigInteger.ZERO) == 0)
        ans.add(0);
      return ans;
    }

    for (int i = 0; i < n; i++)
      for (int j = 0; j < i; j++)
      {
        ArrayList<BigInteger> b = new ArrayList<BigInteger>();
        
        int zi = zeroes(a.get(i));
        int zj = zeroes(a.get(j));
        int zm = Math.min(zi, zj);
        zi -= zm;
        zj -= zm;
        t = zi; zi = zj; zj = t;
        BigInteger ai = shift(a.get(i), zi);
        BigInteger aj = shift(a.get(j), zj);

        for (int k = 0; k < n; k++)
          if (k != i && k != j)
            b.add(a.get(k));
        b.add(ai.add(aj));

        ArrayList<Integer> tmp = Solve(b);
        if (tmp.size() > 0)
        {
          int pos = 0;
          for (int k = 0; k < n; k++)
            if (k != i && k != j)
              ans.add(tmp.get(pos++));
            else if (k == i)
              ans.add(tmp.get(n - 2) + zi);
            else 
              ans.add(tmp.get(n - 2) + zj);
          return ans;
        }
      }
    return ans;
  }

  public void run()
  {
    try {
      BufferedReader in = new BufferedReader(new FileReader("sum.in"));
      PrintWriter out = new PrintWriter("sum.out");
      
      ArrayList<BigInteger> a = new ArrayList<BigInteger>();
      for (int i = 0; i < 3; i++)
        a.add(new BigInteger(in.readLine()));
      a.set(2, a.get(2).negate());
      
      System.out.println("!");
      
      ArrayList<Integer> ans = Solve(a);
      if (ans.size() == 0)
        out.println("NO");
      else
      {
        out.println("YES");
        for (int i = 0; i < ans.size(); i++)
          out.print(ans.get(i) + " ");
      }
          
      out.flush();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  static public void main( String[] args )
  {
    (new Thread(new sum_sk2())).start();
  }
}
