#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>

using namespace std;

#define m 100100

int n, f[m], h[m], g[m], hp[m], fp1[m], fp2[m], gp1[m], gp2[m], gp3[m], gp4[m];
vector <int> c[m];

void dfs( int u, int p )
{
  int h1 = -1, h2 = -1, h3 = -1;
  int f1 = -1, f2 = -1;
  g[u] = 0, gp1[u] = gp2[u] = gp3[u] = gp4[u] = -1;
  for (int i = 0; i < (int)c[u].size(); i++)
  {
    int v = c[u][i];
    if (v == p)
      continue;
    dfs(v, u);
    if (h3 == -1 || h[h3] > h[v]) h3 = v;
    if (h2 == -1 || h[h2] > h[h3]) swap(h3, h2);
    if (h1 == -1 || h[h1] > h[h2]) swap(h2, h1);
    if (f2 == -1 || f[f2] > f[v]) f2 = v;
    if (f1 == -1 || f[f1] > f[f2]) swap(f2, f1);
    if (g[v] > g[u])
      g[u] = g[v], gp1[u] = gp1[v], gp2[u] = gp2[v], gp3[u] = gp3[v], gp4[u] = gp4[v];
  }
  if (h1 == -1) h[u] = 0, hp[u] = u;
  else          h[u] = 1 + h[h1], hp[u] = hp[h1];
  if (f1 == -1) f[u] = 0, fp1[u] = fp2[u] = -1;
  else          f[u] = f[f1], fp1[u] = fp1[f1], fp2[u] = fp2[f1];
  if (h2 != -1 && h[h1] + h[h2] + 2 > f[u])
    f[u] = h[h1] + h[h2] + 2, fp1[u] = hp[h1], fp2[u] = hp[h2];
  if (h1 != -1 && h[h1] + 1 > f[u])
    f[u] = h[h1] + 1, fp1[u] = hp[h1], fp2[u] = u;
  if (f[u] != 0 && f[u] + 1 > g[u])
    g[u] = f[u] + 1, gp1[u] = fp1[u], gp2[u] = fp2[u], gp3[u] = gp4[u] = -1;
  if (f2 != -1 && f[f2] > 0 && f[f1] + f[f2] > g[u])
    g[u] = f[f1] + f[f2] + 2, gp1[u] = fp1[f1], gp2[u] = fp2[f1], gp3[u] = fp1[f2], gp4[u] = fp2[f2];
  for (int i = 0; i < (int)c[u].size(); i++)
  {
    int v = c[u][i], t = f[v];
    if (v == p || t == 0)
      continue;
    int q = 0, pp[2];
    if (h1 != -1 && h1 != v)
      t += h[h1] + 1, pp[q++] = hp[h1];
    if (h2 != -1 && h2 != v)
      t += h[h2] + 1, pp[q++] = hp[h2];
    if (q < 2 && h3 != -1 && h3 != v)
      t += h[h3] + 1, pp[q++] = hp[h3];
    if (q != 0) t++;
    if (t > g[u])
    {
      g[u] = t, gp1[u] = fp1[v], gp2[u] = fp2[v];
      if (q == 1)      gp3[u] = u, gp4[u] = pp[0];
      else if (q == 2) gp3[u] = pp[0], gp4[u] = pp[1];
      else             gp3[u] = gp4[u] = -1;
    }
  }
  fprintf(stderr, "v=%d f=%d h=%d g=%d\n", u, f[u], h[u], g[u]);
}

int main()
{
  freopen("collider.in", "r", stdin);
  freopen("collider.out", "w", stdout);
  scanf("%d", &n);
  assert(3 <= n && n <= 100000);
  for (int i = 1; i < n; i++)
  {
    int a, b;
    scanf("%d%d", &a, &b), a--, b--;
    c[a].push_back(b);
    c[b].push_back(a);
  }
  dfs(0, -1);
  printf("%d\n", g[0]);
  gp1[0]++, gp2[0]++, gp3[0]++, gp4[0]++;
  if (gp1[0] != 0 && gp3[0] != 0)
    printf("%d %d\n%d %d\n", gp1[0], gp3[0], gp2[0], gp4[0]);
  else
  {
    if (gp1[0] != 0)
      printf("%d %d\n", gp1[0], gp2[0]);
    if (gp3[0] != 0)
      printf("%d %d\n", gp3[0], gp4[0]);
  }
  return 0;
}
