#include <iostream>
#include <fstream>
#include <cstdio>
#include <set>
#include <cstdlib>
#include <cstring>
using namespace std;

const int MAXN = 100000;

int prod[MAXN], need[MAXN], cost[MAXN];
int store[MAXN], cstore[MAXN];
int n;

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d%d%d", &prod[i], &cost[i], &need[i]);
	}
	for (i = 0; i < n - 1; i++)
	{
		scanf("%d%d", &store[i], &cstore[i]);
	}
}

const int MAXL = 100;
const long long BASE = 10000;

class LInt
{
public:
	long long a[MAXL];
	int l;
	void Norm()
	{
		int i = 0;
		while (i < l)
		{
			if (a[i] >= BASE)
			{
				a[i + 1] += a[i] / BASE;
				a[i] %= BASE;
				if (i == l - 1) l++;
			}
			i++;
		}
		while (a[l - 1] == 0 && l > 1) l--;
	}
	void operator+=(const LInt &a)
	{
		if (l < a.l) l = a.l;
		int i;
		for (i = 0; i < a.l; i++)
		{
			this->a[i] += a.a[i];
		}
		this->Norm();
	}
	LInt()
	{
		l = 1;
		memset(a, 0, sizeof(a));
	}
	LInt(long long a)
	{
		l = 1;
		memset(this->a, 0, sizeof(this->a));
		this->a[0] = a;
		Norm();
	}
	void AddMul(LInt &a, LInt &b)
	{
		if (l < a.l + b.l) l = a.l + b.l;
		int i, j;
		for (i = 0; i < a.l; i++)
		{
			for (j = 0; j < b.l; j++)
			{
				this->a[i + j] += a.a[i] * b.a[j];
			}
		}
		this->Norm();
	}
};

ostream& operator<<(ostream &out, const LInt &a)
{
	int i;
	out << a.a[a.l - 1];
	for (i = a.l - 2; i >= 0; i--)
	{
		long long k = 10;
		while (k < BASE)
		{
			if (a.a[i] < k) out << "0";
			k *= 10;
		}
		out << a.a[i];
	}
	return out;
}

LInt ans;

void Add2Ans(long long a, long long b)
{
	LInt tmp(a);
	LInt tmp2(b);
	ans.AddMul(tmp, tmp2);
}

void Solve()
{
	int i;
	multiset<pair<long long, long long> > have;
	long long havesz = 0;
	long long havedelta = 0;
	ans.l = 1;
	for (i = 0; i < n; i++)
	{
		have.insert(make_pair(cost[i] - havedelta, prod[i]));
		havesz += prod[i];
		long long cur = need[i];
		while (cur != 0)
		{
			if (have.size() == 0)
			{
				printf("-1");
				return;
			}
			pair<long long, long long> cval = *have.begin();
			have.erase(have.begin());
			if (cur >= cval.second)
			{
				havesz -= cval.second;
				Add2Ans(cval.first + havedelta, cval.second);
				cur -= cval.second;
			}
			else
			{
				havesz -= cur;
				Add2Ans(cval.first + havedelta, cur);
				cval.second -= cur;
				have.insert(cval);
				cur = 0;
			}
		}
		havedelta += cstore[i];
		while (havesz > store[i])
		{
			pair<long long, long long> cval = *(--have.end());
			have.erase(--have.end());
			long long needout = havesz - store[i];
			if (needout >= cval.second)
			{
				havesz -= cval.second;
				needout -= cval.second;
			}
			else
			{
				havesz -= needout;
				cval.second -= needout;
				have.insert(cval);
			}
		}
	}
	cout << ans << "\n";
}

int main()
{
//	freopen("bakery.in", "rt", stdin);
//	freopen("bakery.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
