#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)

const int MAXN = 100000;
const int MAXX = 1000000000;

typedef int tarint[MAXN + 1];

int n;
tarint c, f, d, e, g;

typedef pair<long long, long long> pll;

long long sum, acost;
multiset<pll> cur;

const long long base = 10000;
const int MAXD = 20;

struct thuge {
    long long a[MAXD];
    thuge() {
        memset(a, 0, sizeof a);
    }
    thuge(long long b) {
        memset(a, 0, sizeof a);
        a[0] = b;
        norm();
    }
    void norm() {
        for(int i = 0; i < MAXD - 1; ++i) {
            a[i + 1] += a[i] / base;
            a[i] %= base;
        }
    }
    void out() {
        int i = MAXD - 1;
        while (a[i] == 0 && i > 0) --i;
        cout << a[i];
        for(int j = i - 1; j >= 0; --j) {
            long long x = max(a[j], (long long)1);
            while (x * 10 < base) {
                cout << '0';
                x *= 10;
            }
            cout << a[j];
        }
        cout << endl;
    }
};

thuge operator + (const thuge& a, const thuge&b)
{
    thuge res;
    for(int i = 0; i < MAXD; ++i) res.a[i] = a.a[i] + b.a[i];
    res.norm();
    return res;
}

thuge operator + (const thuge& a, long long b)
{
    thuge res = a + thuge(b);
    return res;
}

thuge operator * (const thuge& a, const thuge&b)
{
    thuge res;
    for(int i = 0; i < MAXD; ++i) {
        for(int j = 0; j < MAXD; ++j) {
            if (i + j < MAXD) res.a[i + j] += a.a[i] * b.a[j];
        }
    }
    res.norm();
    return res;
}

thuge operator * (const thuge& a, long long b)
{
    thuge res = a * thuge(b);
    return res;
}

thuge ans;

void outdata() {
    ans.out();
}

void solve() {
    ans = thuge(0);
    sum = 0;
    acost = 0;
    forn(i, n) {
        cur.insert( make_pair(f[i] - acost, c[i]) );
        sum += c[i];
        long long need = d[i];
        while (need > 0) {
            if (cur.empty()) {
                ans = -1;
                return ;
            }
            pll cp = *cur.begin();
            cur.erase(cur.begin());
            if (cp.second > need) {
                ans = ans + thuge(need) * thuge(cp.first + acost);
                cp.second -= need;
                cur.insert(cp);
                need = 0;
            } else {
                ans = ans + thuge(cp.second) * thuge(cp.first + acost);
                need -= cp.second;
            }
        }
        sum -= d[i];
        while (sum > g[i]) {
            long long dl = sum - g[i];
            multiset<pll>::iterator it = cur.end();
            --it;
            pll cp = *it;
            cur.erase(it);
            if (cp.second > dl) {
                cp.second -= dl;
                sum -= dl;
                cur.insert(cp);
            } else {
                sum -= cp.second;
            }
        }
        acost += e[i];
    }
}

void readdata() {
    scanf("%d", &n);
    assert(1 <= n && n <= MAXN);
    forn(i, n) {
        scanf("%d%d%d", &c[i], &f[i], &d[i]);
        assert(0 <= c[i] && c[i] <= MAXX);
        assert(0 <= f[i] && f[i] <= MAXX);
        assert(0 <= d[i] && d[i] <= MAXX);
    }
    forn(i, n - 1) {
        scanf("%d%d", &g[i], &e[i]);
        assert(0 <= g[i] && g[i] <= MAXX);
        assert(0 <= e[i] && e[i] <= MAXX);
    }
    g[n] = e[n] = 0;
}

int main() {
	readdata();
	solve();
	outdata();
	return 0;
}
