#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forv(i, a) for (int i = 0; i < int(a.size()); i++)
#define fors(i, a) for (int i = 0; i < int(a.length()); i++)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

#define C_IN_FILE "bakery.in"
#define C_OUT_FILE "bakery.out"

const int MAXN = 100000;
const int MAXX = 1000000000;

typedef int tarint[MAXN];

int n;
tarint c, f, d, e, g;

typedef pair<long long, long long> pll;

long long sum, acost;
multiset<pll> cur;

long long ans;

void outdata() {
    cout << ans << endl;
}

void solve() {
    ans = 0;
    sum = 0;
    acost = 0;
    forn(i, n) {
        cur.insert( make_pair(f[i] - acost, c[i]) );
        sum += c[i];
        long long need = d[i];
        while (need > 0) {
            if (cur.empty()) {
                ans = -1;
                return ;
            }
            pll cp = *cur.begin();
            cur.erase(cur.begin());
            if (cp.second > need) {
                ans += need * (cp.first + acost);
                cp.second -= need;
                cur.insert(cp);
                need = 0;
            } else {
                ans += cp.second * (cp.first + acost);
                need -= cp.second;
            }
        }
        sum -= d[i];
        while (sum > g[i]) {
            long long dl = sum - g[i];
            multiset<pll>::iterator it = cur.end();
            --it;
            pll cp = *it;
            cur.erase(it);
            if (cp.second > dl) {
                cp.second -= dl;
                sum -= dl;
                cur.insert(cp);
            } else {
                sum -= cp.second;
            }
        }
        acost += e[i];
    }
}

void readdata() {
    scanf("%d", &n);
    assert(1 <= n && n <= MAXN);
    forn(i, n) {
        scanf("%d%d%d", &c[i], &f[i], &d[i]);
        assert(0 <= c[i] && c[i] <= MAXX);
        assert(0 <= f[i] && f[i] <= MAXX);
        assert(0 <= d[i] && d[i] <= MAXX);
    }
    forn(i, n - 1) {
        scanf("%d%d", &g[i], &e[i]);
        assert(0 <= g[i] && g[i] <= MAXX);
        assert(0 <= e[i] && e[i] <= MAXX);
    }
    g[n] = e[n] = 0;
}

int main() {
	readdata();
	solve();
	outdata();
	return 0;
}
