#define _CRT_SECURE_NO_WARNINGS

#include <vector>
#include <algorithm>
#include <set>
#include <cstdio>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)

const int MAXN = 200000;
const int MAXM = 200000;

int n, m;
multiset<int> e[MAXN + 2];
set<int> emps;
int ans;

void outdata() {
}

void move_from_to(multiset<int>& a, multiset<int>& b)
{
    if (a.size() > b.size()) {
        a.swap(b);
    }
    for(multiset<int>::iterator it = a.begin(); it != a.end(); ++it) {
        b.insert(*it);
    }
    a.clear();
}

int erase_less(multiset<int>& a, int b)
{
    int res = 0;
    multiset<int>::iterator end = a.lower_bound(b);
	for(multiset<int>::iterator it = a.begin(); it != end; ++it) {
        ++res;
    }
	a.erase(a.begin(), end);
    return res;
}


void solve() {
    forn(i, n + 1) {
        emps.insert(i);    
    }
    ans = 0;
    forn(i, n) {
        int x;
        scanf("%d", &x);
        assert(1 <= x && x <= n);
        --x;
        assert(emps.count(x));
        emps.erase(x);
        int y = *emps.lower_bound(x);
        move_from_to(e[x], e[y]);
        ans += erase_less(e[y], y);
        printf("%d\n", ans);
        //fflush(stdout);
    }
}

void readdata() {
    scanf("%d", &n);
    assert(1 <= n && n <= MAXN);
    scanf("%d", &m);
    assert(1 <= m && m <= MAXM);
    forn(i, m) {
        int l, r;
        scanf("%d%d", &l, &r);
        assert(1 <= l && l <= r && r <= n);
        e[l - 1].insert(r - 1);
    }
}

int main() {
	readdata();
	solve();
	outdata();
	return 0;
}
