#include <cstdio>
#include <cstdlib>
#include <cstring>

using namespace std;

const int MAXLEN = 1100000;
const int MAXK = 1100000;
const int N31 = 31;
char a[MAXLEN + 2];
int a_len;
int a_p31;
char b[MAXLEN + 2];
int b_len;
int b_p31;
int k;
char res[MAXK];
int inv[N31];

void Error(const char* message) {
  printf("%s\n", message);
  fclose(stdout);
  exit(1);
}

char ParseDigit(char digit) {
  if (digit >= '0' && digit <= '9')
    return digit - '0';
  else if (digit >= 'A' && digit < 'A' + N31 - 10)
    return digit - 'A' + 10;
  else
    Error("Strange digit");
}

char FormatDigit(char digit) {
  if (digit >= 0 && digit <= 9)
    return '0' + digit;
  else if (digit >= 10 && digit < N31)
    return 'A' + digit - 10;
  else
    Error("Strange digit to output");
}

void ReadNumber(char* where, int* len, int* p31) {
  if (!fgets(where, MAXLEN + 2, stdin))
    Error("Couldn't read");
  *len = strlen(where) - 1;
  where[*len] = 0;  // Delete the trailing newline.
  if (*len < 1 || *len > MAXLEN)
    Error("Wrong length");
  if (where[0]  == '0')
    Error("Leading zero");
  for (int i = 0; i < *len; ++i)
    where[i] = ParseDigit(where[i]);
  *p31 = 0;
  while (where[*len - 1] == 0) {
    --*len;
    ++*p31;
  }
  for (int i = 0; i < *len - 1 - i; ++i) {
    char t = where[i];
    where[i] = where[*len - 1 - i];
    where[*len - 1 - i] = t;
  }
}

int main() {
  for (int i = 1; i < N31; ++i)
    for (int j = 1; j < N31; ++j)
      if ((i * j) % N31 == 1)
        inv[i] = j;
  freopen("division.in", "r", stdin);
  freopen("division.out", "w", stdout);
  ReadNumber(a, &a_len, &a_p31);
  ReadNumber(b, &b_len, &b_p31);
  scanf("%d", &k);
  int r_p31 = a_p31 - b_p31;
  if (r_p31 < 0)
    Error("Too many zeros in divisor");
  k -= r_p31;
  if (k < 0) {
    r_p31 += k;
    k = 0;
  }
  for (int i = a_len; i < k; ++i)
    a[i] = 0;
  for (int i = b_len; i < k; ++i)
    b[i] = 0;
  int b_inv = inv[b[0]];
  for (int i = 0; i < k; ++i) {
    res[i] = (b_inv * a[i]) % N31;
    int carry = 0;
    for (int j = i; j < k; ++j) {
      carry = carry + a[j] - b[j - i] * (int) res[i];
      if (carry < 0) {
        int ncarry = (carry - N31 + 1) / N31;
	a[j] = carry - ncarry * N31;
	carry = ncarry;
      } else {
        a[j] = carry;
	carry = 0;
      }
    }
  }
  for (int i = k - 1; i >= 0; --i)
    printf("%c", FormatDigit(res[i]));
  for (int i = 0; i < r_p31; ++i)
    printf("0");
  printf("\n");
  fclose(stdout);
}
