#include <iostream>
#include <fstream>
using namespace std;

const int MAXN = 10000;
const int MAXM = 10000;

class Edge
{
public:
	int be, en;
};

Edge edg[MAXM];
int ne;
int first[MAXN];
int rfirst[MAXN];
int next[MAXM];
int rnext[MAXM];
int n, m;

void AddEdge(int v1, int v2)
{
	edg[ne].be = v1;
	edg[ne].en = v2;
	next[ne] = first[v1];
	first[v1] = ne;
	rnext[ne] = rfirst[v2];
	rfirst[v2] = ne;
	ne++;
}

void Load()
{
	memset(first, 0xFF, sizeof(first));
	memset(rfirst, 0xFF, sizeof(rfirst));
	scanf("%d%d", &n, &m);
	int i;
	for (i = 0; i < m; i++)
	{
		int p, q;
		scanf("%d%d", &p, &q);
		AddEdge(p, q);
	}
}

int was[MAXN + 1];
int q[MAXN];
int hd, tl;

void Bfs(int ver)
{
	hd = tl = 0;
	q[hd] = ver;
	was[ver] = 1;
	int i;
	while (hd <= tl)
	{
		int cv = q[hd];
		for (i = rfirst[cv]; i != -1; i = rnext[i])
		{
			if (was[edg[i].be] == 0)
			{
				tl++;
				q[tl] = edg[i].be;
				was[edg[i].be] = 1;
			}
		}
		hd++;
	}
}

void Bfs2(int ver)
{
	hd = tl = 0;
	q[hd] = ver;
	was[ver] = 2;
	int i;
	while (hd <= tl)
	{
		int cv = q[hd];
		for (i = first[cv]; i != -1; i = next[i])
		{
			if (was[edg[i].en] != 2)
			{
				tl++;
				q[tl] = edg[i].en;
				was[edg[i].en] = 2;
			}
		}
		hd++;
	}
}

void Solve()
{
	int i, j;
	int ans = 0;
	for (i = 1; i <= n; i++)
	{
		memset(was, 0, sizeof(was));
		Bfs(i);
		for (j = 1; j <= n; j++)
		{
			if (was[j] == 1) Bfs2(j);
		}
		for (j = 1; j <= n; j++) if (was[j] == 2) ans++;
	}
	printf("%d\n", ans);
}

int main()
{
	freopen("lca.in", "rt", stdin);
	freopen("lca.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}