#include <cstdio>
#include <cstring>
#include <cassert>

#ifdef _WIN32
#  define I64 "%I64d"
#else
#  define I64 "%Ld"
#endif

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef unsigned long long ll;

#define rest(a, i) ((a) & ((1 << (i)) - 1))

const int maxn = (int)1e7;
const int maxk = (int)24;
const int maxp = (int)1e9 + 7;

int N, K, P, Q;

int mpos = 0, mem[1 << (maxk + 1)];
int st, *num[maxk];
ll sum, ans[64];

int IsP( int p )
{
  if (p < 2)
    return 0;
  for (int i = 2; i * i <= p; i++)
    if (p % i == 0)
      return 0;
  return 1;
}

int main()
{
  scanf("%d%d%d%d", &N, &K, &P, &Q);

  assert(0 <= N && N <= maxn);
  assert(1 <= K && K <= maxk);
  assert(1 <= P && P <= maxp && IsP(P));
  assert(1 <= Q && Q <= maxp && IsP(Q));

  for (int i = K - 1; i >= 0; i--)
  {
    st = i;
    if (i == K - 1)
    {
      for (int x = st; x >= 0; x--)
        num[x] = mem + mpos, mpos += 1 << (st - x + 1);

      int a = 1;
      forn(j, N)
      {
        num[0][rest(a, st + 1)]++;
        a = a * P + Q;
      }

      for (int x = 1; x <= st; x++)
      {
        int len = st - x + 1;
        forn(j, 1 << (len + 1))
          num[x][j >> 1] += num[x - 1][j];
      }
    }
    else
      for (int x = 0; x <= st; x++)
      {
        int len = st - x + 1;
        forn(j, 1 << len)
          num[x][j] += num[x][j + (1 << len)];
      }

    if (i == K - 1)
    {
      sum = 0;
      forn(len, K)
      {
        int all = (1 << len) - 1, *a = num[K - len - 1] + 1, *b = num[K - len - 1] + all * 2 + 1;
        forn(t, 1 << len)
          sum += (ll)*a * *b, a += 2, b -= 2;
      }
      ans[K] = sum;
    }
    sum = 0;
    forn(x, 2)
      forn(y, 2)
      {
        int all = (1 << i) - 1;
        if (x ^ y)
        {
          int *a = num[0] + (x << i), *b = num[0] + (y << i) + all;
          forn(t, 1 << i)
            sum += (ll)*a * *b, a++, b--;
        }
        forn(len, i)
        {
          all = (1 << len) - 1;
          int s = x ^ y ^ 1, *a = num[i - len - 1] + (x << len) * 2 + s, *b = num[i - len - 1] + ((y << len) + all) * 2 + s;
          forn(t, 1 << len)
            sum += (ll)*a * *b, a += 2, b -= 2;
        }
      }
    ans[i] = sum;
  }
  for (int i = 0; i <= K; i++)
    printf(I64 " ", ans[i]);
  return 0;
}
