#include <iostream>
#include <fstream>
#include <cstdio>

using namespace std;

const int MAXL = 10000;

char s[MAXL];
int n;

void Load()
{
	char c = getchar();
	while (! ((c >= 'a') && (c <= 'z'))) c = getchar();
	n = 0;
	while ((c >= 'a') && (c <= 'z'))
	{
		s[n++] = c;
		c = getchar();
	}
}

int oddl[MAXL];
int oddr[MAXL];
int evenl[MAXL];
int evenr[MAXL];

bool EQ(int i, int j)
{
	if ((i < 0) || (j >= n)) return false;
	if (s[i] == '?' || s[j] == '?') return true;
	return s[i] == s[j];
}

void Grow()
{
	int i;
	for (i = 0; i < n; i++)
	{
		while (EQ(oddl[i] - 1, oddr[i] + 1))
		{
			oddl[i]--;
			oddr[i]++;
		}
	}
	for (i = 0; i < n - 1; i++)
	{
		while (EQ(evenl[i] - 1, evenr[i] + 1))
		{
			evenl[i]--;
			evenr[i]++;
		}
	}
}

long long Count()
{
	long long ans = 0;
	int i;
	for (i = 0; i < n; i++) ans += (oddr[i] - oddl[i] + 2) >> 1;
	for (i = 0; i < n - 1; i++) ans += (evenr[i] - evenl[i] + 1) >> 1;
	return ans;
}

void Solve()
{
	int i;
	for (i = 0; i < n; i++)
	{
		oddl[i] = oddr[i] = i;
	}
	for (i = 0; i < n - 1; i++)
	{
		evenl[i] = i + 1;
		evenr[i] = i;
	}
	Grow();
	printf("%lld\n", Count());
	fflush(stdout);
	for (i = 0; i < n; i++)
	{
		int k;
		scanf("%d", &k);
		s[k - 1] = '?';
		int j;
		for (j = 0; j < n; j++)
		{
			oddl[j] = oddr[j] = j;
		}
		for (j = 0; j < n - 1; j++)
		{
			evenl[j] = j + 1;
			evenr[j] = j;
		}
		Grow();
		printf("%lld\n", Count());
	    fflush(stdout);
	}
}

int main()
{
	Load();
	Solve();
	return 0;
}
