#include <iostream>
#include <fstream>
#include <map>
using namespace std;

const int MAXN = 100000;
const int MAXM = 500000;
const int MOD = 1000000007;
const long long INV2 = 500000004ll;

class Edge
{
public:
	int be, en;
};

int n, m, t;
Edge edg[2 * MAXM];
int first[MAXN + 1];
int next[2 * MAXM];
int ist[MAXN + 1];
int nume;

void AddEdge(int v1, int v2)
{
	edg[nume].be = v1;
	edg[nume].en = v2;
	next[nume] = first[v1];
	first[v1] = nume;
	nume++;
}

void Load()
{
	memset(first, 0xFF, sizeof(first));
	memset(ist, 0, sizeof(ist));
	scanf("%d%d%d", &n, &m, &t);
	int i;
	for (i = 0; i < t; i++)
	{
		int p;
		scanf("%d", &p);
		ist[p] = 1;
	}
	nume = 0;
	for (i = 0; i < m; i++)
	{
		int p, q;
		scanf("%d%d", &p, &q);
		AddEdge(p, q);
		AddEdge(q, p);
	}
}

int dst[MAXN + 1];
int zone[MAXN + 1];
int nzones[MAXN + 1];
int cver[MAXN + 1];
int nver[MAXN + 1];
int ncv, nnv;
int prev[MAXN + 1];
int nump[MAXN + 1];

void Solve()
{
	memset(dst, 0x7F, sizeof(dst));
	memset(zone, 0xFF, sizeof(zone));
	ncv = nnv = 0;
	int i, j;
	for (i = 1; i <= n; i++)
	{
		if (ist[i])
		{
			dst[i] = 0;
			zone[i] = i;
			cver[ncv++] = i;
			prev[i] = -1;
			nzones[i] = 1;
			nump[i] = 1;
		}
	}
	int optdist = -1;
	while (1)
	{
		nnv = 0;
		for (i = 0; i < ncv; i++)
		{
			for (j = first[cver[i]]; j != -1; j = next[j])
			{
				if (dst[edg[j].en] > dst[cver[i]] + 1)
				{
					dst[edg[j].en] = dst[cver[i]] + 1;
					nver[nnv++] = edg[j].en;
					prev[edg[j].en] = cver[i];
					zone[edg[j].en] = zone[cver[i]];
					nzones[edg[j].en] = 1;
					nump[edg[j].en] = nump[cver[i]];
				}
				else if (dst[edg[j].en] == dst[cver[i]] + 1)
				{
					if (zone[edg[j].en] == zone[cver[i]])
					{
						nump[edg[j].en] += nump[cver[i]];
						nump[edg[j].en] %= MOD;
					}
					else
					{
						optdist = dst[edg[j].en] + dst[cver[i]] + 1;
						break;
					}
				}
			}
			if (optdist != -1) break;
		}
		if (optdist != -1) break;
		if (nnv == 0)
		{
			optdist = 0x7F7F7F7F;
			break;
		}
		ncv = 0;
		for (i = 0; i < nnv; i++)
		{
			cver[ncv++] = nver[i];
		}
	}
	for (i = 0; i < nnv; i++)
	{
		dst[nver[i]] = 0x7F7F7F7F;
		nzones[nver[i]] = 0;
		zone[nver[i]] = -1;
		prev[nver[i]] = -1;
	}
	for (i = 0; i < nume; i++)
	{
		if (zone[edg[i].be] == -1 || zone[edg[i].en] == -1) continue;
		if (zone[edg[i].be] == zone[edg[i].en]) continue;
		if (dst[edg[i].be] + dst[edg[i].en] + 1 < optdist)
		{
			optdist = dst[edg[i].be] + dst[edg[i].en] + 1;
		}
	}
	int ans = 0;
	// first kind
	if (optdist % 2 == 0)
	{
		for (i = 1; i <= n; i++)
		{
			if (zone[i] == -1)
			{
				map<int, int> sump;
				for (j = first[i]; j != -1; j = next[j])
				{
					if (zone[edg[j].en] == -1) continue;
					if (dst[edg[j].en] != optdist / 2 - 1) continue;
					if (sump.find(zone[edg[j].en]) == sump.end()) sump[zone[edg[j].en]] = 0;
					sump[zone[edg[j].en]] += nump[edg[j].en];
					sump[zone[edg[j].en]] %= MOD;
				}
				long long csum = 0;
				map<int, int>::iterator p;
				for (p = sump.begin(); p != sump.end(); p++)
				{
					csum = csum + ((long long)p->second);
					csum %= MOD;
				}
				for (p = sump.begin(); p != sump.end(); p++)
				{
					ans += ((csum - p->second) * ((long long)p->second)) % MOD;
					ans %= MOD;
					if (ans < 0) 
						ans += MOD;
				}              
			}
		}
	}
	else // second kind
	{
		for (i = 0; i < nume; i++)
		{
			if ( (dst[edg[i].be] + dst[edg[i].en] + 1 == optdist) 
			     && (zone[edg[i].en] != zone[edg[i].be]))
			{
				ans += ((long long)nump[edg[i].be]) * ((long long)nump[edg[i].en]) % MOD;
				ans %= MOD;
			}
		}
	}
	ans = (ans * INV2) % MOD;
	cout << optdist << " " << ans << "\n";
}

int main()
{
//	freopen("tpath.in", "rt", stdin);
//	freopen("tpath.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
