#include <cmath>
#include <cassert>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back

typedef double dbl;
typedef long long ll;

#define maxn 103

struct edge
{
  int a, b;
  dbl w;
};

dbl ans, mw[maxn];
int K, n, root, en;
vector <int> c[maxn];
vector <dbl> w[maxn];
edge e[maxn];

int rest, size[maxn];

void go( int i, int k, dbl sum, dbl pr )
{
  if (i == en || k == 0)
  {
    pr *= rest;
    if (sum * pr > ans)
      ans = sum * pr;
    return;
  }

  int s = size[e[i].b];
  size[e[i].a] += s;
  go(i + 1, k, sum, pr);
  size[e[i].a] -= s;

  if (k > 0)
  {
    rest -= s;
    sum += e[i].w, pr *= s, i++, k--;
    if (k == 0 || ans / ((sum + mw[i] * k) * pr * pow((dbl)rest / (k + 1), k + 1)) < 1 - 1e-6)
      go(i, k, sum, pr);
    rest += s;
  }
}

void dfs( int v, int pa )
{
  int x;
  forn(i, c[v].size())
    if ((x = c[v][i]) != pa)
    {
      dfs(x, v);
      e[en].a = v;
      e[en].b = x;
      e[en++].w = w[v][i];
    }
}

int main()
{
  assert(scanf("%d%d", &n, &K) == 2);
  assert(1 <= n && n <= 100);
  assert(1 <= K && K <= n);
  K--;
  forn(i, n - 1)
  {
    int a, b;
    dbl _w;
    assert(scanf("%d%d%lf", &a, &b, &_w) == 3);
    assert(1 <= a && a <= n);
    assert(1 <= b && b <= n);
    assert(a != b);
    a--, b--;
    c[a].pb(b), w[a].pb(_w);
    c[b].pb(a), w[b].pb(_w);
  }
  en = 0;
  dfs(root = 0, -1);

  ans = 0;
  forn(i, n)
    size[i] = 1;
  rest = n;
  mw[en] = 0;
  for (int i = en - 1; i >= 0; i--)
    mw[i] = max(mw[i + 1], e[i].w);
  go(0, K, 0, 1);
  printf("%.20lf\n", ans);
  return 0;
}

