#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

#define TASKNAME "triangles"

using namespace std;

const int MinN = 1, MaxN = 14, MaxL = 1 << MaxN; // , MaxH = 1 << 20;
const char NA = 'Z';

int f [2] [MaxL];
int g [MaxN] [MaxN + 1] [MaxL];
char ans [MaxN] [MaxN];
// int h [2] [MaxH];
int n;

int main (void)
{
 int b, i, j, k, m, z;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &z) != EOF)
 {
  assert (MinN <= n && n <= MaxN);
  b = 0;
  memset (f[b], 0, sizeof (f[b]));
  m = 1 << n;
  f[b][0] = 1;
  for (i = n - 1; i >= 0; i--)
  {
   memmove (g[i][n], f[b], sizeof (g[i][n]));
   for (k = 0; k < m; k++)
    printf ("g[%d][%d][%d] = %d\n", i, n, k, g[i][n][k]);
   for (j = n - 1; j >= n - 1 - i; j--)
   {
    b ^= 1;
    memset (f[b], 0, sizeof (f[b]));
    for (k = 0; k < m; k++)
     if (k & (1 << j))
     {
      f[b][k] += f[!b][k ^ (1 << j)];
     }
     else
     {
      if (j - 1 >= 0 && !(k & (1 << (j - 1))))
       f[b][k] += f[!b][k ^ (3 << (j - 1))];
      if (j + 1 < n && !(k & (1 << (j + 1))))
       f[b][k] += f[!b][k ^ (3 << j)];
     }
    memmove (g[i][j], f[b], sizeof (g[i][j]));
    for (k = 0; k < m; k++)
     printf ("g[%d][%d][%d] = %d\n", i, j, k, g[i][j][k]);
   }
  }
  printf ("%d: %d\n", n, f[b][0]);

  memset (ans, NA, sizeof (ans));
  k = 0;
  for (i = 0; i < n; i++)
   for (j = n - i - 1; j < n; j++)
    if (!(k & (1 << j)))
    {
     printf ("%d %d: bit is zero\n", i, j);
     fflush (stdout);
     if (j - 1 >= 0 && !(k & (1 << (j - 1))))
     {
      printf ("trying %d %d %d -> %d %d %d: ",
       i, j, k, i, j + 1, k ^ (3 << (j - 1)));
      printf ("%d %d\n", z, g[i][j + 1][k ^ (3 << (j - 1))]);
      fflush (stdout);
      if (z >= g[i][j + 1][k ^ (3 << (j - 1))])
      {
       z -= g[i][j + 1][k ^ (3 << (j - 1))];
       printf ("set B subtracted\n");
       fflush (stdout);
       assert (j + 1 < n && !(k & (1 << (j + 1))));
       printf ("%d\n", g[i][j + 1][k ^ (3 << j)]);
       fflush (stdout);
       ans[i    ][j    ] = 'B';
       ans[i    ][j + 1] = 'B';
       ans[i + 1][j    ] = 'B';
       k ^= 3 << j;
      }
      else
      {
       printf ("set A\n");
       fflush (stdout);
       ans[i    ][j    ] = 'A';
       ans[i + 1][j - 1] = 'A';
       ans[i + 1][j    ] = 'A';
       k ^= 3 << (j - 1);
      }
     }
     else
     {
      printf ("set B\n");
      fflush (stdout);
      assert (j + 1 < n && !(k & (1 << (j + 1))));
      ans[i    ][j    ] = 'B';
      ans[i    ][j + 1] = 'B';
      ans[i + 1][j    ] = 'B';
      k ^= 3 << j;
     }
    }
    else
    {
     printf ("%d %d: bit is one\n", i, j);
     fflush (stdout);
     k ^= (1 << j);
    }
  assert (z == 0);
  assert (k == 0);

  for (i = 0; i < n; i++)
  {
   for (j = 0; j < n - i - 1; j++)
    putchar (' ');
   for (j = n - i - 1; j < n; j++)
   {
    assert (ans[i][j] != NA);
    putchar (ans[i][j]);
    if (j + 1 == n)
     putchar ('\n');
    else
     putchar (' ');
   }
  }
 }
 return 0;
}
