#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <utility>
#include <vector>

#define TASKNAME "triangles"

using namespace std;

const int MinN = 1, MaxN = 21, MaxL = 1 << MaxN;
const int Prime = 262139, MaxH = 1 << 17, AndH = MaxH - 1;
const char NA = 'Z';

int f [2] [MaxH];
int h [2] [MaxH];
vector <pair <int, int> > g [MaxN] [MaxN + 1];
char ans [MaxN] [MaxN];
int n;

inline void add (int * f, int * h, int index, int value)
{
 int cur;
 cur = (index * Prime) & AndH;
 while (h[cur] != -1)
  cur = (cur + 1) & AndH;
 h[cur] = index;
 f[cur] = value;
}

inline int get (int * f, int * h, int index)
{
 int cur;
 cur = (index * Prime) & AndH;
 while (h[cur] != -1 && h[cur] != index)
  cur = (cur + 1) & AndH;
 if (h[cur] != index)
  return 0;
 return f[cur];
}

int main (void)
{
 int b, i, j, k, m, t, z;
 vector <pair <int, int> >::iterator x;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &z) != EOF)
 {
  assert (MinN <= n && n <= MaxN);
  b = 0;
  memset (h[b], -1, sizeof (h[b]));
  m = 1 << n;
  add (f[b], h[b], 0, 1);
  f[b][0] = 1;
  for (i = n - 1; i >= 0; i--)
  {
   g[i][n].clear ();
   for (k = 0; k < MaxH; k++)
    if (h[b][k] != -1)
     g[i][n].push_back (make_pair (h[b][k], f[b][k]));
   sort (g[i][n].begin (), g[i][n].end ());
   for (j = n - 1; j >= n - 1 - i; j--)
   {
    b ^= 1;
    memset (h[b], -1, sizeof (h[b]));
    for (k = 0; k < m; k++)
    {
     t = 0;
     if (k & (1 << j))
     {
      t += get (f[!b], h[!b], k ^ (1 << j));
     }
     else
     {
      if (j - 1 >= 0 && !(k & (1 << (j - 1))))
       t += get (f[!b], h[!b], k ^ (3 << (j - 1)));
      if (j + 1 < n && !(k & (1 << (j + 1))))
       t += get (f[!b], h[!b], k ^ (3 << j));
     }
     if (t)
      add (f[b], h[b], k, t);
    }
    g[i][j].clear ();
    for (k = 0; k < MaxH; k++)
     if (h[b][k] != -1)
      g[i][j].push_back (make_pair (h[b][k], f[b][k]));
    sort (g[i][j].begin (), g[i][j].end ());
   }
  }

  memset (ans, NA, sizeof (ans));
  k = 0;
  for (i = 0; i < n; i++)
   for (j = n - i - 1; j < n; j++)
    if (!(k & (1 << j)))
    {
     if (j - 1 >= 0 && !(k & (1 << (j - 1))))
     {
      x = lower_bound (g[i][j + 1].begin (), g[i][j + 1].end (),
       make_pair (k ^ (3 << (j - 1)), -1));
/*
      printf ("k = %d, x is %d %d\n", k ^ (3 << (j - 1)),
       x == g[i][j + 1].end () ? -1 : x -> first,
       x == g[i][j + 1].end () ? -1 : x -> second);
      fflush (stdout);
*/
      if (x == g[i][j + 1].end () || x -> first != (k ^ (3 << (j - 1))))
       t = 0;
      else
       t = x -> second;
/*
      printf ("t = %d\n", t);
      fflush (stdout);
*/
      if (z >= t)
      {
       z -= t;
       assert (j + 1 < n && !(k & (1 << (j + 1))));
       ans[i    ][j    ] = 'B';
       ans[i    ][j + 1] = 'B';
       ans[i + 1][j    ] = 'B';
       k ^= 3 << j;
      }
      else
      {
       ans[i    ][j    ] = 'A';
       ans[i + 1][j - 1] = 'A';
       ans[i + 1][j    ] = 'A';
       k ^= 3 << (j - 1);
      }
     }
     else
     {
      assert (j + 1 < n && !(k & (1 << (j + 1))));
      ans[i    ][j    ] = 'B';
      ans[i    ][j + 1] = 'B';
      ans[i + 1][j    ] = 'B';
      k ^= 3 << j;
     }
    }
    else
    {
     k ^= (1 << j);
    }
  assert (z == 0);
  assert (k == 0);

  for (i = 0; i < n; i++)
  {
   for (j = 0; j < n - i - 1; j++)
    putchar (' ');
   for (j = n - i - 1; j < n; j++)
   {
    assert (ans[i][j] != NA);
    putchar (ans[i][j]);
    if (j + 1 == n)
     putchar ('\n');
    else
     putchar (' ');
   }
  }
 }
 return 0;
}
