#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <utility>
#include <vector>

#define TASKNAME "triangles"

using namespace std;

const int MinN = 1, MaxN = 21, MaxL = 1 << MaxN;
const int Prime = 262139, MaxH = 1 << 18, AndH = MaxH - 1;
const char NA = 'Z';

int f [2] [MaxH];
int h [2] [MaxH];
vector <pair <int, int> > g [MaxN] [MaxN + 1];
char ans [MaxN] [MaxN];
int n;
int count_add = 0;

inline void add (int * f, int * h, int index, int value)
{
 count_add++;
 int cur;
 cur = (index * Prime) & AndH;
 while (h[cur] != index && h[cur] != -1)
  cur = (cur + 1) & AndH;
 if (h[cur] == -1)
 {
  h[cur] = index;
  f[cur] = value;
 }
 else
  f[cur] += value;
}

void out (void)
{
 int i, j;
 for (i = 0; i < n; i++)
 {
  for (j = 0; j < n - i - 1; j++)
   putchar (' ');
  for (j = n - i - 1; j < n; j++)
  {
   putchar (ans[i][j]);
   if (j + 1 == n)
    putchar ('\n');
   else
    putchar (' ');
  }
 }
 fflush (stdout);
}

int main (void)
{
 int b, i, j, k, m, r, t, z;
 vector <pair <int, int> >::iterator x;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &z) != EOF)
 {
  assert (MinN <= n && n <= MaxN);
  b = 0;
  memset (h[b], -1, sizeof (h[b]));
  m = 1 << n;
  add (f[b], h[b], 0, 1);
  for (i = n - 1; i >= 0; i--)
  {
   g[i][n].clear ();
   for (k = 0; k < MaxH; k++)
    if (h[b][k] != -1)
    {
     g[i][n].push_back (make_pair (h[b][k], f[b][k]));
     printf ("%d %d: %d %d\n", i, n, h[b][k], f[b][k]);
     fflush (stdout);
    }
   for (j = n - 1; j >= n - 1 - i; j--)
   {
    b ^= 1;
    memset (h[b], -1, sizeof (h[b]));
    for (k = 0; k < MaxH; k++)
     if (h[!b][k] != -1)
     {
      r = h[!b][k];
      t = f[!b][k];
      if (!(r & (1 << j)))
      {
       add (f[b], h[b], r ^ (1 << j), t);
      }
      else
      {
       if (j - 1 >= 0 && (r & (1 << (j - 1))))
        printf ("A, %d %d %3d -> %d %d %3d, %d\n",
         i, j + 1, r, i, j, r ^ (3 << (j - 1)), t),
        add (f[b], h[b], r ^ (3 << (j - 1)), t);
       if (j + 1 < n && (r & (1 << (j + 1))))
        printf ("B, %d %d %3d -> %d %d %3d, %d\n",
         i, j + 1, r, i, j, r ^ (3 << j), t),
        add (f[b], h[b], r ^ (3 << j), t);
      }
     }
    g[i][j].clear ();
    for (k = 0; k < MaxH; k++)
     if (h[b][k] != -1)
     {
      g[i][j].push_back (make_pair (h[b][k], f[b][k]));
      printf ("%d %d: %d %d\n", i, j, h[b][k], f[b][k]);
      fflush (stdout);
     }
   }
  }

  memset (ans, NA, sizeof (ans));
  k = 0;
  for (i = 0; i < n; i++)
   for (j = n - i - 1; j < n; j++)
   {
    printf ("i = %d, j = %d, k = %d\n", i, j, k);
    out ();
    if (!(k & (1 << j)))
    {
     if (j - 1 >= 0 && !(k & (1 << (j - 1))))
     {
      for (x = g[i][j + 1].begin (); x != g[i][j + 1].end (); x++)
       if (x -> first == (k ^ (3 << (j - 1))))
        break;
      printf ("i = %d, j = %d, k = %d, x is %d %d\n",
       i, j, k ^ (3 << (j - 1)),
       (x == g[i][j + 1].end ()) ? -1 : x -> first,
       (x == g[i][j + 1].end ()) ? -1 : x -> second);
      fflush (stdout);
      if (x == g[i][j + 1].end ())
       t = 0;
      else
       t = x -> second;
      printf ("z = %d, t = %d\n", z, t);
      fflush (stdout);
      if (z >= t)
      {
       z -= t;
       assert (j + 1 < n && !(k & (1 << (j + 1))));
       ans[i    ][j    ] = 'B';
       ans[i    ][j + 1] = 'B';
       ans[i + 1][j    ] = 'B';
       k ^= 3 << j;
      }
      else
      {
       ans[i    ][j    ] = 'A';
       ans[i + 1][j - 1] = 'A';
       ans[i + 1][j    ] = 'A';
       k ^= 3 << (j - 1);
      }
     }
     else
     {
      assert (j + 1 < n && !(k & (1 << (j + 1))));
      ans[i    ][j    ] = 'B';
      ans[i    ][j + 1] = 'B';
      ans[i + 1][j    ] = 'B';
      k ^= 3 << j;
     }
    }
    else
    {
     k ^= (1 << j);
    }
   }
  assert (z == 0);
  assert (k == 0);

  for (i = 0; i < n; i++)
  {
   for (j = 0; j < n - i - 1; j++)
    putchar (' ');
   for (j = n - i - 1; j < n; j++)
   {
    assert (ans[i][j] != NA);
    putchar (ans[i][j]);
    if (j + 1 == n)
     putchar ('\n');
    else
     putchar (' ');
   }
  }
 }
 printf ("%d\n", count_add);
 return 0;
}
