#include <cassert>
#include <cstdio>

const int MAXN = 200;
const int MAXM = 2000;
const int MAXW = 100000;

int n, m;
int u[MAXM], v[MAXM], w[MAXM];
int p[MAXN];

int get(int x) {
	if (x != p[x]) p[x] = get(p[x]);
	return p[x];
}

int main() {
	scanf("%d%d", &n, &m);
	assert(n >= 1 && n <= MAXN);
	assert(m >= 1 && m <= MAXM);
	assert(n % 2 == 0);
	for (int i = 0; i < n; i++) {
		p[i] = i;
	}
	for (int i = 0; i < m; i++) {
		scanf("%d%d%d", &u[i], &v[i], &w[i]);
		u[i]--, v[i]--;
		assert(u[i] != v[i]);
		assert(0 <= u[i] && u[i] < n);
		assert(0 <= v[i] && v[i] < n);
		assert(w[i] >= 0 && w[i] <= MAXW);
		int z = get(u[i]);
		int x = get(v[i]);
		if (z == x) continue;
		p[z] = x;
	}
	for (int i = 0; i < n; i++) {
		assert(get(i) == get(0));
	}
	int best = 1e9, mask = -1;
	for (int i = 0; i < (1 << n); i++) {
		int cnt = 0;
		for (int j = 0; j < n; j++) {
			if ((i >> j) & 1) cnt++;
		}
		if (cnt % 2 == 0) continue;
		int cur = 0;
		for (int j = 0; j < m; j++) {
			if (((i >> u[j]) & 1) != (((i >> v[j]) & 1) & 1)) cur += w[j];
		}
		if (cur < best) {
			best = cur;
			mask = i;
		}
	}
	printf("%d\n", best);
	int cnt = 0;
	for (int j = 0; j < n; j++) {
		if ((mask >> j) & 1) cnt++;
	}
	printf("%d\n", cnt);
	for (int j = 0; j < n; j++) {
		if ((mask >> j) & 1) printf("%d ", j + 1);
	}
	printf("\n");
	return 0;
}
