#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#include "Network.h"

int n, m;

void solve(GomoryHu& gomoryHu) {
    OddCut oddCut;
    vector<int> S;
    int ans = oddCut.findCut(n, gomoryHu, S);
	printf("%d\n", ans);
	printf("%d\n", S.size());
	for(size_t i = 0; i < S.size(); ++i) {
        if (i > 0) printf(" ");
		printf("%d", 1 + S[i]);
	}
	printf("\n");
}

void readdata() {
	scanf("%d%d", &n, &m);
    assert(n % 2 == 0);
    assert(1 <= n && n <= 200);
    assert(1 <= m && m <= 2000);
	GomoryHu gomoryHu(n);
	for(int i = 0; i < m; ++i) {
		int x, y, c;
		scanf("%d%d%d", &x, &y, &c);
		assert(x != y);
    	assert(1 <= x && x <= n);
    	assert(1 <= y && y <= n);
        assert(1 <= c && c <= 100000);
        --x; --y;
		gomoryHu.addEdge(x, y, c);
	}
    solve(gomoryHu);
}

int main() {
	readdata();
	return 0;
}
