{$O+,S-,R-,Q-}
const
    NMAX = 3001;
type
    int = longint;
	mass = array [1..NMAX, 1..NMAX] of int;
var
	a: array [1..NMAX, 1..NMAX] of boolean;
	se_len_up, se_num_up, se_len_down, se_num_down: mass;
	ne_len_up, ne_num_up, ne_len_down, ne_num_down: mass;
	n, m, xans, yans, rans, ans, d: int;

function may(x, y, r: int): boolean;
begin
	if (x - r >= 1) and (x + r <= n) and (y - r >= 1) and (y + r <= m) and
		(ne_len_down[x, y - r] >= r + 1) and (se_len_up[x, y - r] >= r + 1) and
		(se_len_down[x - r, y] >= r + 1) and (ne_len_up[x + r, y] >= r + 1) then
			may := true
		else may := false;
end;

function point(x, y: int): int;
begin
	if a[x, y] then point := 1
		else point := 0;
end;

function fun_e(x, y, r: int): int;
var
	up, down: int;
begin
	up := ne_num_down[x, y] - ne_num_down[x - r + 1, y + r - 1] + point(x - r + 1, y + r - 1);
	down := se_num_up[x, y] - se_num_up[x + r - 1, y + r - 1] + point(x + r - 1, y + r - 1);
	fun_e := up + down - point(x, y);
end;

function fun_w(x, y, r: int): int;
var
	up, down: int;
begin
	up := se_num_down[x - r + 1, y - r + 1] - se_num_down[x, y];
	down := ne_num_up[x + r - 1, y - r + 1] - ne_num_up[x, y];
	fun_w := up + down + point(x, y);
end;

function f(x1, y1, x2, y2: int): boolean;
begin
	if a[x1, y1] and a[x2, y2] then f := false
		else f := true;
end;

function good(x, y: int): boolean;
begin
	if (1 <= x) and (x <= n) and (1 <= y) and (y <= m) then good := true
		else good := false;
end;

procedure find(x: int);
var
	i, y, r, now: int;

begin
	y := 1;
	r := 0;
	now := point(x, y);
	if now > ans then begin
		ans := now;
		xans := x;
		yans := y;
		rans := r;
	end;

	for i := 2 to m do begin
		if r > 0 then begin
			dec(now, fun_e(x, y - r, r + 1) + fun_e(x, y - r + 1, r));
			dec(r);
		end
		else inc(now, point(x, i) - point(x, y));
		inc(y);
		
		while may(x, y, r + 1) do begin
			inc(r);
			inc(now, fun_e(x, y - r, r + 1) + fun_w(x, y + r, r + 1) - point(x - r, y) - point(x + r, y));
		end;
		
		if now > ans then begin
			ans := now;
			xans := x;
			yans := y;
			rans := r;
		end;
	end;
end;

procedure calc_se(var se_len, se_num: mass; x, y, dx, dy: int);
var
	i, num, now: int;

begin
	if (x > n) or (y > m) then exit;
	now := 1;
	num := 0;
	if a[x, y] then inc(num);
	for i := 1 to d do
		if good(x + i, y + i) and f(x + i - 1, y + i - 1, x + i - 1 + dx, y + i - 1 + dy) and f(x + i, y + i, x + i - 1 + dx, y + i - 1 + dy) then begin
			inc(now);
			if a[x + i, y + i] then inc(num);
		end
		else break;
	
	while now > 0 do begin
		se_len[x, y] := now;
		se_num[x, y] := num;
		inc(x);
		inc(y);
		dec(now);
		if a[x - 1, y - 1] then dec(num);
	end;
	calc_se(se_len, se_num, x, y, dx, dy);
end;

procedure calc_ne(var ne_len, ne_num: mass; x, y, dx, dy: int);
var
	i, num, now: int;

begin
	if (x < 1) or (y > m) then exit;
	now := 1;
	num := 0;
	if a[x, y] then inc(num);
	for i := 1 to d do
		if good(x - i, y + i) and f(x - i + 1, y + i - 1, x - i + 1 - dx, y + i - 1 + dy) and f(x - i, y + i, x - i + 1 - dx, y + i - 1 + dy) then begin
			inc(now);
			if a[x - i, y + i] then inc(num);
		end
		else break;
	
	while now > 0 do begin
		ne_len[x, y] := now;
		ne_num[x, y] := num;
		dec(x);
		inc(y);
		dec(now);
		if a[x + 1, y - 1] then dec(num);
	end;
	calc_ne(ne_len, ne_num, x, y, dx, dy);
end;

var
	i, j: int;
	ch: char;

begin
	readln(n, m);
	d := n;
	if d < m then d := m;
	fillchar(a, sizeof(a), 0);
	for i := 1 to n do begin
		for j := 1 to m do begin
			read(ch);
			if ch = '*' then a[i, j] := true;
		end;
		readln;
	end;

	for i := 1 to n do begin
		calc_se(se_len_down, se_num_down, i, 1, 1, 0);
		calc_se(se_len_up, se_num_up, i, 1, 0, 1);
	end;
	for i := 2 to m do begin
		calc_se(se_len_down, se_num_down, 1, i, 1, 0);
		calc_se(se_len_up, se_num_up, 1, i, 0, 1);
	end;
	for i := 1 to n do begin
		calc_ne(ne_len_down, ne_num_down, i, 1, 0, 1);
		calc_ne(ne_len_up, ne_num_up, i, 1, 1, 0);
	end;
	for i := 2 to m do begin
		calc_ne(ne_len_down, ne_num_down, n, i, 0, 1);
		calc_ne(ne_len_up, ne_num_up, n, i, 1, 0);
	end;

	xans := 0;
	yans := 0;
	rans := 0;
	ans := -1;
	for i := 1 to n do
		find(i);

	writeln(ans, ' ', yans, ' ', xans, ' ', rans);
end.