#include <iostream>
#include <fstream>
#include <cstdio>
#include <cassert>

using namespace std;

const int MAXL = 10000;

char s[MAXL + 1];
int l;

void Load()
{
	char c = getchar();
	while (! ((c >= 'a') && (c <= 'z'))) c = getchar();
	l = 0;
	while ((c >= 'a') && (c <= 'z'))
	{
		s[l++] = c;
		c = getchar();
	}
	s[l] = 0;
	assert(1 <= l && l <= MAXL);
}

const int HX = 39;
int h[MAXL + 2];
int xpow[MAXL + 1];
short res[MAXL + 1][MAXL + 1];

void Solve()
{
	int i, j, h1, h2;
	xpow[0] = 1;
	for (i = 1; i <= MAXL; i++) xpow[i] = xpow[i - 1] * HX;
	h[l] = 0;
	for (i = l - 1; i >= 0; i--) h[i] = h[i + 1] * HX + s[i] - 'a';
	for (i = 0; i <= l; i++) res[l][i] = 0;
	//cerr << "l = " << l << "\n";
	for (i = l - 1; i >= 0; i--)
	{	
		int ni = i;
		for (j = 1; j <= l; j++)
		{
			res[i][j] = 0;
			if (i + j > l) continue;
			res[i][j] = 1;
			if (ni < i + j) ni = i + j;
			if (ni + j > l) res[i][j] = 1;
			else
			{
				h1 = h[i] - h[i + j] * xpow[j];
				h2 = h[ni] - h[ni + j] * xpow[j];
				while (ni + j <= l && h1 != h2)
				{
					ni++;
					h2 = h[ni] - h[ni + j] * xpow[j];
				}
				//cerr << "i = " << i << " j = " << j << " ni = " << ni << "\n";
				//cerr << h1 << " " << h2 << "\n";
				if (ni + j <= l)
				{
					if (res[ni][j] + 1 > res[i][j]) res[i][j] = res[ni][j] + 1;
				}
			}
		}
	}
	/*cerr << "result:\n";
	for (i = 0; i < l; i++)
	{
		cerr << "pos = " << i << ": ";
		for (j = 1; j <= l; j++)
		{
			cerr << res[i][j] << " ";
		}
		cerr << "\n";
	}*/
	int mres, mi, mj;
	mres = l + 1;
	mi = 0;
	mj = l;
	for (i = 0; i < l; i++)
	{
		for (j = 1; j <= l; j++)
		{	
			if (res[i][j] == 0) continue;
			int cr = l - j * res[i][j] + res[i][j] + j;
			if (cr < mres)
			{
				mres = cr;
				mi = i;
				mj = j;
			}
		}
	}
	if (mres > l)
	{
		printf("\n%s\n", s);
		return;
	}
	for (i = mi; i < mi + mj; i++) printf("%c", s[i]);
	printf("\n");
	//cerr << "mi = " << mi << " mj = " << mj << " mres = " << mres << "\n";
	h1 = h[mi] - h[mi + mj] * xpow[mj];
	for (i = 0; i < l; )
	{
		h2 = h[i] - h[i + mj] * xpow[mj];
		if (h1 == h2 && i + mj <= l)
		{
			printf("A");
			i += mj;
		}
		else
		{
			printf("%c", s[i]);
			i++;
		}
	}
	printf("\n");
}

int main()
{
//	freopen("string.in", "rt", stdin);
	Load();
	Solve();
	return 0;
}
