#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

typedef long long int64;
#ifdef WIN32
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

using namespace std;

const int MinN = 1, MaxN = 10000;
const int Prime = 262139, MaxHash = 1 << 15, AndHash = MaxHash - 1, NA = -1;

char s [MaxN + 2];
char a [MaxN + 2];
int64 c [MaxN];
int v [MaxN];
bool b [MaxHash];
int h [MaxHash];
int n;

int main (void)
{
 int i, l, res;
 while (scanf (" %10001s", s) != EOF)
 {
  n = strlen (s);
  assert (MinN <= n && n <= MaxN);
  for (i = 0; i < n; i++)
   assert ('a' <= s[i] && s[i] <= 'z');
  memset (h, NA, sizeof (h));
  memset (b, 0, sizeof (b));
  res = n;
  a[0] = '\0';

  for (l = 1; l + l < n; l++)
  {
   for (i = 0; i < n; i++)
    printf (INT64 "%c", c[i], i + 1 < n ? ' ' : '\n');
   if (l == 1)
    memset (c, 0, sizeof (c));
   else
    for (i = n - 1; i >= l - 1; i--)
     c[i] = c[i - 1];
   for (i = 0; i < n; i++)
    printf (INT64 "%c", c[i], i + 1 < n ? ' ' : '\n');

   for (i = l - 1; i < n; i++)
   {
    c[i] = c[i] * Prime + s[i];
    int cur = c[i] & AndHash;
    printf ("l = %d, i = %d: start = %d, letter = %c\n", l, i, cur, s[i]);
    while (h[cur] != NA)
     cur = (cur + 1) & AndHash;
    v[i] = cur;
    h[cur] = i;
   }

   printf ("Contents of the hash table:\n");
   for (i = l - 1; i < n; i++)
    printf ("%5d %5d " INT64 "\n", i, v[i], c[i]);

   for (i = l - 1; i < n; i++)
   {
    int cur = v[i], temp = 0, pos = i + l;
    temp = 1;
    printf ("l = %d, i = %d: cur = %d, pos = %d\n", l, i, cur, pos);
    printf ("check b[%d] = %s\n", cur, b[cur] ? "true" : "false");
    if (b[cur])
     continue;
    b[cur] = true;
    cur = (cur + 1) & AndHash;
    while (h[cur] != NA)
    {
     printf ("cur = %d, h[cur] = %d, pos = %d\n", cur, h[cur], pos);
     if (c[h[cur]] == c[i])
     {
      printf ("b[%d] = true\n", cur);
      b[cur] = true;
      if (h[cur] >= pos)
      {
       temp++;
       pos = h[cur] + l;
      }
     }
     cur = (cur + 1) & AndHash;
    }

    printf ("l = %d, i = %d: %d %d\n", l, i, temp, n + l - temp * (l - 1));
    temp = n + l - temp * (l - 1);
    if (res > temp)
    {
     res = temp;
     strncpy (a, s + i - l + 1, l);
     a[l] = '\0';
     printf ("%d: %s\n", res, a);
    }
   }

   for (i = l - 1; i < n; i++)
   {
    b[v[i]] = false;
    h[v[i]] = NA;
   }
  }

  printf ("%s\n", a);
  l = strlen (a);
  for (i = 0; i < n; i++)
   if (a[0] != '\0' && strstr (s + i, a) == s + i)
   {
    putchar ('A');
    i += l - 1;
   }
   else
    putchar (s[i]);
  putchar ('\n');
 }
 return 0;
}
