#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

typedef long long int64;
#ifdef WIN32
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

using namespace std;

const int MinN = 1, MaxN = 10000;
const int Prime = 262139, MaxHash = 1 << 15, AndHash = MaxHash - 1, NA = -1;

char s [MaxN + 2];
char a [MaxN + 2];
int64 c [MaxN];
int v [MaxN];
bool b [MaxHash];
int h [MaxHash];
int n;

int main (void)
{
 int i, l, res;
 while (scanf (" %10001s", s) != EOF)
 {
  n = strlen (s);
  assert (MinN <= n && n <= MaxN);
  for (i = 0; i < n; i++)
   assert ('a' <= s[i] && s[i] <= 'z');
  memset (h, NA, sizeof (h));
  memset (b, 0, sizeof (b));
  res = n;
  a[0] = '\0';

  for (l = 1; l + l < n; l++)
  {
   if (l == 1)
    memset (c, 0, sizeof (c));
   else
    memmove (c + (l - 1), c + (l - 2), sizeof (c[0]) * (n - l + 1));

   for (i = l - 1; i < n; i++)
   {
    c[i] = c[i] * Prime + s[i];
    int cur = c[i] & AndHash;
    while (h[cur] != NA)
     cur = (cur + 1) & AndHash;
    v[i] = cur;
    h[cur] = i;
   }

   for (i = l - 1; i < n; i++)
   {
    int cur = v[i], temp = 0, pos = i + l;
    temp = 1;
    if (b[cur])
     continue;
    b[cur] = true;
    cur = (cur + 1) & AndHash;
    while (h[cur] != NA)
    {
     if (c[h[cur]] == c[i])
     {
      b[cur] = true;
      if (h[cur] >= pos)
      {
       temp++;
       pos = h[cur] + l;
      }
     }
     cur = (cur + 1) & AndHash;
    }

    temp = n + l - temp * (l - 1);
    if (res > temp)
    {
     res = temp;
     strncpy (a, s + i - l + 1, l);
     a[l] = '\0';
    }
   }

   for (i = l - 1; i < n; i++)
   {
    b[v[i]] = false;
    h[v[i]] = NA;
   }
  }

  printf ("%s\n", a);
  l = strlen (a);
  for (i = 0; i < n; i++)
   if (a[0] != '\0' && strstr (s + i, a) == s + i)
   {
    putchar ('A');
    i += l - 1;
   }
   else
    putchar (s[i]);
  putchar ('\n');
 }
 return 0;
}
