#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

using namespace std;

typedef double real;

const int MinN = 1, MaxN = 10000;
const int Prime = 41, MaxHash = 1 << 15, AndHash = MaxHash - 1, NA = -1;
const real Mult = 0.999;

char s [MaxN + 2];
char a [MaxN + 2];
real c [MaxN];
int v [MaxN];
real h [MaxHash];
int p [MaxHash];
int r [MaxHash];
int n;

int main (void)
{
 int i, j, k, l, res, temp;
 while (scanf (" %10001s", s) != EOF)
 {
  n = strlen (s);
  assert (MinN <= n && n <= MaxN);
  for (i = 0; i < n; i++)
   assert ('a' <= s[i] && s[i] <= 'z');
  for (i = 0; i < n; i++)
   s[i] -= 'a';
  for (i = 0; i < MaxHash; i++)
   h[i] = NA;
  res = n;
  a[0] = '\0';

  memset ((void *) c, 0, sizeof (c));
  memset (v, 0, sizeof (v));
  for (l = 1; l + l < n; l++)
  {
   temp = 0;
   j = NA;
   for (i = 0; i <= n - l; i++)
   {
    volatile real & cd = c[i];
    cd = cd * Mult + s[i + l - 1];
//    printf ("%lf %08X%08X\n", c[i], 0, 0);
//    (* ((int *) (c + i) + 1)) &= 0x000FFFFF;
    int & cur = v[i];
    cur = (cur * Prime + s[i + l - 1]) & AndHash;
    while (h[cur] != cd && h[cur] != NA)
     cur = (cur + 1) & AndHash;
    if (h[cur] == NA)
    {
     h[cur] = cd;
     p[cur] = i + l;
     r[cur] = 1;
    }
    else if (p[cur] <= i)
    {
     p[cur] = i + l;
     r[cur]++;
    }
    if (temp < r[cur])
    {
     temp = r[cur];
     j = i;
    }
   }

   temp = n + l - temp * (l - 1);
   if (res > temp)
   {
    res = temp;
    for (k = 0; k < l; k++)
     a[k] = s[j + k] + 'a';
    a[l] = '\0';
   }

   for (i = 0; i <= n - l; i++)
    h[v[i]] = NA;
  }

  for (i = 0; i < n; i++)
   s[i] += 'a';
  printf ("%s\n", a);
  l = strlen (a);
  for (i = 0; i < n; i++)
   if (a[0] != '\0' && strstr (s + i, a) == s + i)
   {
    putchar ('A');
    i += l - 1;
   }
   else
    putchar (s[i]);
  putchar ('\n');
 }
 return 0;
}
