#include <cassert>
#include <cctype>
#include <cstdio>
#include <cstring>
#include <iostream>

const int MAXN = 5;
const int MAXM = 100000;
const int MAXK = 10000;

int n;
char regexp[MAXN + 10];
char str[MAXM + MAXK + 10];
bool dp[MAXM + MAXK + 10][MAXN + 10];

bool solve(int u, int v) {
	/*
	for (int i = u; i <= v; i++) {
		printf("%c", str[i]);
	}
	printf("\n");
	*/
	for (int i = 0; i <= v - u + 1; i++) {
		for (int j = 0; j <= n; j++) {
			dp[i][j] = false;
		}
	}
	dp[0][0] = true;
	for (int i = 0; i <= v - u + 1; i++) {
		for (int j = 0; j <= n; j++) {
			if (i && j && (regexp[j - 1] == '?' || str[u + i - 1] == regexp[j - 1]))
				dp[i][j] |= dp[i - 1][j - 1];
			if (i && j && regexp[j - 1] == '*')
				dp[i][j] |= dp[i - 1][j];
			if (j && regexp[j - 1] == '*') dp[i][j] |= dp[i][j - 1];
		}
	}
	return dp[v - u + 1][n];
}

int main() {
	gets(regexp);
	n = strlen(regexp);
	assert(n >= 1 && n <= MAXN);
	for (int i = 0; i < n; i++) {
		assert(islower(regexp[i]) || regexp[i] == '*' || regexp[i] == '?');
	}
	gets(str);
	int m = strlen(str);
	assert(m >= 1 && m <= MAXM);
	int k;
	scanf("%d\n", &k);
	assert(k >= 1 && k <= MAXK);
	char cmd[100];
	for (int i = 0; i < k; i++) {
		scanf("%s", cmd);
		assert(strlen(cmd) == 1);
		int u;
		if (cmd[0] == '+') {
			scanf("%s", cmd);
			assert(strlen(cmd) == 1);
			char symb = cmd[0];
			assert(islower(symb));
			scanf("%d", &u);
			assert(u >= 0 && u <= m);
			for (int j = m - 1; j >= u; j--) {
				str[j + 1] = str[j];
			}
			str[u] = symb;
			m++;
		}
		else {
			assert(cmd[0] == '-');
			scanf("%d", &u);
			assert(u >= 1 && u <= m);
			for (int j = u; j < m; j++) {
				str[j - 1] = str[j];
			}
			m--;
		}
		/*
		for (int j = 0; j < m; j++) {
			printf("%c", str[j]);
		}
		printf("\n");
		*/
		long long ans = 0;
		for (int j = 0; j < m; j++) {
			for (int u = j; u < m; u++) {
				if (solve(j, u)) {
//					printf("%d %d\n", j, u);
					ans++;
				}
			}
		}
		std::cout << ans << std::endl;
	}
	return 0;
}
