#include <iostream>
#include <fstream>
#include <cstring>
#include <cassert>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

const int MAXN = 100000;
const int MAXK = 1000;
const int MAXC = 1000000000;

class Seg
{
public:
	int l, r;
	int id;
};

bool operator<(const Seg &a, const Seg &b)
{
	return (a.r - a.l) < (b.r - b.l);
}

int n, m, k;
Seg sg[MAXN];
vector<int> crd;
	
void Load()
{
	scanf("%d%d%d", &n, &m, &k);
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d%d", &sg[i].l, &sg[i].r);
		sg[i].id = i;
	}
	map<int, int> remap;
	for (i = 0; i < n; i++)
	{
		crd.push_back(sg[i].l);
		crd.push_back(sg[i].r);
	}
	sort(crd.begin(), crd.end());
	crd.erase(unique(crd.begin(), crd.end()), crd.end());
	for (i = 0; i < crd.size(); i++) remap[crd[i]] = i;
	for (i = 0; i < n; i++)
	{
		sg[i].l = remap[sg[i].l];
		sg[i].r = remap[sg[i].r];
	}
	sort(sg, sg + n);
/*	cerr << "We have segments:\n";
	for (i = 0; i < n; i++)
	{
		cerr << sg[i].l << " " << sg[i].r << " " << sg[i].id << "\n";
	}
	cerr << "remapping coordinates:\n";
	for (i = 0; i < crd.size(); i++) cerr << crd[i] << " ";
	cerr << "\n";*/
}

class Event
{
public:
	int t, tp, id;
};

bool operator<(const Event &a, const Event &b)
{
	if (a.t < b.t) return true;
	if (a.t > b.t) return false;
	return a.tp < b.tp;
}

int ttime[MAXK];
int train[MAXN];
int num[2 * MAXN];
int was[MAXN];

Event evt[2 * MAXN];
int nevt;

int SelectTime()
{
//	cerr << "Time selecting:\n";
	int i;
	int num = 0;
	int mtime = 0;
	int mnum = 0;
	for (i = 0; i < nevt; i++)
	{
//		cerr << "Event: i = " << i << " time = " << evt[i].t << " type = " << evt[i].tp << " id = " << evt[i].id << "\n";
//		cerr << "was: " << was[evt[i].id] << "\n";
		if (was[evt[i].id]) continue;
		if (evt[i].tp == -1) num++;
		else num--;
//		cerr << "new num =  " << num << "\n";
		if (num > mnum)
		{
//			cerr << "new num is better, choosing time " << evt[i].t << "\n";
			mnum = num;
			mtime = evt[i].t;
		}
	}
	return mtime;
}

void Solve()
{
	memset(was, 0, sizeof(was));
	memset(train, 0xFF, sizeof(train));
	int i, j;
	/*cerr << "Segments after sorting:\n";
	for (i = 0; i < n; i++)
	{
		cerr << sg[i].l << " " << sg[i].r << " " << sg[i].id << "\n";
	}*/
	nevt = 0;
	for (i = 0; i < n; i++)
	{
		evt[nevt].t = sg[i].l;
		evt[nevt].tp = -1; // open
		evt[nevt].id = sg[i].id;
		nevt++;
		evt[nevt].t = sg[i].r;
		evt[nevt].tp = 1; // close
		evt[nevt].id = sg[i].id;
		nevt++;
	}
	sort(evt, evt + nevt);
	for (i = 0; i < k; i++)
	{
		int t = SelectTime();
//		cerr << "i = " << i << " t = " << t << "\n";
		ttime[i] = crd[t];
		int num = 0;
		for (j = 0; j < n; j++)
		{	
			if (was[sg[j].id] == 1) continue;
			if (sg[j].l <= t && t <= sg[j].r)
			{
//				cerr << "Taking segment " << j << " with l = " << sg[j].l << " r = " << sg[j].r << " id = " << sg[j].id << "\n";
				num++;
				was[sg[j].id] = 1;
				train[sg[j].id] = i;
				if (num == m) break;
			}
		}
//		cerr << "i = " << i << " marked segments: ";
//		for (j = 0; j < n; j++) cerr << was[j];
//		cerr << "\n";
	}
	int ans = 0;
	for (i = 0; i < n; i++) if (train[i] != -1) ans++;
	printf("%d\n", ans);
	for (i = 0; i < k; i++) printf("%d ", ttime[i]);
	printf("\n");
	for (i = 0; i < n; i++) printf("%d ", train[i] + 1);
	printf("\n");
}

int main()
{
//	freopen("trains.in", "rt", stdin);
//	freopen("trains.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
