#include <iostream>
#include <fstream>
#include <cstring>
#include <cassert>

using namespace std;

const int MAXN = 100000;
const int MAXK = 1000;
const int MAXC = 1000000000;

class Seg
{
public:
	int l, r;
	int id;
};

int n, m, k;
Seg sg[MAXN];

bool operator<(const Seg &a, const Seg &b)
{
	return a.r < b.r;
}

void Load()
{
	scanf("%d%d%d", &n, &m, &k);
	assert(1 <= n && n <= MAXN);
	assert(1 <= m && m <= n);
	assert(1 <= k && k <= min(n, MAXK));
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d%d", &sg[i].l, &sg[i].r);
		assert(-MAXC <= sg[i].l && sg[i].l <= sg[i].r && sg[i].r <= MAXC);
		sg[i].id = i;
	}
	sort(sg, sg + n);
}

int nxt[MAXN];
char pth[MAXK + 1][MAXN];
int res[2][MAXN];
int ttime[MAXK];
int train[MAXN];

void Solve()
{
	int i, j;
	j = n - 1;
	for (i = n - 1; i >= 0; i--)
	{
		while (sg[j].l > sg[i].r) j--;
		nxt[i] = min(j, i + m - 1);
	}
	/*cerr << "we have segments:\n";
	for (i = 0; i < n; i++)
	{
		cerr << sg[i].l << " " << sg[i].r << " " << sg[i].id << "\n";
	}
	cerr << "nxt: ";
	for (i = 0; i < n; i++) cerr << nxt[i] << "\n";*/
	for (i = 0; i <= n; i++) res[0][i] = 0;
	int mres, mi, mj;
	mres = 0;
	mi = n;
	mj = 0;
	for (i = 1; i <= k; i++)
	{
		res[i & 1][n] = 0;
		for (j = n - 1; j >= 0; j--)
		{
			res[i & 1][j] = res[i & 1][j + 1];
			pth[i][j] = 0;
			int tt = nxt[j] - j + 1 + res[(i ^ 1) & 1][nxt[j] + 1];
			if (tt > res[i & 1][j]) 
			{
				res[i & 1][j] = tt;
				pth[i][j] = 1;
			}
			cerr << "i = " << i << " j = " << j << " res = " << res[j][i] << "\n";
			if (res[i & 1][j] > mres)
			{
				mres = res[i & 1][j];
				mi = i;
				mj = j;
			}
		}
	}
	memset(train, 0, sizeof(train));
	memset(ttime, 0, sizeof(ttime));
	i = 0;
	while ((mi > 0) && (mj < n))
	{
		if (pth[mi][mj] == 0) mj++;
		else
		{
			ttime[i++] = sg[mj].r;
			j = mj;
			while (j <= nxt[mj])
			{
				train[sg[j].id] = i;
				j++;
			}
			mj = nxt[mj] + 1;
			mi--;
		}
	}
	printf("%d\n", mres);
	for (i = 0; i < k; i++) printf("%d ", ttime[i]);
	printf("\n");
	for (i = 0; i < n; i++) printf("%d ", train[i]);
	printf("\n");
}

int main()
{
//	freopen("trains.in", "rt", stdin);
//	freopen("trains.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
