#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

bool CheckDecomposition(const vector<long long>& f, long long a, int min_index) {
  int i = f.size() - 1;
  while (i >= min_index) {
    if (a >= f[i]) {
      a -= f[i];
      i -= 2;
    } else {
      --i;
    }
  }
  return a == 0;
}

bool IsPalindrome(const vector<long long>& f, long long start, long long len) {
  int fi = 2;
  while (start >= 0) {
    while (f[fi] - 2 < len || ((f[fi] ^ len) & 1) != 0)
      ++fi;
    long long delta = (f[fi] - 2 - len) / 2;
    len += 2 * delta;
    start -= delta;
    if (start < 0)
      break;
    int minToUse = len == 1 ? 0 : fi - 1;
    if (CheckDecomposition(f, start, minToUse))
      return true;
    len += 2;
    --start;
  }
  return false;
}

int main() {
  vector<long long> f;
  f.push_back(1);
  f.push_back(2);
  while (f[f.size() - 1] < 3100000000LL)
    f.push_back(f[f.size() - 1] + f[f.size() - 2]);
  int n;
  scanf("%d", &n);
  assert(n >= 1 && n <= 10000);
  for (int i = 0; i < n; ++i) {
    int start;
    int len;
    scanf("%d %d", &start, &len);
    assert(1 <= start && start <= 1000000000);
    assert(1 <= len && len <= 1000000000);
    --start;
    if (IsPalindrome(f, start, len)) {
      printf("TAK\n");
    } else {
      printf("NIE\n");
    }
  }
}
