#include <cassert>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
#include <iostream>

using namespace std;

void doit(vector<vector<bool> >& palin2, int at, int len) {
    for (; len > 0; ++at, len -= 2) {
      palin2[at][len] = true;
   }
}

void doall(vector<vector<bool> >& palin2, const vector<int>& lens, int minToUse, int maxToUse, int sum, int len) {
  if (sum + len > lens[lens.size() - 1])
    return;
  doit(palin2, sum, len);
  for (int i = maxToUse; i >= minToUse; --i)
    doall(palin2, lens, minToUse, i - 2, sum + lens[i], len);
}

void markPalin2(vector<vector<bool> >& palin2, int start, int size, vector<int> lens) {
/*  if (size >= 2) {
    doit(palin2, start, lens[size] - 2);
    markPalin2(palin2, start, size - 1, lens);
    markPalin2(palin2, start + lens[size - 2], size - 1, lens);*/
/*    if (size % 2 == lens.size() % 2 && lens[lens.size() - 1] == start + lens[size]) {
    if (start + lens[size - 2] - 2 >= 0)
      palin2[start + lens[size - 2] - 2][lens[size - 1] + 2] = true;
    palin2[start + lens[size - 2] - 1][lens[size - 1] ] = true;
    }*/
    //markPalin2(palin2, start + lens[size - 1], size - 2, lens);
//  }
  for (int len = 2; len <= size; ++len) {
    doall(palin2, lens, max(len - 1, 0), size, 0, max(1, lens[len] - 2));
  }
}

string str(int x) {
  char tmp[100];
  sprintf(tmp, "%d", x);
  return string(tmp);
}

string decompose(int x, vector<int> lens) {
  int at = lens.size() - 1;
  string res = " ";
  while (at >= 0) {
    if (lens[at] <= x) {
      x -= lens[at];
      if (res != "")
        res += " ";
      res += str(at + 2);
    }
    --at;
  }
  if (x != 0)
    exit(1);
  return res;
}

int main() {
  vector<int> lens;
  string prev = "0";
  string cur = "01";
  lens.push_back(1);
  lens.push_back(2);
  for (int i = 0; i < 15; ++i) {
    string next = cur + prev;
    prev = cur;
    cur = next;
    lens.push_back(cur.size());
  }
  //printf("%s\n", cur.c_str());
  //cur = "10" + cur;
  int len = cur.size() - 2;
  vector<vector<bool> > palin(len + 1, vector<bool>(len + 1, true));
  vector<vector<vector<int> > > delta(len + 1, vector<vector<int> >(len + 1, vector<int>(3, 0)));
  vector<int> res(3, 0);
  int ra = -1;
  int rb = -1;
  for (int l = 2; l <= len; ++l) {
    for (int i = 0; i + l <= len; ++i) {
      palin[i][l] = (cur[i] == cur[i + l - 1] && palin[i + 1][l - 2]);
      vector<int> p = delta[i + 1][l - 2];
      vector<int> np = p;
      if (cur[i] == cur[i + l - 1]) {
        ++np[1];
        if (np[0] == 0)
          ++np[2];
      } else {
        ++np[0];
        np[1] = 0;
      }
      delta[i][l] = np;
      if (np[0] > 0 && min(np[1], 2 * np[2]) > min(res[1], 2 * res[2]) || min(np[1], 2 * np[2]) == min(res[1], 2 * res[2]) && rb < l) {
        res = np;
        ra = i;
        rb = l;
      }
    }
  }
  cout << res[0] << " and " << res[1] << " and " << res[2] << " on len " << len << " " << ra << " " << rb << endl;
  string ss = cur.substr(0, 2205);
  cerr << ss << endl;
  reverse(ss.begin(), ss.end());
  cerr << ss << endl; 
  vector<vector<bool> > palin2(len + 3, vector<bool>(len + 1, false));
  markPalin2(palin2, 0, lens.size() - 1, lens);
/*  for (int l = 1; l <= len; ++l) {
    for (int i = 0; i + l <= len; ++i)
      if (palin[i][l] && (l >= len - 1 || i == 0 || i + l == len || !palin[i - 1][l + 2])) {
        cout << " start = " << decompose(i, lens) << ", len = " << decompose(l + 2, lens) << endl;
      }
  }*/
//  cout << palin[lens[15] + lens[13]][lens[14] - 2] << endl;
/*  cout << cur.substr(89) << endl << prev << endl;*/
  for (int l = 1; l <= len; ++l) {
    for (int i = 0; i + l <= len; ++i)
      if (palin[i][l] != palin2[i][l]) {
        cout << " start = " << i << ", len = " << l << " " << palin[i][l] << " " << palin2[i][l] << endl;
      }
  }
}
