#include <cassert>
#include <cstdio>
#include <ext/hash_map>
#include <iostream>
#include <string>
#include <vector>

using namespace std;
using namespace __gnu_cxx;

namespace __gnu_cxx {
template <>
struct hash<string> {
  size_t operator()(const string& s) const {
    return hash_(s.c_str());
  }

  hash<const char*> hash_;
};
}

int GetVersion(const char* name, hash_map<string, int>* version_map, bool should_be_new) {
  pair<hash_map<string, int>::iterator, bool> it = version_map->insert(make_pair(string(name), version_map->size()));
  assert(it.second == should_be_new);
  return it.first->second;
}

int main() {
  hash_map<string, int> version_map;
  int n;
  scanf("%d", &n);
  char buf1[100];
  scanf("%s", buf1);
  int start = GetVersion(buf1, &version_map, true);
  vector<int> branch_id;
  vector<bool> leaf;
  vector<int> values;
  branch_id.push_back(0);
  leaf.push_back(true);
  values.push_back(-1); 
  vector<int> branch_parent;
  branch_parent.push_back(-1);
  vector<hash_map<int, vector<int> > > branch_content(1, hash_map<int, vector<int> >());
  int k;
  scanf("%d", &k);
  char buf2[100];
  char buf3[100];
  for (int step = 0; step < k; ++step) {
    int p;
    int q;
    scanf("%s", buf1);
    if (buf1[0] == 'S') {
      scanf("%s %d %d %s", buf2, &p, &q, buf3);
      int v1 = GetVersion(buf2, &version_map, false);
      int v2 = GetVersion(buf3, &version_map, true);
      leaf.push_back(true);
      if (leaf[v1]) {
        leaf[v1] = false;
        branch_id.push_back(branch_id[v1]);
      } else {
        branch_id.push_back(branch_parent.size());
        branch_parent.push_back(v1);
        branch_content.push_back(hash_map<int, vector<int> >());
      }
      values.push_back(q);
      branch_content[branch_id[v2]][p].push_back(v2);
    } else if (buf1[0] == 'G') {
      scanf("%s %d", buf2, &p);
      int v = GetVersion(buf2, &version_map, false);
      int q = 0;
      while (v >= 0) {
        int branch = branch_id[v];
        hash_map<int, vector<int> >::const_iterator it = branch_content[branch].find(p);
        if (it != branch_content[branch].end() && it->second[0] <= v) {
          // We found the right branch!
          vector<int>::const_iterator vit = upper_bound(it->second.begin(), it->second.end(), v) - 1;
          q = values[*vit];
          break;
        } else {
          v = branch_parent[branch];
        }
      }
      printf("%d\n", q);
      fflush(stdout);
    } else assert(false);
  }
}
