#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>
#include <limits>

using namespace std;

#define EPS 1E-8

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forv(i, a) for (int i = 0; i < int(a.size()); i++)
#define fors(i, a) for (int i = 0; i < int(a.length()); i++)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

#define C_IN_FILE "input.txt"
#define C_OUT_FILE "output.txt"

const int MAXN = 100001;

int n, k;
int par[MAXN];
int key[MAXN];
int value[MAXN];

set<int> leaves;

map<string, int> number;

int getNumber(const string& s, bool must) {
    assert(1 <= (int)s.length() && (int)s.length() <= 10);
    if (number.count(s) == 0) {
        if (must) {
            cerr << "!must " << s << endl;
            assert(false);
        }
        int res = (int)number.size();
        return number[s] = res;
    } else {
        if (!must) {
            cerr << "must " << s << endl;
        }
    }
    return number[s];
}

void outdata() {
}

void solve() {
    char buf[20];
    for(int i = 0; i < k; ++i) {
        scanf("%s", buf);
        assert(strlen(buf) == 1);
        if (buf[0] == 'S') {
            int ckey, cvalue;
            scanf("%s", buf);
            if (scanf("%d%d", &ckey, &cvalue) != 2) assert(false);
            int old = getNumber(buf, true);
            scanf("%s", buf);
            int nev = getNumber(buf, false);
            par[nev] = old;
            assert(1 <= ckey && ckey <= n);
            key[nev] = ckey;
            value[nev] = cvalue;
            leaves.erase(old);
            leaves.insert(nev);
            assert((int)leaves.size() <= 20);
        } else {
            assert(buf[0] == 'G');
            scanf("%s", buf);
            int v = getNumber(buf, true);
            int ckey;
            if (scanf("%d", &ckey) != 1) assert(false);
            int res = 0;
            do {
                if (key[v] == ckey) {
                    res = value[v];
                    break;
                }
                v = par[v];
            } while (v != -1);
            printf("%d\n", res);
            fflush(stdout);
        }
    }
}

void readdata() {
    char buf[20];
    scanf("%d%s%d", &n, buf, &k);
    assert(1 <= n && n <= 100000);
    int c = getNumber(buf, false); 
    par[c] = -1;
    assert(1 <= k && k <= 100000);
}

int main() {
	readdata();
	solve();
	outdata();
	return 0;
}
