#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <map>

using namespace std;

const int MAXN = 30;

class Box
{
public:
	int a, b, c;
};

int n;
Box box[MAXN];

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d%d%d", &box[i].a, &box[i].b, &box[i].c);
	}
}

class BoxPos
{
public:
	int x, y, z, id;
};

bool operator<(const BoxPos &a, const BoxPos &b)
{
	long long s1 = ((long long)a.x) * a.y;
	long long s2 = ((long long)b.x) * b.y;
	return (s1 > s2) 
			|| ((s1 == s2) && (a.x > b.x))
			|| ((s1 == s2) && (a.x == b.x) && (a.y > b.y)); 
}

class State
{
public:
	int m, x, y, p;
};

bool operator<(const State &a, const State &b)
{
	if (a.m < b.m) return true;
	if (a.m > b.m) return false;
	if (a.p < b.p) return true;
	if (a.p > b.p) return false;
	if (a.x < b.x) return true;
	if (a.x > b.x) return false;
	return a.y < b.y;
}

BoxPos pos[3 * MAXN];
int np;
int was[MAXN];
int ctk[MAXN];
int ctop;
int otk[MAXN];
int otop;
int oans;
int res[3 * MAXN];
int res2[3 * MAXN];
map<State, int> was2;

void Gen(int cur, int lx, int ly, int lz, int msk)
{
	if (cur == np)
	{
		if (lz > oans)
		{
			oans = lz;
			otop = ctop;
			int i;
			for (i = 0; i < ctop; i++) otk[i] = ctk[i];
		}
		return;
	}
	if (cur < 2.5 * n)
	{
		State pp;
		pp.m = msk;
		pp.x = lx;
		pp.y = ly;
		pp.p = cur;
		map<State, int> :: iterator p;
		p = was2.find(pp);
		if (p != was2.end())
		{
			if (lz <= p->second) return;
		}
		was2[pp] = lz;
	}
	int i, j;
	for (i = np - 1; i >= cur; i--)
	{
		if (was[pos[i].id] != 0) 
		{
			res2[i] = 0;
			if (i != np - 1) res2[i] = res2[i + 1];
		}
		else 
		{
		    res2[i] = pos[i].z;
			if (i != np - 1) res2[i] = max(res2[i], res2[i + 1]);
			for (j = i + 1; j < np; j++)
			{
				if (pos[j].x <= pos[i].x && pos[j].y <= pos[i].y)
				{
					res2[i] = max(res2[i], pos[i].z + res2[j]);
				}
			}
		}
	}
	if (lz + res2[cur] <= oans) return;
	int sum = 0;   	
	for (i = cur; i < np; i++)
	{
		if (was[pos[i].id] != 0) continue;
		sum += pos[i].z;
	}
	if (lz + sum <= oans) return;
	if (lz + res[cur] <= oans) return;
	if ((was[pos[cur].id] == 0) && (pos[cur].x <= lx) && (pos[cur].y <= ly))
	{
		was[pos[cur].id] = 1;
		ctk[ctop] = cur;
		ctop++;
		Gen(cur + 1, pos[cur].x, pos[cur].y, lz + pos[cur].z, msk | (1 << pos[cur].id));
		ctop--;
		was[pos[cur].id] = 0;
	} 
	Gen(cur + 1, lx, ly, lz, msk);
}

void Solve()
{
	int i, j;
	np = 0;
	for (i = 0; i < n; i++)
	{
		pos[np].z = box[i].a;
		pos[np].x = min(box[i].b, box[i].c);
		pos[np].y = max(box[i].b, box[i].c);
		pos[np].id = i;
		np++;
		pos[np].z = box[i].b;
		pos[np].x = min(box[i].a, box[i].c);
		pos[np].y = max(box[i].a, box[i].c);
		pos[np].id = i;
		np++;
		pos[np].z = box[i].c;
		pos[np].x = min(box[i].b, box[i].a);
		pos[np].y = max(box[i].b, box[i].a);
		pos[np].id = i;
		np++;
	}
	sort(pos, pos + np);
	memset(res, 0, sizeof(res));
	for (i = np - 1; i >= 0; i--)
	{
		res[i] = pos[i].z;
		if (i != np - 1) res[i] = max(res[i], res[i + 1]);
		for (j = i + 1; j < np; j++)
		{
			if (pos[j].x <= pos[i].x && pos[j].y <= pos[i].y)
			{
				res[i] = max(res[i], res[j] + pos[i].z);
			}
		}
	}
	/*cerr << "Have positions:\n";
	for (i = 0; i < np; i++)
	{
		cerr << pos[i].id << " " << pos[i].x << " " << pos[i].y << " " << pos[i].z << "\n";
	}*/
	oans = 0;
	otop = 0;
	memset(was, 0, sizeof(was));     
	ctop = 0;
	was2.clear();
	Gen(0, 1000000000, 1000000000, 0, 0);
	printf("%d\n%d\n", oans, otop);
	for (i = 0; i < otop; i++)
	{
		printf("%d %d %d %d\n", pos[otk[i]].id + 1, pos[otk[i]].x, pos[otk[i]].y, pos[otk[i]].z);
	}
}

int main()
{
	Load();
	Solve();
	return 0;
}

