#include <iostream>
#include <fstream>
#include <cstdio>

using namespace std;

const int MAXN = 30;

class Box
{
public:
	int a, b, c;
};

int n;
Box box[MAXN];

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d%d%d", &box[i].a, &box[i].b, &box[i].c);
	}
}

class BoxPos
{
public:
	int x, y, z, id;
};

bool operator<(const BoxPos &a, const BoxPos &b)
{
	long long s1 = ((long long)a.x) * a.y;
	long long s2 = ((long long)b.x) * b.y;
	return (s1 > s2) 
			|| ((s1 == s2) && (a.x > b.x))
			|| ((s1 == s2) && (a.x == b.x) && (a.y > b.y)); 
}

BoxPos pos[3 * MAXN];
int np;
int was[MAXN];
int ctk[MAXN];
int ctop;
int otk[MAXN];
int otop;
int oans;

void Gen(int cur, int lx, int ly, int lz)
{
	if (cur == np)
	{
		if (lz > oans)
		{
			oans = lz;
			otop = ctop;
			int i;
			for (i = 0; i < ctop; i++) otk[i] = ctk[i];
		}
		return;
	}
	int sum = 0;
	int i;
	for (i = cur; i < np; i++)
	{
		if (was[pos[i].id] != 0) continue;
		sum += pos[i].z;
	}
	if (lz + sum <= oans) return;
	if ((was[pos[cur].id] == 0) && (pos[cur].x <= lx) && (pos[cur].y <= ly))
	{
		was[pos[cur].id] = 1;
		ctk[ctop] = cur;
		ctop++;
		Gen(cur + 1, pos[cur].x, pos[cur].y, lz + pos[cur].z);
		ctop--;
		was[pos[cur].id] = 0;
	} 
	Gen(cur + 1, lx, ly, lz);
}

void Solve()
{
	int i;
	np = 0;
	for (i = 0; i < n; i++)
	{
		pos[np].z = box[i].a;
		pos[np].x = min(box[i].b, box[i].c);
		pos[np].y = max(box[i].b, box[i].c);
		pos[np].id = i;
		np++;
		pos[np].z = box[i].b;
		pos[np].x = min(box[i].a, box[i].c);
		pos[np].y = max(box[i].a, box[i].c);
		pos[np].id = i;
		np++;
		pos[np].z = box[i].c;
		pos[np].x = min(box[i].b, box[i].a);
		pos[np].y = max(box[i].b, box[i].a);
		pos[np].id = i;
		np++;
	}
	sort(pos, pos + np);
	/*cerr << "Have positions:\n";
	for (i = 0; i < np; i++)
	{
		cerr << pos[i].id << " " << pos[i].x << " " << pos[i].y << " " << pos[i].z << "\n";
	}*/
	oans = 0;
	otop = 0;
	memset(was, 0, sizeof(was));     
	ctop = 0;
	Gen(0, 1000000000, 1000000000, 0);
	printf("%d\n%d\n", oans, otop);
	for (i = 0; i < otop; i++)
	{
		printf("%d %d %d %d\n", pos[otk[i]].id + 1, pos[otk[i]].x, pos[otk[i]].y, pos[otk[i]].z);
	}
}

int main()
{
	Load();
	Solve();
	return 0;
}

