#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <ctime>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

int readInt()
{
  int s = 1, x = 0, c = getc(stdin);
  while (c <= 32)
    c = getc(stdin);
  if (c == '-')
    s = -1, c = getc(stdin);
  while ('0' <= c && c <= '9')
    x = x * 10 + c - '0', c = getc(stdin);
  return x * s;
}

const int maxn = (int)1e6;

int n, x[maxn], y[maxn], z[maxn];
char u[maxn];

#define D(i, j) (abs(x[i] - y[j]) + abs(y[i] - z[j]) + abs(z[i] - x[j]))
#define RAND (unsigned)((rand() << 15) + rand())

int main()
{
  int start = clock();
  int n = readInt();
  forn(i, n)
  {
    x[i] = readInt();
    y[i] = readInt();
    z[i] = readInt();
  }

  int ans = 0, ri = 0, rj = 0;
  if (n <= (int)1e4)
  {
    forn(i, n) 
      forn(j, n)
        if (i != j && D(i, j) > ans)
          ans = D(i, j), ri = i, rj = j;
  }
  else
  {
    int cnt = 0;
    memset(u, 0, sizeof(u));
    while (clock() - start < 1.8 * CLOCKS_PER_SEC)
    {
      int p = RAND % n;
      while (u[p] != 1)
      {
        int ma = -1, ind = 0;
        forn(i, n)
          if (p != i && D(p, i) > ma)
            ma = D(p, i), ind = i;
        if (ma > ans)
        {
          ans = ma, ri = p, rj = ind;
          printf("cnt=%d\n", cnt);
        }
//        printf("%d --> %d\n", p, ind);
        u[p] = 1, p = ind;
        cnt++;
      }
    }
  }
  printf("%d\n%d %d\n", ans, ri + 1, rj + 1);
  return 0;
}
