#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

const int NMAX = 1000000;
const int MAXX = 100000;

int n;
struct point {
    int id;
    int a[3];
    int& operator[] (int idx) {
        return a[idx];
    }
    int sum(int msk) const {
        int res = 0;
        for(int i = 0; i < 3; ++i) {
            res += (msk & (1 << i)) ? -a[i] : a[i];
        }
        return res;
    }
};

point a[NMAX];
int ans, ax, ay;

class comparator {
public:
    comparator(int msk):msk(msk) {
    }
    bool operator() (const point &a, const point &b) {
        return a.sum(msk) < b.sum(msk);
    }
private:
    int msk;
};

void outdata() {
    cout << ans << endl << ax + 1 << " " << ay + 1 << endl;
}

int p(point a, point b) {
    return abs(a[0] - b[1]) + abs(a[1] - b[2]) + abs(a[2] - b[0]);
}

void get2Max(int msk, vector<point>& res) {
    comparator cmp(msk);
    swap(a[0], *max_element(a, a + n, cmp));
    swap(a[1], *max_element(a + 1, a + n, cmp));
    res.push_back(a[0]);
    res.push_back(a[1]);
}

void solve() {
    ans = p(a[0], a[1]);
    ax = 0;
    ay = 1;
    for(int msk = 0; msk < 8; ++msk) {
        if (msk == 5 || msk == 4) continue;
        int m1 = 0, m2 = 7;
        for(int i = 0; i < 3; ++i)  {
            if (msk & (1 << i)) {
                int ni = i + 1 == 3 ? 0 : i + 1;
                m1 ^= (1 << i);
                m2 ^= (1 << ni);
            }
        }
        vector<point> c1, c2;
        get2Max(m1, c1);
        get2Max(m2, c2);
        for(size_t i = 0; i < c1.size(); ++i) {
            for(size_t j = 0; j < c2.size(); ++j) {
                int cx = c1[i].id, cy = c2[j].id;
                if (cx != cy) {
                    int cans = p(c1[i], c2[j]);
                    if (ans < cans) {
                        ans = cans;
                        ax = cx;
                        ay = cy;
                    }
                }
            }
        }
    }
}

void readdata() {
    if (scanf("%d", &n) != 1) assert(false);
    assert(2 <= n && n <= NMAX);
    for(int i = 0; i < n; ++i) {
        a[i].id = i;
        for(int j = 0; j < 3; ++j) {
            if (scanf("%d", &a[i][j]) != 1) assert(false);
            assert(-MAXX <= a[i][j] && a[i][j] <= MAXX);
        }
    }
}

int main() {
	readdata();
	solve();
	outdata();
	return 0;
}
