#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

const int MAXN = 10000;
const int MAX_POW_LOG = 4;
const int MAX_POW = (1 << MAX_POW_LOG);
const int MAX_POWM1 = MAX_POW - 1;
const int MAXM = 100000;

typedef unsigned int Mask[MAXN / MAX_POW + 1];

int n, m, ln;
vector<int> g[MAXN];
Mask b[MAXN];

void setOne(Mask& m, int pos) {
    m[pos >> MAX_POW_LOG] |= (1 << (pos & MAX_POWM1));
}

int count_bits(int x) {
    int res = 0;
    while (x) {
        ++res;
        x &= (x - 1);
    }
    return res;
}

int andNumOnes(Mask& a, Mask& b) {
    int ans = 0;
    for(int i = 0; i < ln; ++i) {
        ans += count_bits(a[i] & b[i]);
    }
    return ans;
}

void solve() {
    int ans = 0;
    ln = (n >> MAX_POW_LOG) + 1;
    for(int i = 0; i < n; ++i) {
        for(size_t j = 0; j < g[i].size(); ++j) {
            int u = g[i][j];
            if (i < u) {
                ans += andNumOnes(b[i], b[u]);
            }
        }
    }
    printf("%0.10lf\n", (ans / 3) * 0.25);
}

void readdata() {
    if (scanf("%d%d", &n, &m) != 2) {
        assert(false);
    }
    assert(3 <= n && n <= MAXN);
    assert(1 <= m && m <= MAXM);
    memset(b, 0, sizeof(b));
    for(int i = 0; i < m; ++i) {
        int x, y;
        if (scanf("%d%d", &x, &y) != 2) {
            assert(false);
        }
        assert(1 <= x && x <= n);
        assert(1 <= y && y <= n);
        assert(x != y);
        --x; --y;
        g[x].push_back(y);
        g[y].push_back(x);
        setOne(b[x], y);
        setOne(b[y], x);
    }
    for(int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
        assert(unique(g[i].begin(), g[i].end()) == g[i].end());
    }
}

int main() {
	readdata();
	solve();
	return 0;
}
