#include <iostream>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <sstream>
#include <string>

using namespace std;

const long double eps = 1e-12;
const int MANY = 0x7F7F7F7F;
const int MAXN = 42;

int n;
long long need;

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 0; i < n; i++)
	{
		int p;
		scanf("%d", &p);
		need |= (1ll << ((long long)p));
	}
}

int Count(long long a)
{
//	cerr << "Count(" << a << ") = ";
	int i;
	int cnt = 0;
	for (i = 1; i <= MAXN; i++)
	{
		if (((1ll << ((long long)i)) & a) != 0) cnt++;
	}
//	cerr << cnt << "\n";
	return cnt;
}

int ub;
map<long long, int> was;
int cstk[MAXN][3];
int ctop;

bool Gen(int dpt, long long hv)
{
	map<long long, int>::iterator p;
	p = was.find(hv);
	if (p == was.end())
	{
		was[hv] = dpt;
	}
	else
	{
		if (p->second <= dpt) return false;
		p->second = dpt;
	}
	int q = Count(need & (~hv));
	if (dpt + q > ub) return false;
	if (q == 0) return true;
//	cerr << "Gen(" << dpt << ", " << hv << ")\n";
	// shift
	long long i;
	for (i = 1; i <= MAXN; i++)
	{                               
		if ((hv & (1ll << i)) == 0) continue;
//		cerr << "i = " << i << "\n";
		// by what shift
		int j;
		for (j = 1; j <= 5; j++)
		{
			if ((i * (1 << j)) > MAXN) break;
			//cerr << "Shift by " << j << "\n";
			cstk[ctop][0] = 0;
			cstk[ctop][1] = i;
			cstk[ctop][2] = j;
			ctop++;
			if (Gen(dpt + 1, hv | (1ll << (i * (1 << j))))) return true;
			ctop--;
		}
	}
	// add or subtract
	long long j;
	for (i = 1; i <= MAXN; i++)
	{
		if ((hv & (1ll << i)) == 0) continue;
		for (j = i; j <= MAXN; j++)
		{
			if ((hv & (1ll << j)) == 0) continue;
			if (i + j <= MAXN)
			{
				cstk[ctop][0] = 1;
				cstk[ctop][1] = i;
				cstk[ctop][2] = j;
				ctop++;
				if (Gen(dpt + 1, hv | (1ll << (i + j)))) return true;
				ctop--;
			}
			if (j - i > 0)
			{
				cstk[ctop][0] = 2;
				cstk[ctop][1] = i;
				cstk[ctop][2] = j;
				ctop++;
				if (Gen(dpt + 1, hv | (1ll << (j - i)))) return true;
				ctop--;
			}
		}
	}
	return false;
}

void Solve()
{
	long long have = 2;
	for (ub = Count(need & (~have)); ub <= 100; ub++)
	{
//		cerr << "ub = " << ub << "\n";
		was.clear();
		ctop = 0;
		if (Gen(0, have))
		{
			printf("%d\n", ub);
			int i;
			for (i = 0; i < ctop; i++)
			{
				if (cstk[i][0] == 0) printf("%d<<%d\n", cstk[i][1], cstk[i][2]);
				else if (cstk[i][0] == 1) printf("%d+%d\n", cstk[i][1], cstk[i][2]);
				else if (cstk[i][0] == 2) printf("%d-%d\n", cstk[i][2], cstk[i][1]);
			}
			return;
		}
	}
	cout << "B0TVA";
}

int main()
{
	Load();
	Solve();
	return 0;
}
