#include <cassert>
#include <cstring>
#include <iostream>
#include <fstream>

using namespace std;

const int MAXN = 100000;
const int MAXM = 100000;

class Edge
{
public:
	int be, en;
};

class GameGraph
{
public:
	int first[MAXN + 1];
	int next[MAXM];
	int n, m;
	Edge edg[MAXM];
	int ne;

	void AddEdge(int v1, int v2)
	{
		edg[ne].be = v1;
		edg[ne].en = v2;
		next[ne] = first[v1];
		first[v1] = ne;
		ne++;
	}

	void Read()
	{
		memset(first, 0xFF, sizeof(first));
		ne = 0;
		scanf("%d%d", &n, &m);
		assert(1 <= n && n <= MAXN);
		assert(1 <= m && m <= MAXM);
		int i;
		for (i = 0; i < m; i++)
		{
			int p, q;
			scanf("%d%d", &p, &q);
			assert(1 <= p && p <= n);
			assert(1 <= q && q <= n);
			AddEdge(p, q);
		}
	}

	int res[MAXN + 1];
	int len[MAXN + 1];

	int Count(int ver)
	{
		if (res[ver] != -1) return res[ver];
		res[ver] = 0;
		len[ver] = 0;
		int i;
		for (i = first[ver]; i != -1; i = next[i])
		{
			int q = Count(edg[i].en);
			if (q == 0)
			{
				if (res[ver] == 0)
				{
					res[ver] = 1;
					len[ver] = len[edg[i].en] + 1;
				}
				else
				{
					len[ver] = min(len[ver], len[edg[i].en] + 1);
				}
			}
			else
			{
				if (res[ver] == 0)
				{
					len[ver] = max(len[ver], len[edg[i].en] + 1);
				}
			}
		}
		//cerr << "Count(" << ver << "): ";
		//cerr << res[ver] << " " << len[ver] << "\n";
		return res[ver];
	}

	void CountRes()
	{
		memset(res, 0xFF, sizeof(res));
		int i;
		for (i = 1; i <= n; i++)
		{
			if (res[i] == -1) Count(i);
		}
	}
};

GameGraph g1, g2;

void Load()
{
	g1.Read();
	g2.Read();
}

void Solve()
{
	//cerr << "Graph 1:\n";
	g1.CountRes();
	//cerr << "Graph 2:\n";
	g2.CountRes();
	int t, x, y;
	scanf("%d", &t);
	int i;
	for (i = 0; i < t; i++)
	{
		scanf("%d%d", &x, &y);
		//cerr << "g1r " << g1.res[x] << " g2r " << g2.res[y] << " g1l " << g1.len[x] << " g2l " << g2.len[y] << "\n";
		if (g1.res[x] == 1 && g2.res[y] == 1)
		{
			printf("first");
		}
		else if (g1.res[x] == 0 && g2.res[y] == 0)
		{
			printf("second");
		}
		else if (g1.res[x] == 1 && g2.res[y] == 0)
		{
			if (g1.len[x] <= g2.len[y]) printf("first");
			else printf("second");
		}
		else // g1.res[x] == 0 && g2.res[y] == 1
		{
			if (g2.len[y] <= g1.len[x]) printf("first");
			else printf("second");
		}
		printf("\n");
	}
}

int main()
{
	Load();
	Solve();
	return 0;
}
