#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <cmath>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back

typedef double dbl;

struct pnt
{
  int x, y;

  pnt( int x_ = 0, int y_ = 0 ) : x(x_), y(y_) {}

  void read() { scanf("%d%d", &x, &y); }
  
  dbl d() { return hypot(x, y); }
};

pnt operator + ( pnt a, pnt b ) { return pnt(a.x + b.x, a.y + b.y); }
pnt operator - ( pnt a, pnt b ) { return pnt(a.x - b.x, a.y - b.y); }

const int maxn = 1000;
const int maxv = maxn * 4 + 2;

const dbl inf = 1e20;
const dbl eps = 1e-6;

int n, lx[maxn], ly[maxn], rx[maxn], ry[maxn];
pnt st, en;
pnt p[maxn][5];

int vn, ind[maxv];
pnt v[maxv];
dbl d[maxv];
int u[maxv], pr[maxv];

dbl a, b, c, no;
int LX, LY, RX, RY;

int isEdge( int i, int j )
{
  LX = min(v[i].x, v[j].x), RX = max(v[i].x, v[j].x);
  LY = min(v[i].y, v[j].y), RY = max(v[i].y, v[j].y);

  if (ind[i] == ind[j] && ind[i] != -1)
    return LX == RX || LY == RY;

  a = v[i].y - v[j].y;
  b = v[j].x - v[i].x;
  no = sqrt(a * a + b * b);
  a /= no, b /= no;
  c = -(a * v[i].x + b * v[i].y);

  forn(k, n)
    if (lx[k] < RX && LX < rx[k] && ly[k] < RY && LY < ry[k])
    {
      int f1 = 0, f2 = 0;
      forn(m, 4)
      {
        dbl s = a * p[k][m].x + b * p[k][m].y + c;
        if (s < -eps)
          f1 = 1;
        else if (s > eps)
          f2 = 1;
        if (f1 && f2)
          return 0;
      }
    }
  return 1;
}

int main()
{
  st.read();
  en.read();
  scanf("%d", &n);
  forn(i, n)
  {
    scanf("%d%d%d%d", &lx[i], &ly[i], &rx[i], &ry[i]);
    if (lx[i] > rx[i])
      swap(lx[i], rx[i]);
    if (ly[i] > ry[i])
      swap(ly[i], ry[i]);
    p[i][0] = pnt(lx[i], ly[i]);
    p[i][1] = pnt(lx[i], ry[i]);
    p[i][2] = pnt(rx[i], ry[i]);
    p[i][3] = pnt(rx[i], ly[i]);
    p[i][4] = p[i][0];
  }

  ind[vn] = -1, v[vn++] = st;
  ind[vn] = -1, v[vn++] = en;
  forn(i, n)
    forn(j, 4)
      ind[vn] = i, v[vn++] = p[i][j];

  int cur = 0;
  forn(i, vn)
    d[i] = inf;
  d[cur] = 0;
  int cnt = 0;
  while (cur != 1)
  {
    cnt++;
    u[cur] = 1;
    forn(i, vn)
      if (!u[i])
      {
        dbl w = (v[i] - v[cur]).d();
        if (d[i] > d[cur] + w + eps && isEdge(cur, i))
          d[i] = d[cur] + w, pr[i] = cur; 
      }

    cur = -1;
    forn(i, vn)
      if (!u[i] && (cur == -1 || d[cur] > d[i]))
        cur = i;
  }

  printf("%.20lf\n", d[1]);
  vector <int> path;
  while (cur != 0)
    path.pb(cur), cur = pr[cur];
  path.pb(cur);
  printf("%d\n", path.size());
  for (int i = path.size() - 1; i >= 0; i--)
    printf("%d %d\n", v[path[i]].x, v[path[i]].y);
  return 0;
}
