#include <iostream>
#include <fstream>
#include <cstdio>
#include <cassert>

using namespace std;

const int MAXN = 10000;

int n, p;

void Load()
{
	scanf("%d%d", &n, &p);
	assert(1 <= n && n <= MAXN);
	assert(0 <= p && p <= 100);
}

#define double long double

double res[2][MAXN + 3][3];
double prob[2][MAXN + 3][3];
double pp;

void Solve()
{
	res[1][0][0] = 0;
	prob[1][0][0] = 1;
	int i, j;
	pp = (p + 0.0) / 100.0;
	for (i = 1; i <= n; i++)
	{
		for (j = 0; j <= i + 1; j++) 
		{
			res[i & 1 ^ 1][j][0] = res[i & 1 ^ 1][j][1] = res[i & 1 ^ 1][j][2] = 0;
			prob[i & 1 ^ 1][j][0] = prob[i & 1 ^ 1][j][1] = prob[i & 1 ^ 1][j][2] = 0;
		}
		for (j = i - 1; j >= 0; j--)
		{
			if (i == n)
			{
				res[i & 1][j - 1][0] += res[i & 1][j][0] + res[i & 1][j][1] + res[i & 1][j][2];
				prob[i & 1][j - 1][0] += prob[i & 1][j][0] + prob[i & 1][j][1] + prob[i & 1][j][2];
				continue;
			}
			if (j == 0)
			{
				res[i & 1 ^ 1][1][1] += res[i & 1][j][0] + res[i & 1][j][1] + res[i & 1][j][2];
				prob[i & 1 ^ 1][1][1] += prob[i & 1][j][0] + prob[i & 1][j][1] + prob[i & 1][j][2];
				continue;
			}
			//cerr.setf(ios::fixed | ios::showpoint);
			//cerr.precision(10);
			//cerr << i << " " << j << " " << prob[i & 1][j][0] << " " << prob[i & 1][j][1] << " " << prob[i & 1][j][2] << "\n";
			// add a vertex
			res[i & 1 ^ 1][j + 1][1] += pp * res[i & 1][j][0];
			prob[i & 1 ^ 1][j + 1][1] += pp * prob[i & 1][j][0];
			res[i & 1 ^ 1][j + 1][2] += pp * (prob[i & 1][j][1] + res[i & 1][j][1] + res[i & 1][j][2]);
			prob[i & 1 ^ 1][j + 1][2] += pp * (prob[i & 1][j][1] + prob[i & 1][j][2]);
			// go to new vertex
			res[i & 1][j - 1][0] += (1 - pp) * (res[i & 1][j][0] + res[i & 1][j][1] + res[i & 1][j][2]);
			prob[i & 1][j - 1][0] += (1 - pp) * (prob[i & 1][j][0] + prob[i & 1][j][1] + prob[i & 1][j][2]);
		}
	}
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(12);
	cout << res[n & 1][0][0] + res[n & 1][0][1] + res[n & 1][0][2];
}

int main()
{
//	freopen("b.in", "rt", stdin);
	Load();
	Solve();
	return 0;
}

