#include <iostream>
#include <fstream>
#include <cstdio>
#include <cassert>

using namespace std;

const int MAXN = 10000;
const long double eps = 1e-20;

int n, p;

void Load()
{
	scanf("%d%d", &n, &p);
	assert(1 <= n && n <= MAXN);
	assert(0 <= p && p <= 100);
}

#define double long double

double res[2][MAXN + 3][3];
double prob[2][MAXN + 3][3];
double pp;

void Solve()
{
	memset(res, 0, sizeof(res));
	memset(prob, 0, sizeof(prob));
	res[1][0][0] = 0;
	prob[1][0][0] = 1;
	int i, j;
	pp = (p + 0.0) / 100.0;
	double pp1 = 1.0 - pp;
	for (i = 1; i <= n; i++)
	{
		int ci, ni;
		ci = i & 1;
		ni = i & 1 ^ 1;
		memset(res[ni], 0, sizeof(double) * 3 * (i + 2));
		memset(prob[ni], 0, sizeof(double) * 3 * (i + 2));
		/*for (j = 0; j <= i + 1; j++) 
		{
			res[ni][j][0] = res[ni][j][1] = res[ni][j][2] = 0;
			prob[ni][j][0] = prob[ni][j][1] = prob[ni][j][2] = 0;
		}*/
		for (j = i - 1; j >= 0; j--)
		{
			double *r;
			double *q;
			r = res[ci][j];
			q = prob[ci][j];
			if (i == n)
			{
				res[ci][j - 1][0] += r[0] + r[1] + r[2];
				prob[ci][j - 1][0] += q[0] + q[1] + q[2];
				continue;
			}
			if (j == 0)
			{
				res[ni][1][1] += r[0] + r[1] + r[2];
				prob[ni][1][1] += q[0] + q[1] + q[2];
				continue;
			}
			if (q[0] + q[1] + q[2] < eps) continue;
			//cerr.setf(ios::fixed | ios::showpoint);
			//cerr.precision(10);
			//cerr << i << " " << j << " " << prob[ci][j][0] << " " << prob[ci][j][1] << " " << prob[ci][j][2] << "\n";
			// add a vertex
			res[ni][j + 1][1] += pp * r[0];
			prob[ni][j + 1][1] += pp * q[0];
			res[ni][j + 1][2] += pp * (q[1] + r[1] + r[2]);
			prob[ni][j + 1][2] += pp * (q[1] + q[2]);
			// go to new vertex
			res[ci][j - 1][0] += pp1 * (r[0] + r[1] + r[2]);
			prob[ci][j - 1][0] += pp1 * (q[0] + q[1] + q[2]);
		}
	}
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(12);
	cout << res[n & 1][0][0] + res[n & 1][0][1] + res[n & 1][0][2];
}

int main()
{
//	freopen("b.in", "rt", stdin);
	Load();
	Solve();
	return 0;
}

