#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef double dbl;

const int maxn = 7500;

int n;
dbl sum = 0, p, pf[2][maxn][3], f[2][maxn][3];

inline void Relax( int i, int j, int c, int i0, int j0, int c0, dbl add, dbl k )
{
  if (k == 0)
    return;
  f[i][j][c] = f[i][j][c] * pf[i][j][c] + (f[i0][j0][c0] + add) * pf[i0][j0][c0] * k;
  pf[i][j][c] += pf[i0][j0][c0] * k;
  f[i][j][c] /= pf[i][j][c];
}

int main()
{
  scanf("%d%lf", &n, &p);
  assert(1 <= n && n <= maxn);
  assert(0 <= p && p <= 100 && (int)p == p);
  p *= 0.01;
  pf[0][0][0] = 1;
  f[0][0][0] = 0;
  for (int t = 0; t < n; t++)
  {
    int i = t & 1;
    memset(pf[i ^ 1], 0, sizeof(pf[0]));
    for (int j = 0; t + j + 1 <= n; j++)
      forn(c, 3)
        if (t + j + 1 == n)
          sum += f[i][j][c] * pf[i][j][c];
        else if (pf[i][j][c] > 1e-15)
          if (j == 0)
            Relax(i, j + 1, min(2, c + 1), i, j, c, c == 1, 1.0);
          else
          {
            Relax(i ^ 1, j - 1, 0, i, j, c, 0, 1 - p);
            Relax(i, j + 1, min(2, c + 1), i, j, c, c == 1, p);
          }
  }
  printf("%.20lf\n", sum);
  return 0;
}
