#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef double dbl;

const int maxn = 2000;

int n;
dbl p, pf[maxn][maxn][3], f[maxn][maxn][3];

inline void Relax( int i, int j, int c, int i0, int j0, int c0, dbl add, dbl k )
{
  if (k == 0)
    return;
  f[i][j][c] = f[i][j][c] * pf[i][j][c] + (f[i0][j0][c0] + add) * pf[i0][j0][c0] * k;
  pf[i][j][c] += pf[i0][j0][c0] * k;
  f[i][j][c] /= pf[i][j][c];
}

int main()
{
  scanf("%d%lf", &n, &p);
  assert(1 <= n && n <= maxn);
  assert(0 <= p && p <= 100 && (int)p == p);
  p *= 0.01;
  pf[0][0][0] = 1;
  f[0][0][0] = 0;
  for (int i = 0; i < n; i++)
    for (int j = 0; i + j + 1 < n; j++)
      forn(c, 3)
        if (pf[i][j][c] > 1e-12)
          if (j == 0)
            Relax(i, j + 1, min(2, c + 1), i, j, c, c == 1, 1.0);
          else
          {
            Relax(i + 1, j - 1, 0, i, j, c, 0, 1 - p);
            Relax(i, j + 1, min(2, c + 1), i, j, c, c == 1, p);
          }

  dbl sum = 0;
  forn(i, n)
    forn(c, 3)
      sum += f[i][n - i - 1][c] * pf[i][n - i - 1][c];
  printf("%.20lf\n", sum);
  return 0;
}
