#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

const double EPS = 1e-12;

int n;

vector<int> s;

vector< vector<int> > sums;
vector<int> c;

void go(int n, int min_s) {
    if (n == 0) {
        sums.push_back(c);
    }
    for(int i = min_s; i <= n; ++i) {
        c.push_back(i);
        go(n - i, i);
        c.pop_back();
    }
}

template <class T>
int number(vector<T>& a, T& v) {
    return (int)(lower_bound(a.begin(), a.end(), v) - a.begin());
}

vector<vector<double> > d;
vector<double> b, res;

void gauss() {
	for(int i = 0; i < n; ++i) {
		for(int j = i; j < n; ++i) {
			if (fabs(d[j][i]) > EPS) {
				swap(d[j], d[i]);
				break;
			}
		}
		assert(fabs(d[i][i]) > EPS);
		double x = d[i][i];
		for(int j = i; j < n; ++j) {
			d[i][j] /= x;
		}
		b[i] /= x;
		for(int j = i + 1; j < n; ++j) {
			double y = d[j][i];
			for(int t = i; t < n; ++t) {
				d[j][t] -= d[i][t] * y;
			}
			b[j] -= b[i] * y;
		}
	}
	res.resize(n);
	for(int i = n - 1; i >= 0; --i) {
		res[i] = b[i];
		for(int j = i + 1; j < n; ++j) {
			res[i] -= d[i][j] * res[j];
		}
	}
}

void solve() {
    double zn = n * (n - 1) / 2.0;
    go(n, 1);
    sort(sums.begin(), sums.end());
    sums.erase(unique(sums.begin(), sums.end()), sums.end());
	int res_index = number(sums, s);
	vector<int> init(n, 1);
	int init_index = number(sums, init);
    n = (int)sums.size();
    d.resize(n, vector<double>(n, 0.0));
	b.resize(n, -1.0);
    for(int t = 0; t < n; ++t) {
        vector<int> x = sums[t];
        for(int i = 0; i < (int)x.size(); ++i) {
            for(int j = 0; j < i; ++j) {
                vector<int> y = x;
                y.erase(y.begin() + i);
                y.erase(y.begin() + j);
                y.push_back(x[i] + x[j]);
                sort(y.begin(), y.end());
                d[t][number(sums, y)] += x[i] * x[j] / zn;
            }
        }
        for(int i = 0; i < (int)x.size(); ++i) {
            int cl = x[i];
            for(int j = 1; j * 2 <= cl; ++j) {
                vector<int> y = x;
                y.erase(y.begin() + i);
                y.push_back(j);
                y.push_back(cl - j);
                sort(y.begin(), y.end());
                double add = cl / zn;
                if (cl == j * 2) {
                    add /= 2.0;
                }
                d[t][number(sums, y)] += add;
            }
        }
    }
    for(int i = 0; i < n; ++i) {
		d[init_index][i] = 0.0;
	}
    for(int i = 0; i < n; ++i) {
		d[i][i] += -1.0;
	}
	b[init_index] = 0;
	gauss();
	cout << (long long)(res[res_index] + EPS) << endl;
}

void readdata() {
    if (scanf("%d", &n) != 1) {
        assert(false);
    }
    assert(1 <= n && n <= 15);
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        if (scanf("%d", &a[i]) != 1) {
            assert(false);
        }
		--a[i];
    }
    for(int i = 0; i < n; ++i) {
        if (a[i] != -1) {
            int j = i, l = 0;
            while (a[j] != -1) {
                int nj = a[j];
                a[j] = -1;
                j = nj;
                ++l;
            }
            s.push_back(l);
        }
    }
    sort(s.begin(), s.end());
}

int main() {
	readdata();
	solve();
	return 0;
}
