#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

const int MAXITER = 10000000;

int n;
vector<int> a, c, s;

void solve() {
    s = a;
    sort(s.begin(), s.end());
    for(int i = 0; i < n; ++i) {
        assert(s[i] == i + 1);
    }
    int iter = 0;
    int res = 0, k = 0;
    while (iter < MAXITER) {
        c = a;
        int cres = 0;
        while (s != c && iter < MAXITER) {
            int x = rand() % n;
            int y = rand() % (n - 1);
            if (y >= x) {
                y++;
            }
            swap(c[x], c[y]);
            ++iter;
            ++cres;
        }
        if (s == c) {
            ++k;
            res += cres;
            ++iter;
        }
    }
    cout << (int)(res / (double)k) << endl;
}

void readdata() {
    if (scanf("%d", &n) != 1) {
        assert(false);
    }
    assert(1 <= n && n <= 15);
    a.resize(n);
    for(int i = 0; i < n; ++i) {
        if (scanf("%d", &a[i]) != 1) {
            assert(false);
        }
    }
}

int main() {
	readdata();
	solve();
	return 0;
}
