#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

using namespace std;

enum ev_type { End = 1, Start = 2, EOL = 3 };
struct event {
  int x;
  int id; ev_type ty;
};
struct line {
  int s, f;
  int rem;
};
bool operator<(event a, event b) {
  if (a.x < b.x) return true;
  if (a.x > b.x) return false;
  return a.ty < b.ty;
}
bool operator<(line a, line b) {
  if (a.s < b.s) return true;
  if (a.s > b.s) return false;
  return a.f < b.f;
}

int ans_count;
vector<event> evs;
vector<int> xs, rem;
vector<line> lines;

int srch2(int val) {
  int l = 0, r = xs.size() - 1;
  while (l + 1 < r) {
    int m = (l + r) >> 1;
    if (xs[m] <= val) l = m;
    else r = m;
  }
  if (xs[r] <= val) return r;
  else return l;
}

void paint0(int k) {
  int pos = srch2(k);
  if (!--rem[pos]) {
    #ifdef DEBUG
    fprintf(stderr, "Painted from %d to %d\n", xs[pos] + 1, evs[pos + 1].x);
    #endif
    for (int i = 0; i < lines.size(); i++)
      if ((lines[i].s <= pos) && (pos < lines[i].f))
        if (!--lines[i].rem) {
          #ifdef DEBUG
          fprintf(stderr, "  Painted from %d to %d (id=%d)\n", lines[i].s + 1, lines[i].f, i + 1);
          #endif
          ans_count++;
	}
  }
}

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  int l, n;
  scanf("%d%d", &l, &n);
  
  evs = vector<event>(n << 1);
  lines = vector<line>(n);
  for (int i = 0; i < n; i++) {
    int s, f; scanf("%d%d", &s, &f); s--, f--;
    event n;
    n.id = i;
    n.x = s; n.ty = Start; evs[i << 1] = n;
    n.x = f + 1; n.ty = End;   evs[(i << 1) + 1] = n;
    
    lines[i].s = s;
    lines[i].f = f + 1;
    lines[i].rem = 0;
  }
  sort(evs.begin(), evs.end());

  xs = vector<int>(evs.size());
  rem = vector<int>(evs.size() - 1);
  for (int i = 0; i < evs.size(); i++) xs[i] = evs[i].x;
  for (int i = 0; i < evs.size() - 1; i++) rem[i] = evs[i + 1].x - evs[i].x;
  
  for (int i = 0; i < n; i++)
    lines[i].rem = srch2(lines[i].f) - srch2(lines[i].s);
  sort(lines.begin(), lines.end());
  
  ans_count = 0;
  for (int i = 0; i < l; i++) {
    int k; scanf("%d", &k); k--;
    paint0(k);
    printf("%d\n", ans_count);
    fflush(stdout);
  }

  return 0;
}
