#include <stdio.h>
#include <stdlib.h>
#include <vector>

using namespace std;

const int MAXN =200000;
const int MAXM =200000;

struct NodeList
{
	int l;
	int r;
	int k;
	//list<NodeTree*> links;
	NodeList();
};

NodeList::NodeList()
{
	this->l=this->r=this->k=0;
}

struct NodeTree
{
	bool val;
	vector<NodeList*> links;
	NodeTree();	
};

NodeTree::NodeTree()
{
	this->val=false;
	this->links.clear();
}

struct RSegQ
{
	static const int k1=1<<18;
	static const int k2=k1*2;
	NodeTree el[k2];
	RSegQ(){};
	bool Get(int l, int r, int L, int R, int x);
	void Update(int x, bool val);
	void AddSeg(int l, int r);
	int FindSegs(int l, int r, int L, int R, int x, NodeList* link);
};

RSegQ q;
int n,m,ans=0;

void RSegQ::AddSeg(int l, int r)
{
	NodeList *t= new NodeList;
	t->l=l, t->r=r;
	t->k = this->FindSegs(l,r,0,this->k1-1,0,t);
}

void Decrem(vector<NodeList*> &links)
{
	for (int i=0; i<links.size(); i++)
		if (links[i]->k>0)
		{
			links[i]->k--;
			if (!links[i]->k)
				ans++;
		}
}

bool RSegQ::Get(int l, int r, int L, int R, int x)
{
	if (r<L || R<l)
		return false;
	else if (l<=L && R<=r)
		return this->el[x].val;
	else
	{
		bool a,b;
		a=this->Get(l,r,L,(L+R)/2,(x+1)*2-1);
		b=this->Get(l,r,(L+R)/2+1,R,(x+1)*2-1+1);
		return (a && b);
	}
}

void RSegQ::Update(int x, bool val)
{
	if (this->el[x].val==val)
		return;
	this->el[x].val=val;
	Decrem(this->el[x].links);	
	x=(x+1)/2-1;
	while (x>=0)
	{
		int l=(x+1)*2-1,r=(x+1)*2;
		bool a=this->el[l].val;
		bool b=this->el[r].val;
		if ( (this->el[x].val)==(a&&b))
			return;
		Decrem(this->el[x].links);
		this->el[x].val=(a&&b);
		x= (x+1)/2-1;
	}	
}

int RSegQ::FindSegs(int l, int r, int L, int R, int x, NodeList* link)
{
	if (r<L || R<l)
		return 0;
	else if (l<=L && R<=r)
	{
		this->el[x].links.push_back(link);
		return 1;
	}
	else
	{
		return this->FindSegs(l,r,L,(L+R)/2,(x+1)*2-1,link) +this->FindSegs(l,r,(L+R)/2+1,R,(x+1)*2-1+1,link);
	}
}

		
int main()
{
	scanf("%d%d", &n, &m);
	for (int i=0; i<m; i++)
	{
		pair<int,int> buf;
		scanf("%d%d", &buf.first, &buf.second);
		buf.first--, buf.second--;
		q.AddSeg(buf.first,buf.second);
	}
	
	for (int i=0; i<n; i++)
	{
		int k;
		scanf("%d", &k);
		k--;
		q.Update(q.k1-1+k,true);
		printf("%d\n",ans);
		fflush(stdout);
	}
}