#include <iostream>
#include <vector>

using namespace std;

const int maxn=11000;

struct edge
{
	int x;
	edge * next;
	bool del;
};

edge* E[maxn];
edge* Erev[maxn];
bool used[maxn];
int col[maxn];
int kol[maxn];
bool mat[maxn][maxn];
int topsort[maxn];
int tssize=0;
int n,m;


void AddEdge(int a, int b)
{
	edge * t = new edge;
	t->x=b;
	t->next=E[a];
	t->del=false;
	E[a]=t;
}

void AddEdgeRev(int a, int b)
{
	edge * t = new edge;
	t->x=b;
	t->next=Erev[a];
	t->del=false;
	Erev[a]=t;
}


void DFSTopSort(int x)
{
	used[x]=true;
	for (edge * t = E[x]; t; t=t->next)
		if (!used[t->x])
			DFSTopSort(t->x);
	topsort[tssize++]=x;
}

void DFScomp(int x, int num)
{
	col[x]=num;
	kol[num]++;
	for (edge*t=Erev[x];t;t=t->next)
		if (!col[t->x])
			DFScomp(t->x,num);
}
		
int main()
{
	for (int i=0; i<maxn; i++)
		E[i]=Erev[i]=0, used[i]=0, col[i]=0, kol[i]=0,topsort[i]=0;
// 	for (int i=0; i<maxn; i++)
// 		for (int j=0; j<maxn; j++)
//                             mat[i][j]=false;
	memset(mat,0,sizeof(mat));
	
	cin >> n >> m;
	
	for (int i=0; i<m; i++)
	{
		int q,w;
		cin >> q >> w;
		q--, w--;
		AddEdge(q,w);
		AddEdgeRev(w,q);
	}
	
	for (int i=0; i<n; i++)
		if (!used[i])
			DFSTopSort(i);
	
	for (int i=0; i<n; i++)
		used[i]=0;
	
	int num =1;
	//for (int j=0; j<n; j++)
	for (int j=n-1; j>=0; j--)
	{
		int i = topsort[j];
		if (!col[i])
			DFScomp(i,num++);
	}
	
	long long ans=0;
	
	for (int i=1; i<=num; i++)
		ans+=kol[i]*kol[i], mat[i][i]=true;
	
	for (int i=0; i<n; i++)
		for (edge*t=Erev[i]; t; t=t->next)
			if (col[i]!=col[t->x] && !mat[col[i]][col[t->x]])
				ans+= kol[col[i]]*kol[col[t->x]]*2,
 				mat[col[i]][col[t->x]]=mat[col[t->x]][col[i]]=true;
				
	cout << ans;
	
}