#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <functional>
#include <math.h>
#include <set>
#include <map>

using namespace std;

const long long base = (1e18 + 0.1);
const long long base2 = (1e9 + 0.1);

struct tlong {
	int a;
 	long long b;
};

tlong operator+ (tlong x, long long y) {
	x.b += y;
	while (x.b >= base) {
		x.a += 1;
		x.b -= base;
	}
	return x;
}

tlong operator+ (tlong x, tlong y) {
	x.a += y.a;
	x.b += y.b;
	while (x.b >= base) {
		x.a += 1;
		x.b -= base;
	}
	return x;
}

tlong operator- (tlong x, long long y) {
	x.b -= y;
	while (x.b < 0) {
		x.a -= 1;
		x.b += base;
	}
	return x;
}

tlong operator- (tlong x, tlong y) {
	x.a -= y.a;
	x.b -= y.b;
	while (x.b < 0) {
		x.a -= 1;
		x.b += base;
	}
	return x;
}

int print (tlong x) {
	if (x.a > 0) printf ("%d%018lld\n", x.a, x.b); else printf ("%lld\n", x.b);
	return 0;
}

pair<int, int> all[100001];
int c[100001], f[100001], d[100001], g[100001], e[100001], x[100001];
int heap[2][100001];
int inheap[2][100001];
int r[2], ct;
long long cs[100001];

long long calc (int k, int i, int t) {
	if (k == 0) return f[i] + cs[t] - cs[i]; else return -(f[i] + cs[t] - cs[i]);
}

int swap (int k, int i, int j) {
	inheap[k][heap[k][i]] = j;
	inheap[k][heap[k][j]] = i;
	int tmp = heap[k][i];
	heap[k][i] = heap[k][j];
	heap[k][j] = tmp;
}

int up (int k, int x) {
	while (x > 1) {
		int y = x / 2;
		if (calc (k, heap[k][y], ct) > calc (k, heap[k][x], ct)) {
			swap (k, x, y);
			x = y;
		} else break;
	}
	return 0;
}

int down (int k, int x) {
	while (1) {
		int y = x * 2;
		int z = x * 2 + 1;
		int nx = x;
		if (y <= r[k] && calc (k, heap[k][y], ct) < calc (k, heap[k][nx], ct)) nx = y;
		if (z <= r[k] && calc (k, heap[k][z], ct) < calc (k, heap[k][nx], ct)) nx = z;
		if (x != nx) {
			swap (k, x, nx); 
			x = nx;
		} else break;
	}
	return 0;
}

int add (int k, int x) {
	r[k]++;
	heap[k][r[k]] = x;
	inheap[k][x] = r[k];
	up (k, r[k]);
}

int del (int k, int x) {
	swap (k, x, r[k]);
	r[k]--;
	if (x <= r[k]) {
		up (k, x);
		down (k, x);
	}
}

tlong ll2tlong (long long x, long long y) {
	tlong z;
	z.a = z.b = 0;
	long long px = x / base2, qx = x - px * base2, py = y / base2, qy = y - py * base2;
	z.a = px * py;
	long long tmp = px * qy + py * qx;
	long long tmp2 = tmp / base2;
	tmp -= tmp2 * base;
	z.a += tmp2;
	z.b = tmp * base2 + qx * qy;
	return z;
}

int main () {
	int n;
	scanf ("%d", &n);
	for (int i = 0; i < n; i++)
		scanf ("%d%d%d", &c[i], &f[i], &d[i]);
	for (int i = 0; i + 1 < n; i++)
		scanf ("%d%d", &g[i], &e[i]);
	g[n - 1] = e[n - 1] = 0;
	cs[0] = 0;
	for (int i = 1; i < n; i++) cs[i] = cs[i - 1] + e[i - 1];
	tlong ans;
	ans.a = ans.b = 0;
	r[0] = r[1] = 0;
	ct = 0;
	long long xall = 0;
	for (int i = 0; i < n; i++) {
		x[i] = c[i];
		xall += c[i];
		ans = ans + (long long)f[i] * c[i];
		add (0, i);
		add (1, i);
		while (r[0] > 0) {
			int j = heap[0][1];
			int tmp = min (d[i], x[j]);
			d[i] -= tmp;
			x[j] -= tmp;
			xall -= tmp;
			if (x[j] == 0) {
				del (0, inheap[0][j]);
				del (1, inheap[1][j]);
			}
			if (d[i] == 0) break;
		}
		if (d[i] != 0) {
			printf ("-1\n");
			return 0;
		}
		g[i] = xall - g[i];
		while (r[0] > 0 && g[i] > 0) {
			int j = heap[1][1];
			int tmp = min (x[j], g[i]);
			g[i] -= tmp;
			x[j] -= tmp;
			xall -= tmp;
			tlong tmp2;
			ans = ans - ll2tlong (calc (0, j, ct), tmp);
			if (x[j] == 0) {
				del (0, inheap[0][j]);
				del (1, inheap[1][j]);
			}
		}
		ans = ans + ll2tlong (xall, e[i]);
		ct++;
	}
	print (ans);
}