#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>

using namespace std;

typedef long long ll;

#ifdef DEBUG
int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  int n, k, p, q;
  while (scanf("%d", &n) != EOF) {
    scanf("%d%d%d", &k, &p, &q);
    int modk = (1 << k) - 1;
    
    vector<int> arr(n);
    vector<int> count(k + 1, 0);
    ll a = 1;
    for (int i = 0; i < n; i++) {
      arr[i] = a;
      a = a * p + q; a &= modk;
    }
    
    for (int i = 0; i < n; i++)
      for (int i2 = 0; i2 < n; i2++) {
        int x = arr[i] + arr[i2];
        for (int off = 0; x; off++, x >>= 1) count[off] += x & 1;
      }
    
    for (int i = 0; i < k + 1; i++) {
      if (i) printf(" ");
      printf("%d", count[i]);
    }
    printf("\n");
  }

  return 0;
}
