#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>

using namespace std;

#define INF 1000000

#ifdef DEBUG
int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  
  int n, m, t;
  vector<int> T;
  while (scanf("%d", &n) != EOF) {
    scanf("%d%d", &m, &t);
    T = vector<int>(t);
    for (int i = 0; i < t; i++) scanf("%d", &T[i]), T[i]--;
    
    vector< vector<int> > d(n, vector<int>(n, INF));
    vector< vector<long long> > cnt(n, vector<long long>(n, 0));
    for (int i = 0; i < m; i++) {
      int a, b;
      scanf("%d%d", &a, &b);
      a--, b--;
      d[a][b] = d[b][a] = 1;
      cnt[a][b] = cnt[b][a] = 1;
    }
    for (int i = 0; i < n; i++) d[i][i] = 0, cnt[i][i] = 1;

    for (int i = 0; i < n; i++)
      for (int j = 0; j < n; j++)
        for (int k = 0; k < n; k++) {
          if (d[j][i] + d[i][k] >= INF) continue;
          cnt[j][k] += cnt[j][i] * cnt[i][k];
          if (d[j][k] > d[j][i] + d[i][k])
            d[j][k] = d[j][i] + d[i][k];
	}
    #ifdef DEBUG
    for (int a = 0; a < n; a++) {
      for (int b = 0; b < n; b++)
        eprintf(" %lld", cnt[a][b]);
      eprintf("\n");
    }
    #endif
            
    int min_ans = INF; long long ans_cnt = 0;
    for (int a = 0; a < t; a++)
      for (int b = a + 1; b < t; b++)
        if (d[T[a]][T[b]] != INF) {
          ans_cnt += cnt[T[a]][T[b]];
          #ifdef DEBUG
          eprintf("%d %d: %lld\n", T[a], T[b], cnt[T[a]][T[b]]);
          #endif
          if (d[T[a]][T[b]] < min_ans)
            min_ans = d[T[a]][T[b]];
        }
    printf("%d %lld\n", min_ans, ans_cnt);
    fprintf(stderr, "\n");
  }

  return 0;
}
