#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int64 inf = (int64)1e18;
const int nmax = 100100;
const int mmax = 501000;
struct edge{
	int v,u,w,n;
	edge(){};
	edge(int v1, int u1, int w1, int n1){
		v = v1;
		u = u1;
		w = w1;
		n = n1;
	};
};

edge e[mmax];
vector<int> g[nmax];
vector<int> res;
int n,m,m1,m2;
int64 cost;
bool used[nmax];
int p[nmax];

void add(int m){
	res.pb(e[m].n);
	cost += e[m].w;
	e[m].w = 0;
	e[m].n = 0;
}

void cant(){
	puts("NO");
	exit(0);
}

void add_stupid(){
	forn(i,m)
		if (e[i].w <= 0 && e[i].n > 0)
			add(i);
}


//--------------------------

vector<int> ts;
vector<int> go[nmax];
int col[nmax];
int color;

void topsort(int v){
	used[v] = true;
	forn(i,g[v].size()){
		edge now = e[g[v][i]];
		if (now.n > 0)continue;
		if (!used[now.u])
			topsort(now.u);
	}
	ts.pb(v);
}

void dfs(int v){
	used[v] = true;
	col[v] = color;
	forn(i,go[v].size())
		if (!used[go[v][i]])
			dfs(go[v][i]);
}

void condence(){
	forn(i,n)
		used[i] = 0;
	forn(i,n)
		if (!used[i])
			topsort(i);
	forn(i,m1)
		go[e[i].u].pb(e[i].v);
	forn(i,n)
		used[i] = 0;
	color = 0;
	ford(i,ts.size())
		if (!used[ts[i]]){
			dfs(ts[i]);
			color++;
		}
	n = color;
	forn(i,n)
		g[i].clear();
	forn(i,m){
		e[i].v = col[e[i].v];
		e[i].u = col[e[i].u];
		if (e[i].v == e[i].u)continue;
		g[e[i].v].pb(i);
	}	
		
}
//----------------------------------------------------

int64 d[nmax];

bool find(int v, int u){
	forn(i,n)
		d[i] = inf;
	d[v] = 0;
	p[v] = -1;
	set < pii > h;
	h.insert(mp(0,v));
	while (h.size() > 0){
		pii q = *h.begin();
		h.erase(h.begin());
		int v = q.sc;
		forn(i,g[v].size()){
			int to = e[g[v][i]].u;
			int w  = e[g[v][i]].w;
			if (d[to] <= d[v] + w)continue;
			if (d[to] < inf)h.erase(mp(d[to],to));
			d[to] = d[v] + w;
			p[to] = g[v][i];
			h.insert(mp(d[to],to));
		}
	}
	if (d[u] == inf)return false;
	int now = u;
	while (now != v){
		int r = p[now];
		if (e[r].n > 0)
			res.pb(e[r].n);
		cost += e[r].w;
		now = e[r].v;
	}
	return true;
}


void make_g(){
	forn(i,m1)
		g[e[i].v].pb(i);
}

void add_int(){
	ts.clear();
	forn(i,n)
		used[i] = 0;
	forn(i,n)
		if (!used[i])
			topsort(i);
	forn(i,n)
		g[i].clear();
	forn(i,m){
		swap(e[i].v,e[i].u);
		if (e[i].v == e[i].u)continue;
		g[e[i].v].pb(i);
	}	
	
	if (!find(ts.back(),ts[0])) cant();
}

void solve(){
	make_g();
	add_stupid();
	condence();
	add_int();
}

void read(){
	scanf("%d %d",&n,&m1);
	m = 0;
	forn(i,m1){
		e[m].n = 0;
		e[m].w = 0;
		scanf("%d %d",&e[m].v,&e[m].u);
		m++;
	}
	scanf("%d",&m2);
	forn(i,m2){
		e[m].n = i + 1;
		scanf("%d %d %d",&e[m].v,&e[m].u,&e[m].w);
		m++;
	}
	forn(i,m){
		e[i].v--;
		e[i].u--;
	}
}
		
void write_ans(){
	puts("YES");
	printf("%lld\n",cost);
	printf("%d\n",res.size());
	sort(all(res));
	forn(i,res.size())
		printf("%d ",res[i]);
	printf("\n");
}

int main(){
/*	freopen("input.txt","rt",stdin);
	freopen("output.txt","wt",stdout);*/
	
	read();
	solve();
	write_ans();
	
	return 0;
}
