#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

int const K=28, N = 102, M = N * K, MOD = 1000000009;
int k, m, b[N], re[N][N], nc[N][N], c[M][M], ft[K][N][N];

void genc() {
	for (int i=0; i<M; i++)
		c[0][i]=c[i][0]=1;
	for (int i=1; i<M; i++)
		for (int j=1; j<M; j++)
			c[i][j]=(c[i-1][j] + c[i][j-1]) % MOD;	
}

int ncus(int m, int k) {
	if (nc[m][k] >= 0) 
		return nc[m][k];
	if (!k) 
		return nc[m][k] = !m;
	long long res = 0;
	for (int i = 1; i <= m; i++)
		res += ncus(m-i, k-1);
	return nc[m][k] = res % MOD;	
}

int fut(int m, int j, int x) {
	if (ft[m][j][x]>=0) 
		return ft[m][j][x];
	long long res=0;
	for (int t=0; t<=x && t<=b[m]-b[m-1]-j; t++) {
		long long p=ncus(b[m]-b[m-1]-j, t), q=c[x-t][t];
		res += p * q % MOD;
	}
	return 	ft[m][j][x] = res % MOD;
}

int rec(int m, int k) {
	if (re[m][k]>=0) 
		return re[m][k];
	if (m==1)
		return re[m][k] = (k ? 0 : 1);
	if (k>b[m-1]) 
		return re[m][k] = 0;
	long long res=0;
	for (int j=0; j<=b[m]-b[m-1]; j++) 
		for (int i=0; i<=j && i<=k && i<=b[m-1]; i++) {
			long long x=ncus(j, i), y=c[b[m-1]-k][i], z=rec(m-1, k-i), p=fut(m, j, k-i+1);	
			res += x * y % MOD * z % MOD * p % MOD;	
// 			for (int t=0; t<=k-i+1 && t<=b[m]-b[m-1]-j; t++) {
// 				long long p=ncus(b[m]-b[m-1]-j, t), q=c[k-i+1-t][t];
// 				res += x * y % MOD * z % MOD * p % MOD * q % MOD;	
// 			}
		}
	return re[m][k] = res % MOD;
}

void read() {
// 	m=5, k=rand()%25+1;
// 	for (int i=1; i<=m; i++) {
// 		b[i]=rand()%3+1;
// 		b[i]+=b[i-1];
// 	}
	cin >> k >> m;
	for (int i=1; i<=m; i++) {
		cin >> b[i];
		b[i]+=b[i-1];
	}
}

int solve() {
	memset(re, -1, sizeof re);
	memset(nc, -1, sizeof nc);
	memset(ft, -1, sizeof ft);
	return rec(m, k);
}

int stup() {
	int c[12], res=0;
	for (int i=1; i<=m; i++)
		for (int j=b[i-1]; j<b[i]; j++)
			c[j]=i;
	do {
		int cr=0;
		for (int i=1; i<b[m]; i++)
			if (c[i-1]>c[i]) cr++;
		if (cr==k) res++;
	}
	while(next_permutation(c, c+b[m]));
	return res;
}
		
int main () {
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);	
	genc();
// 	for (int x=0; x<=1000; x++) {
// 		read();
// 		if (b[m]<=10) {
// 			if(stup() != solve()){
// 				cerr << "err" << endl;
// 				return 0;
// 			}
// 		}
// 	}	
	read();
	if (b[m]<=10) cout << stup() << endl; 
	else cout << solve() << endl;
// 	cerr << clock() << endl;
	return 0;
} 
