#include <iostream>
#include <vector>
#include <algorithm>
#include <stdlib.h>

using namespace std;

const int maxn=100100;

struct edge
{
	int b,x,w;
	int id;
	edge* next;	
};

edge* E[maxn];
edge* Erev[maxn];
vector<int> topsort;
vector<edge> E2;
vector<int> ans;
bool used[maxn];
int col[maxn];
int n,m1,m2;

void AddEdge(int a, int b, int w)
{
	edge * t = new edge;
	t->x=b;
	t->w=w;
	t->b=-1;
	t->id=-1;
	t->next=E[a];
	E[a]=t;
}

void AddEdgeRev(int a, int b, int w)
{
	edge * t = new edge;
	t->x=b;
	t->w=w;
	t->b=-1;
	t->id=-1;
	t->next=Erev[a];
	Erev[a]=t;
}

void DFSTopSort(int x)
{
	used[x]=true;
	for (edge* t = E[x];t;t=t->next)
		if (!used[t->x])
			DFSTopSort(t->x);
	
	topsort.push_back(x);
}

void DFSComp(int x, int color)
{
	col[x]=color;
	for (edge* t = Erev[x];t;t=t->next)
		if (!col[t->x])
			DFSComp(t->x,color);
}

bool operator< (const edge a, const edge b)
{
	return (a.w<b.w);
}

int CompCount()
{
	for (int i=0; i<n; i++)
		used[i]=false, col[i]=0;
	topsort.clear();
	
	for (int i=0; i<n; i++)
		if (!used[i])
			DFSTopSort(i);
	
	int colnum=1;
	
	for (int j=topsort.size()-1; j>=0; j--)
	{
		int i = topsort[j];
		if (!col[i])
			DFSComp(i,colnum++);
	}
	return colnum-1;	
}

int main()
{
	for (int i=0; i<n; i++)
		E[i]=Erev[i]=0;
	ans.clear();
		
	cin >> n >> m1;
	
	for (int i=0; i<m1; i++)
	{
		int x,y,w=0;
		cin >> x >> y;
		x--,y--;
		AddEdge(x,y,w);
		AddEdgeRev(y,x,w);
	}
	
	cin >> m2;
	for (int i=0; i<m2; i++)
	{
		edge buf;
		buf.next=0;
		cin >> buf.b >> buf.x >> buf.w;
		buf.b--, buf.x--; buf.id=i;
		E2.push_back(buf);
	}
	
	sort(E2.begin(),E2.end());
	
	long long sumw=0;
	
	
	if (CompCount()==1)
	{
		cout << "YES" << endl;
		cout << sumw << endl;
		cout << ans.size() << endl;
		for (int i=0; i<ans.size(); i++)
			cout << ans[i]+1 << ' ';
		return 0;
	}
	
	
	for (int i=0; i<E2.size(); i++)
	{
		int a = E2[i].b, b=E2[i].x, w=E2[i].w;
		
		if (col[a]!=col[b])
		{
			AddEdge(a,b,w);
			AddEdgeRev(b,a,w);
			ans.push_back(E2[i].id);
			sumw+=w;
			if (CompCount()==1)
			{
				cout << "YES" << endl;
				cout << sumw << endl;
				cout << ans.size() << endl;
				for (int i=0; i<ans.size(); i++)
					cout << ans[i]+1 << ' ';
				return 0;
			}
		}
	}
	cout << "NO";
}