#include <cstdio>
#include <string>

using namespace std;

const int di[4] = {0, 1, 0, -1};
const int dj[4] = {1, 0, -1, 0};

char w[3001];
bool g[3001][3001];
bool was[3001][3001];
int d[3001][3001];
int qi[9000001], qj[9000001];
int f[6002][6002];
int n, m, ans, ai, aj, ax;

int calc (int i, int j, int x) {
	return f[i + x][j + x] - f[i - x - 1][j + x] - f[i + x][j - x - 1] + f[i - x - 1][j - x - 1];
}

int check (int i, int j, int x) {
	int tmp = calc (i + j + 1, i - j + m + 1, x);
	if (tmp > ans) {
		ans = tmp;
		ai = i;
		aj = j;
		ax = x;				
	}
	return 0;
}

int main () {
	scanf ("%d%d\n", &n, &m);
	memset (f, 0, sizeof (f));
	for (int i = 0; i < n; i++) {
		scanf ("%s", w);
		for (int j = 0; j < m; j++) {
			g[i][j] = (w[j] == '*');
			if (g[i][j]) f[i + j + 1][i - j + m + 1] = 1;
		}
	}
	for (int i = 1; i <= n + m + 1; i++)
		for (int j = 1; j <= n + m + 1; j++)
			f[i][j] += f[i - 1][j] + f[i][j - 1] - f[i - 1][j - 1];
	memset (was, false, sizeof (was));
	int r = 0, l = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			if (g[i][j]) {
				bool tmp = 0;
				if (i > 0) tmp |= g[i - 1][j];
				if (j > 0) tmp |= g[i][j - 1];
				if (i + 1 < n) tmp |= g[i + 1][j];
				if (j + 1 < m) tmp |= g[i][j + 1];
				if (tmp) {
					was[i][j] = true;
					d[i][j] = 0;
					qi[r] = i;
					qj[r++] = j;
				}
			}
			if (!was[i][j] && (i == 0 || i + 1 == n || j == 0 || j + 1 == m)) {
				was[i][j] = true;
				d[i][j] = 0;
				qi[r] = i;
				qj[r++] = j;
			}
		}
	ans = 0;
	while (l < r) {
		int i = qi[l];
		int j = qj[l++];
		int x = d[i][j];
		check (i, j, x);
		for (int k = 0; k < 4; k++) {
			int ni = i + di[k], nj = j + dj[k];
			if (ni >= 0 && nj >= 0 && ni < n && nj < m && !was[ni][nj]) {
				was[ni][nj] = 1;
				d[ni][nj] = x + 1;
				qi[r] = ni;
				qj[r++] = nj;
			}
		}
	}
	printf ("%d %d %d %d\n", ans, aj + 1, ai + 1, ax);
}