#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>

using namespace std;

#ifdef DEBUG
int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

vector< vector<bool> > field;

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  int w, h;
#ifdef DEBUG
  while (scanf("%d", &h) != EOF) {
#else
    scanf("%d", &h);
#endif
    scanf("%d\n", &w);
    field = vector< vector<bool> >(h, vector<bool>(w));

    for (int y = 0; y < h; y++) {
      string s;
      getline(cin, s);
      for (int x = 0; x < w; x++) field[y][x] = (s[x] == '*');
    }
    
    int bn = 0, bcx = 0, bcy = 0, br = 0;
    
    for (int y = 0; y < h; y++) {
      int curn = !!field[y][0], r = 0;
      for (int x = 0; x < w;) {
        eprintf("%d %d %d\n", x, y, r);
        if (bn < curn) { bn = curn; bcx = x; bcy = y; br = r; }
        if (x + 1 >= w) break;
        
        enum Act { move = 0, up = 1, down = -1 } act;
        int ax, ay;
        
        if (x + r + 1 < w) {
          if (r) {
            bool good = true;
            ax = x + 1, ay = y - r;
            for (; ay < y; ay++, ax++) {
              good = good && !(field[ay][ax] && field[ay][ax - 1]);
              good = good && !(field[ay][ax] && field[ay + 1][ax]);
            }
            good = good && !(field[ay][ax] && field[ay][ax - 1]); ay++, ax--;
            for (; ax >= x + 1; ay++, ax--) {
              good = good && !(field[ay][ax] && field[ay][ax - 1]);
              good = good && !(field[ay][ax] && field[ay - 1][ax]);
            }
          
            if (good) { // We can move our romb :)
              bool good = false;
              if ((y - r - 1 >= 0) && (y + r + 1 < h) &&
                  (x + r + 2 < w)) {
                good = true;
                ax = x + 1, ay = y - r - 1;
                good = good && !(field[ay][ax] && field[ay + 1][ax]); ay++, ax++;
                for (; ay < y; ay++, ax++) {
                  good = good && !(field[ay][ax] && field[ay][ax - 1]);
                  good = good && !(field[ay][ax] && field[ay - 1][ax]);
                }
                good = good && !(field[ay][ax] && field[ay][ax - 1]); ay++, ax--;
                for (; ax > x + 1; ay++, ax--) {
                  good = good && !(field[ay][ax] && field[ay][ax - 1]);
                  good = good && !(field[ay][ax] && field[ay - 1][ax]);
                }
                good = good && !(field[ay][ax] && field[ay - 1][ax]);
              }
              if (good) act = up;
              else act = move;
            } else
              act = down;
	  } else {
	    if ((y - 1 >= 0) && (y + 1 < h) &&
	        (x + 2 < w) &&
	        !(field[y][x + 1] && field[y][x]) &&
	        !(field[y][x + 1] && field[y - 1][x + 1]) &&
	        !(field[y][x + 1] && field[y][x + 2]) &&
	        !(field[y][x + 1] && field[y + 1][x + 1]) ) act = up;
	    else act = move;
	  }
        } else act = down;
        eprintf("@%d\n", act);
        switch (act) {
        case up:
          r++, x++;
          ax = x, ay = y - r;
          for (; ay < y; ay++, ax++) curn += !!field[ay][ax];
          for (; ax >= x; ay++, ax--) curn += !!field[ay][ax];
          break;
        case down:
          ax = x, ay = y - r;
          for (; ay < y; ay++, ax--) curn -= !!field[ay][ax];
          for (; ax <= x; ay++, ax++) curn -= !!field[ay][ax];
          r--, x++;
          break;
	case move:
          ax = x, ay = y - r;
          for (; ay < y; ay++, ax--) curn -= !!field[ay][ax];
          for (; ax <= x; ay++, ax++) curn -= !!field[ay][ax];
          x++;
          ax = x, ay = y - r;
          for (; ay < y; ay++, ax++) curn += !!field[ay][ax];
          for (; ax >= x; ay++, ax--) curn += !!field[ay][ax];
          break;
        }
      }
    }
    
    printf("%d %d %d %d\n", bn, bcx + 1, bcy + 1, br);
#ifdef DEBUG
  }
#endif

  return 0;
}
