#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;

const int inf = (1 << 30) - 1;

const int nmax = 3010;
int n, m;
char c[nmax][nmax];
bool u[nmax][nmax];
int s[nmax][nmax], s1[nmax][nmax], spd[nmax][nmax], spu[nmax][nmax];
int dx[4] = {0, 0, -1, 1};
int dy[4] = {-1, 1, 0, 0};
int ar, ax, ay, an;

int check (int x, int y)
{
	if (!c[x][y])
		return 0;
	int res = 0;
	forn (i, 4)
		res += c[x+dx[i]][y+dy[i]];
	return res;
}

int calc (int x, int y, int r)
{
	int x1 = x - r;
	int x2 = x + r;
	int y1 = y - r;
	int y2 = y + r;
	if (s1[x][y2] + s1[x][y1] - s1[x1][y] - s1[x2][y])
		return -1;
// 	cerr << x1 << " " << x2 << " " << y1 << " " << y2 << endl;	
// 	cerr << s[x][y2] << " " << s[x][y1-1] << endl;	
// 	cerr << spd[x1+1][y2-1] << " " << spu[x-1][y1-1] << endl;
	return s[x][y2] + s[x][y1-1] - s[x2][y-1] - s[x1][y-1] 
	      - spd[x2+1][y-1] - spu[x1-1][y-1];	
}

void findbin (int x, int y, int l, int r)
{
	if (l > r)
		return;
	while (l < r)
	{
		int mid = (l + r + 1) >> 1;
		int rs = calc (x, y, mid);
		if (rs == -1)
			r = mid - 1;
		else
			l = mid;	
	}
	int rs = calc (x, y, r);
	if (rs > an)
	{
		an = rs;
		ax = x;
		ay = y;
		ar = r;
	}
}

void go (int x, int y)
{
	if (y <= 0 || y > m || x < -1 || x > n+2)
		return;
	if (u[x][y])
		return;
	go (x-1, y-1);
	go (x+1, y-1);
	go (x, y-2);	
	u[x][y] = 1;
	if (x == 1)
	{
		s[x][y] = s[x+1][y-1];
		s1[x][y] = s1[x+1][y-1];
		spd[x][y] = spd[x+1][y-1];
		return;
	}
	if (x == n+2)
	{
		s[x][y] = s[x-1][y-1];
		s1[x][y] = s1[x-1][y-1];
		spu[x][y] = spd[x-1][y-1];
		return;
	}
	int ts = s[x-1][y-1] + s[x+1][y-1];
	if (y - 2 >= 0)
		ts -= s[x][y-2];
	s[x][y] = ts + (int)c[x][y] + (int)c[x][y-1];	
			
	ts = s1[x-1][y-1] + s1[x+1][y-1];
	if (y - 2 >= 0)
		ts -= s1[x][y-2];
	s1[x][y] = ts + check (x,y-1);	
	spd[x][y] = spd[x+1][y-1] + (int)c[x][y];
	spu[x][y] = spu[x-1][y-1] + (int)c[x][y];
}

int check_slow (int x, int y, int r)
{
	if (x-r <= 1 || y-r <= 0 || x+r > n+1 || y+r > m)
		return -1;
	int res = 0;	
	for (int i = 1; i <= n+1; i ++)
		for (int j = 1; j <= m; j ++)
			if (abs (x-i) + abs (y-j) <= r)
				res += (int)c[i][j];	
	for (int i = 1; i <= n+1; i ++)
		for (int j = 1; j <= m; j ++)
			forn (k, 4)
				if (abs (x-i) + abs (y-j) <= r && abs (x-i-dx[k]) + abs (y-j-dy[k]) <= r && c[i][j] && c[i+dx[k]][j+dy[k]])
					return -1;
	return res;			
}

int main ()
{	
// 	freopen ("c.in", "r", stdin);
// 	freopen ("c.out", "w", stdout);
	scanf ("%d%d", &n, &m);
	seta (c, 0);
	forn (i, n)
		forn (j, m)
		{
			char ch;
			scanf (" %c ", &ch);
			if (ch == '*')
				c[i+2][j+1] = 1;
		}	
	seta (s, 0);
	seta (u, 0);
	seta (s1, 0);
	seta (spd, 0);
	seta (spu, 0);
	for (int i = 1; i <= n+2; i ++)
		for (int j = 1; j <= m; j ++)
			go (i, j);
	ar = 0;
	int st = 0;
	forn (i, n)
		forn (j, m)
			if (c[i+2][j+1])
			{
				ax = i+2;
				ay = j+1;
				an = 1;
				st ++;
			}	
//  	for (int i = 1; i <= n; i ++)
//  	{
//  		for (int j = 1; j <= m; j ++)
//  			cerr << calc (i+1, j, 1) << " ";
//  		cerr << endl;	
//  	}	
	if (st == 0)
	{
		printf ("0 1 1 0\n");
		return 0;
	}		
	for (int x = 1; x <= n; x ++)
		for (int y = 1; y <= m; y ++)
			findbin (x+1, y, 1, min (min (x-1, y-1), min (n-x, m-y)));
// 	int ok_res = 0;
// 	forn (i, n)
// 		forn (j, m)
// 			forn (k, n)
// 				ok_res = max (ok_res, check_slow (i+2,j+1, k));		
	printf ("%d %d %d %d\n", an, ay, ax-1, ar);		
// 	cerr << ok_res << endl;
// 	assert (check_slow (ax, ay, ar) == an);
// 	assert (ok_res == an);
	return 0;
}
