#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 250;
const int inf = (int)1e9;

int c[nmax][nmax];
int f[nmax][nmax];
int h[nmax], e[nmax];
int l[nmax];
int n,m,mflow,res;
bool used[nmax];

void push(int v, int u){
	if (h[v] <= h[u])return;
	int add = min(e[v],c[v][u]-f[v][u]);
	f[v][u] += add;
	f[u][v] -= add;
	e[v] -= add;
	e[u] += add;
}

void up(int v){
	while (l[v] < n){
		if (e[v] == 0)return;
		push(v,l[v]);
		l[v]++;
	}
	h[v] ++;
	l[v] = 0;
}

int flow(int t){
	forn(i,n)
		forn(j,n)
			f[i][j] = 0;
	forn(i,n)
		h[i] = e[i] = l[i] = 0;
	h[0] = n+1;
	e[0] = inf;
	forn(i,n)
		push(0,i);
	while(1){
		int pos = -1;
		forn(i,n)
			if ((pos == -1 || h[pos] < h[i]) && e[i] > 0 && i != t && i != 0)
				pos = i;
		if (pos == -1)break;
		up(pos);
	}
	return e[t];
}	

void go(int v, int &now){
	now++;
	used[v] = true;
	forn(i,n)
		if (c[v][i]-f[v][i] > 0 && !used[i])
			go(i,now);
}

void solve(){	
	int pos = 0;
	mflow = inf;
	forn(i,n){
		if(!i)continue;
		forn(j,n)
			used[j] = 0;
		int q = flow(i);
		int now = 0;
		go(0,now);
		if (now % 2 == 0)continue;				
 		if (q < mflow){
			mflow = q;
			pos = i;
		}
	}
		
	
	mflow = flow(pos);
	forn(i,n)
		used[i] = 0;
	go(0,pos);
}

void read(){
	cin >> n >> m;
	forn(i,m){
		int u,v,w;
		cin >> u >> v >> w;
		u--;
		v--;
		c[v][u]+=w;
		c[u][v]+=w;
	}
}

void write(){
	vector<int> res;
	forn(i,n)
		if(used[i])
			res.pb(i+1);
	cout << mflow << endl;
	cout << res.size() << endl;
	forn(i,res.size())
		cout << res[i] << " ";
	cout << endl;
}

int main(){
//   	freopen("input.txt","rt",stdin);
//   	freopen("output.txt","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
