#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>

using namespace std;

#ifdef DEBUG
int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif


inline int bsrch(vector<int> &v, int val) {
  if (!v.size()) return -1;
  if (val < v[0]) return -1;
  if (v[v.size() - 1] <= val) return v.size() - 1;
  
  int l = 0, r = v.size();
  while (l + 1 < r) {
    int m = (l + r) >> 1;
    if (v[m] <= val) l = m;
    else r = m;
  }
  #if DEBUG
  for (int i = 0; i < v.size(); i++)
    if (val < v[i]) { assert(l == i - 1); return i - 1; }
  assert(l == v.size() - 1); return v.size() - 1;
  #else
  return l;
  #endif
}

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  string p;
  getline(cin, p);
  while (p.size() && (p[0] == '*')) p = string(p, 1);
  while (p.size() && (p[p.size() - 1] == '*')) p = string(p, 0, p.size() - 1);
  
  vector<string> pp;
  if (p.size()) {
    pp = vector<string>(1, "");
    for (int i = 0; i < p.size(); i++) {
      if (p[i] == '*') {
        if (pp[pp.size() - 1] != "") pp.push_back("");
      } else
        pp[pp.size() - 1] += p[i];
    }
  }
  
  string s;
  getline(cin, s);
  
  int cur_ans = 0;
  vector<int> matches[3];
  vector<int> cnt[3], depends[3];
  if (pp.size()) {
    for (int i = 0; i < pp.size(); i++)
      for (int i2 = 0; i2 < s.size(); i2++) {
        int i3 = 0;
        while ((i2 + i3 < s.size()) && (i3 < pp[i].size()))
          if (s[i2 + i3] == pp[i][i3]) i3++;
          else break;
        if (i3 == pp[i].size()) matches[i].push_back(i2);
      }
    for (int i = 0; i < pp.size(); i++)
      cnt[i] = vector<int>(matches[i].size()),
      depends[i] = vector<int>(matches[i].size(), 0);
    bool good = true;
    for (int i = 0; i < pp.size(); i++)
      if (!matches[i].size()) { good = false; break; }
    if (good) {
      for (int i2 = matches[0].size() - 1; i2 >= 0; i2--)
        depends[0][i2] = 1;
      for (int i = 0; i + 1 < pp.size(); i++) {
        int ppsz = pp[i].size(), msz = matches[i].size();
        for (int i2 = msz - 1; i2 >= 0; i2--) {
          int tof = matches[i][i2] + ppsz;
          int l = bsrch(matches[i + 1], tof);
          
          if ((l < 0) || (matches[i + 1][l] != tof)) l++;
          for (; l < matches[i + 1].size(); l++)
            depends[i + 1][l] += depends[i][i2];
        }
      }
      
      int n = s.size();
      int i = pp.size() - 1;
      for (int i2 = matches[i].size() - 1; i2 >= 0; i2--) {
        cnt[i][i2] = 1;
        cur_ans += cnt[i][i2] * depends[i][i2];
      }
    }
    eprintf("%d\n", cur_ans);
    return 0;
  }
  
  int K; scanf("%d", &K);
  for (int I = 0; I < K; I++) {
    char op, ch; int k;
    scanf(" %c %c %d", &op, &ch, &k);
    switch (op) {
    case '+': s = s.insert(k, 1, ch); break;
    case '-': s = s.erase(k, 1); break;
    }
    
    
    if (!pp.size())
      printf("%d\n", (s.size() * (s.size() - 1)) >> 1);
    else {
      printf("%d\n", cur_ans);
    }
  }
  return 0;
}
