#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>

using namespace std;

#ifdef DEBUG
int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

#define eq(a, b) ( ((a) == (b)) || ((a) == '?') || ((b) == '?') )


inline int bsrch(vector<int> &v, int val) {
  if (!v.size()) return -1;
  if (val <= v[0]) return 0;
  if (v[v.size() - 1] < val) return v.size();
  
  int l = 0, r = v.size();
  while (l + 1 < r) {
    int m = (l + r) >> 1;
    if (v[m] < val) l = m;
    else r = m;
  }
  
  #ifdef DEBUG
  for (int i = 0; i < v.size(); i++)
    if (val <= v[i]) { assert(r == i); return i; }
  #endif
  return r;
}

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  string p;
  getline(cin, p);
  while (p.size() && (p[0] == '*')) p = string(p, 1);
  while (p.size() && (p[p.size() - 1] == '*')) p = string(p, 0, p.size() - 1);
  
  vector<string> pp;
  if (p.size()) {
    pp = vector<string>(1, "");
    for (int i = 0; i < p.size(); i++) {
      if (p[i] == '*') {
        if (pp[pp.size() - 1] != "") pp.push_back("");
      } else
        pp[pp.size() - 1] += p[i];
    }
  }
  
  string s;
  getline(cin, s);
  int K; scanf("%d", &K);
  for (int I = 0; I < K; I++) {
    char op, ch; int k;
    scanf(" %c", &op);
    switch (op) {
    case '+': scanf(" %c %d", &ch, &k); s = s.insert(k, 1, ch); break;
    case '-': scanf(" %d", &k); s = s.erase(k, 1); break;
    }
    
    vector<int> matches[3];
    vector<int> cnt[3];
    for (int i = 0; i < pp.size(); i++)
      for (int i2 = 0; i2 < s.size(); i2++) {
        int i3 = 0;
        while ((i2 + i3 < s.size()) && (i3 < pp[i].size()))
          if (eq(s[i2 + i3], pp[i][i3])) i3++;
          else break;
        if (i3 == pp[i].size()) matches[i].push_back(i2);
      }
    for (int i = 0; i < pp.size(); i++) cnt[i] = vector<int>(matches[i].size());
    bool good = true;
    for (int i = 0; i < pp.size(); i++) {
      if (!matches[i].size()) {
        printf("0\n"); fflush(stdout);
        good = false; break;
      }
    }
    if (!good) continue;
    if (pp.size()) {
      int n = s.size();
      int i = pp.size() - 1;
      
      cnt[i][matches[i].size() - 1] = 1;
      for (int i2 = matches[i].size() - 2; i2 >= 0; i2--)
        cnt[i][i2] = cnt[i][i2 + 1] + 1;
        
      for (i--; i >= 0; i--) {
        int ppsz = pp[i].size(), msz = matches[i].size();
        for (int i2 = msz - 1; i2 >= 0; i2--) {
          cnt[i][i2] = (i2 + 1 < msz) ? cnt[i][i2 + 1] : 0;
          for (int i3 = 0; i3 < cnt[i + 1].size(); i3++) {
            int tof = matches[i][i2] + ppsz;
            int r = bsrch(matches[i + 1], tof);
            
            cnt[i][i2] = (i2 + 1 < msz) ? cnt[i][i2 + 1] : 0;
            if (r < matches[i + 1].size())
              cnt[i][i2] += cnt[i + 1][r];
          }
        }
      }
      printf("%d\n", cnt[0][0]);
    } else {
      printf("%d\n", (s.size() * (s.size() - 1)) >> 1);
    }
    fflush(stdout);
  }
  return 0;
}
