#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <set>
#include <assert.h>

using namespace std;

#ifdef DEBUG
int eoffset = 0;
int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}

int eoprintf(const char* format, ...) {
  for (int i = 0; i < eoffset; i++) eprintf(" ");
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int n;
vector<int> a, sta;
vector<int> perm;

bool dfs(int st, int cur_pos, int pip) {
  if (pip >= sta[cur_pos]) cur_pos++, pip = 0;
  #ifdef DEBUG
  eoprintf("dfs(%d, %d, %d)\n", st, cur_pos, pip);
  #endif
  if (cur_pos >= n) return true;
  
  #ifdef DEBUG
  eoffset += 2;
  #endif
  for (int i = 0; i < n; i++)
    if (a[i] && (i != cur_pos)) {
      perm[st] = i; a[i]--;
      if (dfs(st + 1, cur_pos, pip + 1)) return true;
      a[i]++;
    }
  #ifdef DEBUG
  eoffset -= 2;
  eoprintf(":(\n");
  #endif
  return false;
}

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

#ifdef DEBUG
  while (scanf("%d", &n) != EOF) {
#else
    scanf("%d", &n);
#endif
    a = vector<int>(n);
    sta  = vector<int>(n);
    int sum = 0;
    for (int i = 0; i < n; i++) scanf("%d", &sta[i]), a[i] = sta[i], sum += sta[i];
    assert(a[1]);
    perm = vector<int>(sum, -1);
    
    int k; scanf("%d", &k);
    vector< pair<int, int> > ls(k);
    for (int i = 0; i < k; i++)
      scanf("%d%d", &ls[i].first, &ls[i].second), ls[i].first--, ls[i].second--;
    
    if (dfs(0, 0, 0)) {
      printf("Ok\n");
      for (int i = 0; i < k; i++) {
        bool first = true;
        for (int i2 = ls[i].first; i2 <= ls[i].second; i2++)
          printf("%s%d", first ? "" : " ", perm[i2] + 1), first = false;
        printf("\n");
      }
    } else
      printf("Bad luck\n");
#ifdef DEBUG
  }
#endif
  return 0;
}
