#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 550000;

struct edge{
	int d,l1,l2,s1,s2;
	edge(){};
};

bool ls(edge a, edge b){
	return a.d > b.d;
}

int n;
vector<string> s;
vector<edge> a;
vector<int> p;
int64 cost;
vector<edge> res;

int calc(int v){
	if (v == p[v]) return v;
	return p[v] = calc(p[v]);
}

void join(int a, int b){
	a = calc(a);
	b = calc(b);
	if (rand() & 1)
		p[a] = b;
	else 
		p[b] = a;
}

edge dist(const string &a, const string &b, int p1, int p2){
	edge res;
	res.s1 = p1+1;
	res.s2 = p2+1;
	res.d = res.l1 = res.l2 = 0;
	forn(i,a.size())
		forn(j,b.size()){
			int now = 0;
			while (i + now <(int) a.size() && j + now < (int)b.size() && a[i+now] == b[j+now])
				now++;
			if (res.d < now){
				res.d = now;
				res.l1 = i+1;
				res.l2 = j+1;
			}
		}
	return res;
}

void read(){
	scanf("%d\n",&n);
	s.resize(n);
	p.resize(n);
	forn(i,n)
		getline(cin,s[i]);
}

void solve(){
	forn(i,n)
		p[i] = i;
	forn(i,n)
		forn(j,i)
			a.pb(dist(s[i],s[j],i,j));
	sort(all(a),ls);
	forn(i,a.size())
		if (calc(a[i].s1) != calc(a[i].s2)){
			res.pb(a[i]);
			cost += a[i].d;
			join(a[i].s1,a[i].s2);
		}
}

void write(){
	cout << cost << endl;
	forn(i,res.size())
		printf("%d %d %d %d %d\n",res[i].s1,res[i].s2,res[i].l1,res[i].l2,res[i].d);
}

int main(){
//     	freopen("input.txt","rt",stdin);
//     	freopen("output.txt","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
