#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <vector>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back
#define sz(a) (int)(a).size()

typedef unsigned long long ll;

const int mlen = (int)1e6 + 1;
const int maxn = 500000;
const int P = 23917;

struct edge
{
  int i, j, pi, pj, len;
};

int n, mpos = 0, len[maxn], p[maxn];
char mem[mlen], *s[maxn];

ll sum = 0;
int en = 0;
edge ans[maxn];

int size[maxn], pr[maxn];

int Get( int v )
{
  return pr[v] == v ? pr[v] : (pr[v] = Get(pr[v]));
}

void Join( int i, int j )
{
  i = Get(i), j = Get(j);
  if (size[i] < size[j])
    swap(i, j);
  size[i] += size[j], pr[j] = i;
}

bool pless( int i, int j )
{
  return len[i] > len[j];
}

const int maxh = 1000003;
const int maxe = (int)1e7;

int cc = 0;
int used[maxh], head[maxh];
ll ha[maxh];
vector <int> list;

int e, next[maxe], ind[maxe], pos[maxe];

int Hash( ll h )
{
  int i = h % maxh;
  while (used[i] == cc && ha[i] != h)
    if (++i == maxh)
      i = 0;
  if (used[i] != cc)
  {
    used[i] = cc, ha[i] = h;
    head[i] = -1;
    list.pb(i);
  }
  return i;
}

int main()
{
  scanf("%d ", &n);
  forn(i, n)
  {
    gets(s[i] = mem + mpos);
    mpos += (len[i] = strlen(s[i])) + 1;
  }
  forn(i, n)
    size[i] = 1, pr[i] = i;

  forn(i, n)
    p[i] = i;
  sort(p, p + n, pless);

  for (int l = len[p[0]]; l > 0; l--)
  {
    ll tmp = 1;
    forn(i, l - 1)
      tmp *= P;
    cc++;
    list.clear();
    e = 0;
      
    for (int i = 0; i < n && len[p[i]] >= l; i++)
    {
      char *t = s[p[i]];
      int tn = len[p[i]];
      ll h = 0;
      forn(j, l)
        h = h * P + t[j];
      forn(j, tn - l + 1)
      {
        int ha = Hash(h);
        next[e] = head[ha], ind[e] = i, pos[e] = j, head[ha] = e++;
        h = (h - tmp * t[j]) * P + t[j + l];
      }
    }

    forn(i, sz(list))
    {
      int h = list[i];

      int is = 0;
      for (int it1 = head[h]; it1 != -1; it1 = next[it1])
        if (next[it1] != -1 && Get(ind[it1]) != Get(ind[next[it1]]))
        {
          is = 1;
          break;
        }
      if (!is)
        continue;
      
      for (int it1 = head[h]; it1 != -1; it1 = next[it1])
        for (int it2 = head[h]; it2 != it1; it2 = next[it2])
          if (Get(ind[it1]) != Get(ind[it2]))
          {
            Join(ind[it1], ind[it2]);
            ans[en].i = ind[it1], ans[en].pi = pos[it1];
            ans[en].j = ind[it2], ans[en].pj = pos[it2];
            ans[en++].len = l;
            sum += l;
          }
    }
  }

  printf("%Ld\n", sum);
  forn(i, en)
    printf("%d %d %d %d %d\n", ans[i].i + 1, ans[i].j + 1, ans[i].pi + 1, ans[i].pj + 1, ans[i].len);
  return 0;
}
