#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 500000;

struct edge{
	int d,l1,l2,s1,s2;
	edge(){};
};

bool ls(edge a, edge b){
	return a.d > b.d;
}

int n;
vector<string> s;
vector<edge> a;
vector<int> p;
int64 cost;
vector<edge> res;
string now;
edge d[nmax];
int z[nmax];

int calc(int v){
	if (v == p[v]) return v;
	return p[v] = calc(p[v]);
}

void join(int a, int b){
	a = calc(a);
	b = calc(b);
	if (rand() & 1)
		p[a] = b;
	else 
		p[b] = a;
}

edge dist(const string &a, const string &b, int p1, int p2){
	edge res;
	res.s1 = p1+1;
	res.s2 = p2+1;
	res.d = res.l1 = res.l2 = 0;
	forn(i,a.size())
		forn(j,b.size()){
			int now = 0;
			while (i + now <(int) a.size() && j + now < (int)b.size() && a[i+now] == b[j+now])
				now++;
			if (res.d < now){
				res.d = now;
				res.l1 = i+1;
				res.l2 = j+1;
			}
		}
	return res;
}

edge calc_dist(int i, int j){
	edge res;
	res.s1 = i+1;
	res.s2 = j+1;
	res.d = -1;
	string a = s[i];
	string b = s[j];
	string now;
	forn(j,a.size()){
		now = a.substr(j,(int)a.size()-j);
		now = now + '#' + b;
		forn(i,now.size())
			z[i] = 0;
		int l,r;
		l = 0;
		r = -1;
// 		cerr << now << endl;
		for (int i = 1; i < (int)now.size(); i++){
			if (i <= r) z[i] = min(r-i+1,z[i-l]);
			while (i + z[i] < (int)now.size() && now[i+z[i]] == now[z[i]])
				z[i]++;
			if (i + z[i] > r){
				l = i;
				r = i + z[i]-1;
			}
//  			cerr << z[i] << " ";
		}
//   		cerr << endl;
		int pos = -1,dl;
		forn(i,now.size()){
			if (now[i] == '#'){
				pos++;
				dl = 0;
			}
			if (pos < 0)continue;
			if (res.d < z[i]){
				res.d = z[i];
				res.l1 = j+1;
				res.l2 = dl;
			}
			dl++;
		} 
	}
	return res;
}
	
	

void read(){
	scanf("%d\n",&n);
	s.resize(n);
	p.resize(n+10);
	forn(i,n)
		getline(cin,s[i]);
}

void solve(){
	forn(i,n+10)
		p[i] = i;
	forn(i,n)
		forn(j,n)
			a.pb(calc_dist(i,j));
	sort(all(a),ls);
//	exit(0);
	forn(i,a.size())
		if (calc(a[i].s1) != calc(a[i].s2)){
			res.pb(a[i]);
			cost += a[i].d;
			join(a[i].s1,a[i].s2);
		}
}


void write(){
	cout << cost << endl;
	forn(i,res.size())
		printf("%d %d %d %d %d\n",res[i].s1,res[i].s2,res[i].l1,res[i].l2,res[i].d);
}

int main(){
//       	freopen("input.txt","rt",stdin);
//       	freopen("output.txt","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
