#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <algorithm>
#include <vector>
#include <iostream>

using namespace std;

const int mul = 5;
const int mod =16777216;

struct Node
{
	//int num;
	int l,r;
	int hash;
};

typedef vector<Node> VecNode;

struct HashTable
{
	vector<VecNode> el;
	HashTable()
	{
		this->el.clear();
	}
	
	void Resize(int size)
	{
		this->el.resize(size+1);
	}

	void Add(int l,int r,int hash)
	{
		Node buf;
		buf.l=l; buf.r=r; buf.hash=hash;
		int len = r-l+1;
		this->el[len].push_back(buf);
	}
	
	Node Find(int len, int hash)
	{
		Node G;
		G.l=G.r=-1;
		for (VecNode::iterator i = this->el[len].begin(); i!=this->el[len].end(); i++)
			if (i->hash==hash)
				return (*i);
		return G;
	}
};

struct DSU
{
	vector<int> p;
	int kol;
	DSU(int size)
	{
		this->p.resize(size);
		for (int i=0; i<this->p.size(); i++)
			this->p[i]=i;
		this->kol=size;
	}
	int Get(int x)
	{
		if (this->p[x]!=x)
			return this->p[x]=Get(this->p[x]);
		return x;
	}
	
	void Union(int x,int y)
	{
		x= this->Get(x), y=this->Get(y);
		
		if (x==y)
			return;
		this->kol--;
		if (rand()&1)
			p[x]=y;
		else
			p[y]=x;
	}
};

struct edge
{
	int a, b;
	int posa, posb;
	int len;
};

int step(int a, int x)
{
	int b=1;
	
	while (x>0)
		if (x%2==0)
		{
			x/=2;
			a=a*a;
		}
		else
		{
			x--;
			b=b*a;
		}
	return b;
}

bool operator< (const edge a, const edge b)
{
	return a.len<b.len;
}

int Mod(int x, int mod)
{
 	return ((x%mod+mod)%mod);
}
vector<string> strs;
vector<HashTable> h;
vector<edge> E;
vector<edge> ans;
int n;

int main()
{
	strs.clear();
	h.clear();
	
// 	scanf("%d", &n);
	cin >> n;		
	
 	DSU snm(n);
	
	strs.resize(n);
	h.resize(n);
	
	for (int i=0; i<n; i++)
	{
// 		char str[100000];
// 		scanf("%s",&str);
// 		printf("%s\n", strs[i]);
		cin >> strs[i];
// 		strs[i] = str;
		h[i].Resize(strs[i].length());
	}
	
	for (int i=0; i<n; i++)
		for (int l=1; l<=strs[i].length(); l++)
		{
			int hash=0;
			
			for (int j=0; j<l; j++)
				hash=Mod(Mod(hash*mul,mod)+strs[i][j],mod);
			h[i].Add(0,l-1,hash);
			
// 			cout << "////////////////";
//  			cout << hash << endl;
			
			for (int j=l; j<strs[i].length(); j++)
				{
					hash = Mod(Mod(Mod(hash-Mod(strs[i][j-l]*step(mul,l-1),mod),mod)*mul,mod)+strs[i][j],mod);
					h[i].Add(j-l+1,j,hash);
//  					cout << "////////////////";
//  					cout << hash << endl;
				}
		}	
		
	for (int i=0; i<n; i++)
		for (int j=i+1; j<n; j++)
		{
			bool f = false;
			for (int len=min(strs[i].length(),strs[j].length()); (len>0) && (!f); len--)
				for (int q=0; ((q<h[i].el[len].size()) && (!f)); q++)
				{
					Node buf = h[j].Find(len,h[i].el[len][q].hash);
					if (buf.l!=-1)
					{
						edge ed;
						ed.a=i,ed.b=j,ed.posa=h[i].el[len][q].l;
						ed.posb=buf.l, ed.len=buf.r-buf.l+1;
						E.push_back(ed);
						f=true;
					}
				}
		}
			
	sort(E.begin(),E.end());
	
	long long sum=0;
	
	for (int i=E.size()-1; i>=0 && snm.kol>1; i--)
	{
		if (snm.Get(E[i].a)!=snm.Get(E[i].b))
		{
			sum+=E[i].len;
			ans.push_back(E[i]);
			snm.Union(E[i].a,E[i].b);
		}
	}
	
// 	printf("%d\n", sum);
	cout << sum << endl;
	for (int i=0; i<ans.size(); i++)
// 		printf("%d %d %d %d %d\n", ans[i].a+1, ans[i].b+1, ans[i].posa+1, ans[i].posb+1, ans[i].len);
		cout << ans[i].a+1 << ' ' << ans[i].b+1<< ' ' << ans[i].posa+1<< ' ' << ans[i].posb+1<< ' ' << ans[i].len << endl;
		
}