#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define l first
#define r second
#define pb push_back
#define mp make_pair

const int nmax = 110000;

struct ver{
	int l,r,m,p;
	int add;
	ver(){
		add = 0;
	};
	ver(int l1, int r1){
		l = l1;
		r = r1;
	};
};

pii a[nmax];
int n,m,k;
int tr[nmax];
int res[nmax];
int sum;
vector<int> qw;

ver t[nmax*4];

void build(int v, int l, int r){
	t[v].m = t[v].p = 0;
	if (l == r){
		t[v].p = t[v].l = t[v].r = qw[l-1];
		return;
	}
	int m = (l + r) / 2;
	build(v*2,l,m);
	build(v*2+1,m+1,r);
	t[v].l = t[v].p = t[v*2].l;
	t[v].r = t[v*2+1].r;
}

void push(int v){
	if (t[v].add == 0) return;
	t[v].m += t[v].add;
	t[v*2].add += t[v].add;
	t[v*2+1].add += t[v].add;
	t[v].add = 0;
}	

void update(int v, int l, int r, int c){
	push(v);
	if (t[v].l > r || t[v].r < l) return;
	if (l <= t[v].l && t[v].r <= r){
		t[v].add = c;
		push(v);
		return;
	}
	update(v*2,l,r,c);
	update(v*2+1,l,r,c);
	int e;
	if (t[v*2].m >= t[v*2+1].m)
		e = v*2;
	else
		e = v * 2 +1;
	t[v].m = t[e].m;
	t[v].p = t[e].p;
}

void solve(){
	sum = 0;
	forn(j,k){
		vector<pii> b;
		forn(i,n)
			if (res[i] == 0){
				b.pb(mp(a[i].l,-1));
				b.pb(mp(a[i].r,1));
			}
		sort(all(b));
		int pos = 0;
		int best = 0;
		int now = 0;
		forn(i,b.size()){
			now -= b[i].r;
			if (now > best){
				pos = b[i].l;
				best = now;
			}
		}
		tr[j] = pos;
		now = 0;
		forn(i,n)
			if (res[i] == 0 && now < m && a[i].l <= pos && pos <= a[i].r){
				now ++;
				sum++;
				res[i] = j+1;
			}
	}
}

void solve_tree(){
	forn(i,n){
		qw.pb(a[i].l);
		qw.pb(a[i].r);
	}
	sort(all(qw));
	qw.erase(unique(all(qw)), qw.end());
	int sz = 1;
	while (sz < (int)qw.size())
		sz *= 2;
	qw.resize(sz);
	build(1,1,sz);
			
	forn(i,n)
		update(1,a[i].l,a[i].r,1);
	sum = 0;
	forn(j,k){
		int pos = t[1].p;
		tr[j] = pos;
		int now = 0;
		forn(i,n)
			if (res[i] == 0 && now < m && a[i].l <= pos && pos <= a[i].r){
				update(1,a[i].l,a[i].r,-1);
				now ++;
				sum++;
				res[i] = j+1;
			}
	}
}
				
			

void read(){
	scanf("%d %d %d",&n,&m,&k);
	forn(i,n)
		scanf("%d %d",&a[i].l,&a[i].r);
}

void write(){
	cout << sum << endl;
	forn(i,k)
		printf("%d ",tr[i]);
	printf("\n");
	forn(i,n)
		printf("%d ",res[i]);
	printf("\n");
}

int main(){
//   	freopen("input.txt","rt",stdin);
//   	freopen("output.txt","wt",stdout);
	
	read();
	solve_tree();
	write();
	
	return 0;
}
