#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 2500;

struct point{
	real x,y;
	point(){};
	point (real x1, real y1){
		x = x1;
		y = y1;
	};
};

point operator+(point a, point b){
	return point(a.x+b.x,a.y+b.y);
}

point operator-(point a, point b){
	return point(a.x-b.x,a.y-b.y);
}

point operator*(point a, real b){
	return point(a.x*b,a.y*b);
}

point operator*(real b, point a){
	return point(a.x*b,a.y*b);
}

struct line{
	real a,b,c;
	line(){};
	line(real a1, real b1, real c1){
		a = a1;
		b = b1;
		c = c1;
	};
	line(point v, point u){
		a = u.y - v.y;
		b = v.x - u.x;
		c = - a*v.x - b*v.y;
	};
};

real dist(line a, point b){
	real now, d;
	now = a.a*b.x + a.b*b.y + a.c;
	d = sqrt(a.a*a.a + a.b*a.b);
	return fabsl(now/d);
}

real dist(point a, point b){
	return sqrt((a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y));
}


real res = 0.0;
int n;
point p[nmax];


void solve(){
	for(int i = 0; i < n; i++)
		for (int j = i + 2; j < n; j++){
			int l = i+1;
			int r = j-1;
			line l1 = line(p[i],p[j]);
			while (l < r){
				int m1,m2,t;
				t = (r-l)/3;
				m1 = l + t;
				m2 = m1 + t;
				if (m1 == m2)m2++;
				real r1 = dist(l1,p[m1]);
				real r2 = dist(l1,p[m2]);
				if (r1 < r2)
					l = m1+1;
				else
					r = m2-1;
			}
			res = max(res,dist(p[i],p[j]) * dist(l1,p[l]));
// 			cerr << i << " " << j << " " << l << " " << dist(l1,p[l]) << endl;
		}
}

void read(){
	scanf("%d",&n);
	forn(i,n){
		double x,y;
		scanf("%lf %lf",&x,&y);
		p[i] = point(x,y);
	}
}

void write(){
	res /= 2.0;
	printf("%0.9lf\n",(double) res);
}

int main(){
//       	freopen("input.txt","rt",stdin);
//        	freopen("output.txt","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
