#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>
#include <set>
#include <map>

using namespace std;

#ifdef DEBUG
int eoffset = 0;

int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
int eoprintf(const char* format, ...) {
  for (int i = 0; i < eoffset; i++) fprintf(stderr, " ");
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

struct ver {
  string name;
  vector<ver*> childs;
  ver* par;
  
  ver() { par = 0; }
};

struct ver_int {
  int dat;
  map<string, ver_int*> childs;
  ver_int* par;
  
  ver_int() { par = 0; }
  ver_int(int _dat) { par = 0; dat = _dat; }
};

int n;
vector<ver_int> arr;
ver g_vers;

ver ver_mem[100000]; int ver_mem_pos;
ver_int ver_int_mem[100000]; int ver_int_mem_pos;

#ifdef DEBUG
void dbgprint(ver &v) {
  eoprintf("I am %s\n", v.name.c_str());
  eoffset += 2;
  for (int i = 0; i < v.childs.size(); i++) {
    assert(v.childs[i]);
    assert(v.childs[i]->par == &v);
    dbgprint(*v.childs[i]);
  }
  eoffset -= 2;
}
#endif

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

#ifdef DEBUG
  while (scanf("%d", &n) != EOF) {
#else
    scanf("%d", &n);
#endif
    arr = vector<ver_int>(n, ver_int(0));

    map<string, ver* > vers;
    
    int k;
    char buf[11]; scanf(" %s %d", buf, &k);
    g_vers = ver();
    g_vers.name = buf;
    vers.insert(make_pair(buf, &g_vers));
    #ifdef DEBUG
    dbgprint(g_vers);
    #endif
    
    ver_mem_pos = 0; ver_int_mem_pos = 0;
    for (int i = 0;  i < k; i++) {
      char com; int field, newval;
      char v1[11]; char v2[11];
      scanf(" %c %s %d", &com, v1, &field);
        
      vector<string> cid;
      ver *cver = vers.find(v1)->second;
      for (ver *_i = cver; _i; _i = _i->par)
        cid.push_back(_i->name);
      
      ver_int *cvver = &arr[field];
      for (int i = cid.size() - 1; i >= 0; i--) {
        map<string, ver_int*>::iterator it = cvver->childs.find(cid[i]);
        if (it != cvver->childs.end())
          cvver = it->second;
      }
      
      switch (com) {
      case 'S':
        scanf(" %d %s", &newval, v2);
        {
          ver_int *nver = &ver_int_mem[ver_int_mem_pos++];
          *nver = ver_int(newval);
          nver->par = cvver;
          cvver->childs.insert(make_pair(v2, nver));
        }
        
        {
          ver *nver = &ver_mem[ver_mem_pos++];
          *nver = ver();
          nver->name = v2;
          nver->par = cver;
          cver->childs.push_back(nver);
          vers.insert(make_pair(v2, cver->childs[cver->childs.size() - 1]));
        }
        #ifdef DEBUG
        dbgprint(g_vers);
        #endif
        break;
      case 'G':
        printf("%d\n", cvver->dat); fflush(stdout);
        break;
      }
    }
    
    
#ifdef DEBUG
  }
#endif
  return 0;
}
