#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int nmax = 110000;

struct tree{
	tree *l,*r;
	string v;
	int z,y;
};

typedef tree* ptree;

ptree t[nmax];

ptree new_node(string &key, int zn, int y){
	ptree q = new tree;
	q->v = key;
	q->y = y;
	q->z = zn;
	q->l = 0;
	q->r = 0;
	return q;
}

void split(ptree &v, string &key, ptree &l, ptree &r){
	if (v == 0){
		l = r = 0;
		return;
	}
	if (v->v <= key){
		l = v;
		split(l->r,key,l->r,r);
	}else{
		r = v;
		split(r->l,key,l,r->l);
	}
}

ptree add(ptree &v, string &key, int zn, int y){
	if (v == 0)
		return new_node(key,zn,y);
	
	if (v->y < y){
		ptree l,r,q;
		split(v,key,l,r);
		q = new_node(key,zn,y);
		q->l = l;
		q->r = r;
		return q;
	}
	if (v->v <= key)
		v->r = add(v->r,key,zn,y);
	else
		v->l = add(v->l,key,zn,y);
	return v;
}

bool find(ptree t, string &key,int &res){
	if (t == 0)
		return 0;
	if (t->v == key){
		res = t->z;
		return true;
	}
	if (t->v > key)
		return find(t->l,key,res);
	if (t->v < key)
		return find(t->r,key,res);
	assert(0);
}

void print(ptree v){
	if (v == 0)return;
	print(v->l);
	cout << v->v << " ";
	print(v->r);
}



int n,k;

string s[nmax];
int pr[nmax];
int m = 1;
vector< pair<int,string> > last;

int main(){
//    	freopen("input.txt","rt",stdin);
//    	freopen("output.txt","wt",stdout);
	
	string v,w;
/*	char l[20],*r;*/
	int q,p;

	
	scanf("%d\n",&n);
	getline(cin,s[0]);
	last.pb(mp(0,s[0]));
	t[n] = add(t[n],s[0],0,rand()*rand());
	scanf("%d",&k);
	forn(i,k){
		char tip;
		scanf(" %c",&tip);
		if (tip == 'S'){
			cin >> v;
			scanf("%d %d",&p,&q);
			cin >> w;
			s[m] = w;
			forn(j,last.size())
				if (last[j].sc == v){
					pr[m] = last[j].fs;
					last[j] = mp(m,w);
					break;
				}
			t[p] = add(t[p],w,q,rand()*rand());
			t[n] = add(t[n],w,m,rand()*rand());
			m++;
			continue;
		}
		cin >> v;
		scanf("%d",&p);
		int nom;
		assert(find(t[n],v,nom));
		int res;
		bool ans = false;
		while (nom > 0){
			if (find(t[p],s[nom],res)){
				ans = true;
				printf("%d\n",res);
// 				fflush(stdout);
				break;
			}
			nom = pr[nom];
		}
		if (!ans){
			printf("0\n");		
		}
		fflush(stdout);
	}
	return 0;
}
