#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>
#include <math.h>

using namespace std;

#define abs(x) (((x) < 0) ? -(x) : (x))

#ifdef DEBUG
int eoffset = 0;

int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
int eoprintf(const char* format, ...) {
  for (int i = 0; i < eoffset; i++) fprintf(stderr, " ");
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int n;
vector<int> x, y;

int tsrch(int a, int b, double A, double B, double C) {
  if (a > b) return -1;
  if (a == b) return a;

  double coff = 1;
  if (x[a] * A + y[a] * B + C > 0) coff = -1;
  
  while (a + 2 < b) {
    int m1 = a + (b - a) / 3, m2 = a + 2 * (b - a) / 3;
    double v1 = x[m1] * A + y[m1] * B + C,
           v2 = x[m2] * A + y[m2] * B + C;
    v1 *= coff; v2 *= coff;
    if (v1 <= v2) a = m1;
    else b = m2;
  }
  
  double minv; int mini = -1;
  for (int i = a; i <= b; i++) {
    double v = x[i] * A + y[i] * B + C;
    v *= coff;
    if ((mini < 0) || (minv > v)) { minv = v; mini = i; }
  }
  return mini;
}

double dist(double x1, double y1, double x2, double y2) {
  return sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));
}

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

#ifdef DEBUG
  while (scanf("%d", &n) != EOF) {
#else
    scanf("%d", &n);
#endif
    x = vector<int>(n << 1);
    y = vector<int>(n << 1);
    for (int i = 0; i < n; i++) scanf("%d%d", &x[i], &y[i]);
    
    for (int IT = 0; IT < 3; IT++) {
    n = 2000;
    x = vector<int>(n << 1);
    y = vector<int>(n << 1);
    for (int i = 0; i < n; i++) x[i] = i, y[i] = i * i;
    
    for (int i = 0; i < n; i++) x[i + n] = x[i], y[i + n] = y[i];
    
    double best_ans = 0;
    for (int a = 0; a < n; a++)
      for (int b = a + 1; b < n; b++) {
        double A, B, C;
        A = y[b] - y[a];
        B = x[a] - x[b];
        C = -x[a] * A - y[a] * B;
        
        int c; double h, cans;
        
        c = tsrch(a + 1, b - 1, A, B, C);
        if (c >= 0) {
          h = abs(A * x[c] + B * y[c] + C) / sqrt(A * A + B * B);
          cans = dist(x[a], y[a], x[b], y[b]) * h / 2;
          if (cans > best_ans) best_ans = cans;
        }
        
        c = tsrch(b + 1, a + n - 1, A, B, C);
        if (c >= 0) {
          h = abs(A * x[c] + B * y[c] + C) / sqrt(A * A + B * B);
          cans = dist(x[a], y[a], x[b], y[b]) * h / 2;
          if (cans > best_ans) best_ans = cans;
        }
      }
    printf("%.3lf\n", best_ans);
    }

#ifdef DEBUG
  }
#endif

  return 0;
}
