#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>

using namespace std;

#ifdef DEBUG
int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  int n;
  scanf("%d", &n);
  vector< pair<int, int> > reqs(n);
  int need_len = 0;
  
  vector<long long> lens(46);
  lens[0] = 1; lens[1] = 2;
  for (int i = 2; i < lens.size(); i++) lens[i] = lens[i - 1] + lens[i - 2];
  
  for (int i = 0; i < n; i++) {
    scanf("%d%d", &reqs[i].first, &reqs[i].second),
    reqs[i].first--,
    reqs[i].second += reqs[i].first - 1;
    
    int i2 = 0;
    for (; lens[i2] < reqs[i].second; i2++);
    while (true) {
      if (i2 && (lens[i2 - 1] <= reqs[i].first))  {
        reqs[i].first -= lens[i2 - 1], reqs[i].second -= lens[i2 - 1],
        i2--;
      } else
        break;
    }
    
    need_len = max(need_len, reqs[i].second);
  }

  string prev = "0", cur = "01";
  while (cur.size() < need_len) {
    cur.swap(prev);
    cur = prev + cur;
  }
  
  for (int i = 0; i < n; i++) {
    int a = reqs[i].first, b = reqs[i].second;
    bool good = true;
    for (; a < b; a++, b--)
      if (cur[a] != cur[b]) { good = false; break; }
    printf(good ? "TAK\n" : "NIE\n");
  }
  

  return 0;
}
