#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

const int inf = (1 << 30) - 1;
const int minf = 1 << 31;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

struct rec
{
	int pos, ver, q;
	rec () {pos = ver = q = 0;}
	rec (int a, int b, int c)
	{
		pos = a;
		ver = b;
		q = c;
	}
};

struct node
{
	rec w;
	int y;
	node *l, *r;
};
typedef node* pnode;


bool operator < (rec p1, rec p2)
{
	if (p1.pos != p2.pos)
		return p1.pos < p2.pos;
	else
	if (p1.ver != p2.ver)
		return p1.ver > p2.ver;
	else
		return p1.q < p2.q;		
}

bool operator <= (rec p1, rec p2)
{
	if (p1.pos != p2.pos)
		return p1.pos < p2.pos;
	else
	if (p1.ver != p2.ver)
		return p1.ver > p2.ver;
	else
		return p1.q <= p2.q;		
}

map <string, int> F;
node T[2001000];
node *S[20];
int n, m, num[100100], d[100100], p[100100], lst;
int POS[100100], Q[100100];
char c[12];

void split (pnode v, pnode &l, pnode &r, rec q)
{
	if (v == NULL)
	{
		l = NULL;
		r = NULL;
		return;
	}
	if (v->w < q)
	{
		l = v;
		split (v->r, l->r, r, q);
	}
	else
	{
		r = v;
		split (v->l, l, r->l, q);
	}
}

pnode merge (pnode l, pnode r)
{
	if (l == NULL)
		return r;
	if (r == NULL)
		return l;
	if (l->y < r->y)
	{
		l->r = merge (l->r, r);
		return l;
	}
	else
	{
		r->l = merge (l, r->l);
		return r;
	}		
}

pnode newnode (rec q)
{
	lst ++;
	T[lst].w = q;
	T[lst].l = T[lst].r = NULL;
	T[lst].y = rand();
	return &T[lst];
}

void insert (pnode &v, rec q)
{
	pnode l, r, t = newnode (q);
	split (v, l, r, q);
	v = merge (l, t);
	v = merge (v, r);
}

pnode find (pnode v, rec q)
{
	if (v == NULL)
		return NULL;
	if (v->w < q)
		return find (v->r, q);	
	pnode res = find (v->l, q);
	if (res == NULL)
		res = v;
	return res;	
}

int read ()
{
	seta (c, 0);
	scanf (" %s", c);
	string st = c;
	if (!F.count(st))
	{
		m ++;
		F[st] = m;
	}
	return F[st];
}

int main ()
{	
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.out", "w", stdout);
	srand (53453);
	lst = -1;
	seta (d, 0);
	m = 0;
	int x;
	F.clear ();
	forn (i, 20)
		S[i] = NULL;
	scanf ("%d", &x);
	read ();
	seta (num, 255);
	num[1] = 0;
	int op;
	scanf ("%d", &op);
	int list = 0;
	seta (p, 255);
	forn (i, op)
	{
		char c1;
		scanf (" %c", &c1);
		if (c1 == 'S')
		{
			int v = read ();
			int pos, q;
			scanf ("%d%d", &pos, &q);
			int u = read ();
			p[u] = v;
			POS[u] = pos;
			Q[u] = q;
			if (d[v] > 0)
			{
				list ++;
				num[u] = list;
				for (int j = v; j > 0; j = p[j])
					insert (S[num[u]], rec (POS[j], j, Q[j]));
			}
			else
				num[u] = num[v];
			d[v] ++;
			insert (S[num[u]], rec (pos, u, q));	
		}
		else
		{
			int v = read ();
			int pos;
			scanf ("%d", &pos);
			pnode it = find (S[num[v]], rec (pos, v, minf));
			if (it == NULL)
				printf ("0\n");
			else
			if (it->w.pos != pos)
				printf ("0\n");
			else	
				printf ("%d\n", it->w.q);
			fflush (stdout);		
		}
	}
	return 0;
}
