#include <iostream>
#include <string>

using namespace std;

const int maxlen=2000;
const int p=57;
		
string sp="0";
string s="01";
unsigned int HLR[maxlen], HRL[maxlen];
int n;
bool iscalc=false;

int step(int a, int x)
{
	int b=1;
	
	while (x>0)
		if (x%2==0)
	{
		x/=2;
		a=a*a;
	}
	else
	{
		x--;
		b=b*a;
	}
	return b;
}

int HashLR(int l,int r)
{
	if (r==0)
		return HLR[0];
	return HLR[r]-HLR[l-1]*step(p,r-l+1);
}

int HashRL(int l, int r)
{
	if (l==s.length()-1)
		return HRL[l];
	return HRL[l]-HRL[r+1]*step(p,r-l+1);
}

bool IsPalin(int l, int r)
{
	int lmod=l%13;
	int rmod=r%13;
	
	if (l>=r)
		return true;
	
	int ones[5]={1,4,6,9,12};
	bool f1=false,f2=false;
	for (int i=0; i<5 && !f1; i++)
		f1=(lmod==ones[i]);
		
	for (int i=0; i<5 && !f2; i++)
		f2=(rmod==ones[i]);
	
	if ((f1&&f2) || ((!(f1)) && (!(f2))))
		return IsPalin(l+1,r-1);
	else
		return false;
}

void calc()
{
	unsigned int hash=0;
	for (int i=0; i<s.length(); i++)
		HLR[i]=hash=hash*p+s[i];
	
	hash=0;
	for (int i=s.length()-1; i>=0; i--)
		HRL[i]=hash=hash*p+s[i];
	iscalc=true;
}

	string ns;
int main()
{
	for (int i=0; s.length()<maxlen;i++)
		ns=s+sp, sp=s, s=ns;
	
// 	int kn=0;
// 	for (int i=0; i<s.length(); i++)
// 		if (s[i]=='0')
// 			kn++;
// 		else
// 		{
// 			cout << kn << endl;
// 			kn=0;
// 		}
	
	cin >> n;
	
	for (int i=0; i<n; i++)
	{
		int l,r,len;
		cin >> l >> len;
		l--;
		r=l+len-1;
		
		if ((l>=s.length())||(r>=s.length()))
			if (IsPalin(l,r))
				cout << "TAK" << endl;
			else
				cout << "NIE" << endl;
		else
		{
			if (!iscalc)
				calc();
			if (HashLR(l,r)==HashRL(l,r))
				cout << "TAK" << endl;
			else
				cout << "NIE" << endl;
		}
	}
}