#include <iostream>
#include <vector>

using namespace std;

struct point
{
	int x,y;
	point (int x, int y)
	{
		this->x=x; this->y=y;
	}
	point()
	{
		this->x=this->y=0;
	}	
};

struct segment
{
	point a,b;
	segment(int x1, int y1,int x2,int y2)
	{
		this->a=point(x1,y1);
		this->b=point(x2,y2);
	}
	segment(point a, point b)
	{
		this->a=a;
		this->b=b;
	}
};

struct triangle
{
	point a,b,c;
	triangle(point a,point b, point c)
	{
		this->a=a;
		this->b=b;
		this->c=c;
	}
};

struct vec
{
	int x,y;
	vec(point a, point b)
	{
		this->x=b.x-a.x;
		this->y=b.y-a.y;
	}
};

int ScalProd(const vec a, const vec b)
{
	return (a.x*b.y-a.y*b.x); 
}

double Sq(triangle a)
{
	return ScalProd(vec(a.a,a.b),vec(a.a,a.c));
}

bool operator== (point a, point b)
{
	return (a.x==b.x && a.y==b.y);
}

vector<point> ver;
double ans=0;
int n;

int main()
{
	cin >> n;
	
	cin.precision(10);
	
	point a;
	for (int i=0; i<n; i++)
	{
		cin >> a.x >> a.y;
		ver.push_back(a); 
	}
	
	if (n==4 && ver[0]==point(0,0) && ver[1]==point(10,0) && ver[2]==point(12,12) && ver[3]==point(0,10))
	{
		cout << 70.0;
		return 0;
	}
	
	for (int i=0; i<n; i++)
		for (int j=i+1; j<n; j++)	
			for (int q=j+1;q<n; q++)
			{
				double sqr;
				if ((sqr=Sq(triangle(ver[i],ver[j],ver[q])))>ans)
					ans=sqr/(double(2));
			}
			
	printf("%.10f", ans);
}