#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long int64;
typedef pair<int64,int64> pii;
typedef long double real;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 40;
const int64 NEED = (int64) 1e9;
const int tmax = 15000;
const int ALL = 2*(int)1e6;

int64 s[nmax*2];
int n = 40;
int tuk = 1000;

int gen_c(int64 x, int64 y){
	if (y == 0) return 0;
	if (y == 1) return x;
	if (x < s[y-1])
		return gen_c(x,y-1);
	else
		return gen_c(x-s[y-1],y-2);
}

void pre_calc(){
	s[0] = 1;
	s[1] = 2;
	
	for (int i = 2; i < nmax+5; i++)
		s[i] = s[i-1] + s[i-2];
}

bool full_solve(int l, int r){
	bool eq = true;
	while (l < r){
		if (gen_c(l,n) != gen_c(r,n)){
			eq = false;
			break;
		}
		l ++;
		r --;
	}
	return eq;
}	

bool fun_solve(int l, int r){
	bool eq = true;
	forn(i,tuk){
		int now = rand();
		now = now % ((r-l+1)/2);
		int l1,r1;
		l1 = l + now;
		r1 = r - now;
		if (gen_c(l1,n) != gen_c(r1,n)){
			eq = false;
			break;
		}
	}
	return eq;
}

int tst;
int l[tmax];
int r[tmax];


int main(){
      	freopen("input.txt","rt",stdin);
      	freopen("output.txt","wt",stdout);
 	
	pre_calc();
	
	int tst;
	cin >> tst;
	
	tuk = ALL / tst;
	
	forn(i,tst){
		int l1,len1;
		scanf("%d %d",&l1,&len1);
		l[i] = l1-1;
		r[i] = l[i] + len1 -1;
	}
		
	forn(i,tst){
		bool eq = true;
		
		if (r[i]-l[i]+1 <= tuk)
			eq = full_solve(l[i],r[i]);
		else
			eq = fun_solve(l[i],r[i]);
		if (eq)
			puts("TAK");
		else
			puts("NIE");
	}
	
	
	return 0;
}
