#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <functional>

using namespace std;

#define PB push_back
#define MP make_pair

const char allcards[9] = {'6', '7', '8', '9', 'T', 'J', 'Q', 'K', 'A'};

char w[10];
char g[10];
char trump;
int last, mva, mvb, cur, r, istake;
int ingame[4];
vector<pair<char, char> > cards[4];
pair<pair<char, char>, pair<char, char> > table[1000];

int erase (int i, pair<char, char> a) {
	int ii = -1;
	for (int j = 0; j < cards[i].size (); j++)
		if (cards[i][j] == a) {
			cards[i].erase (cards[i].begin () + j);
			return 0;
		} else 
		if (cards[i][j].first == '?') ii = j;
	cards[i].erase (cards[i].begin () + ii);
	return 0;
}

int getmove (int cur) {
	if (ingame[cur]) mva = cur; else mva = (cur + 2) % 4;
	if (ingame[(cur + 1) % 4]) mvb = (cur + 1) % 4; else mvb = (cur + 3) % 4;
	return 0;
}

int cost (pair<char, char> cur) {
	int tmp = 0;
	for (int i = 0; i < 9; i++)
		if (cur.first == allcards[i]) tmp = i + 1;
	if (cur.second == trump) tmp += 5;
	return tmp;
}

int myless (pair<char, char> a, pair<char, char> b) {
	if (b.second == trump && a.second != trump) return 1;
	if (b.second != a.second) return 0;
	int aa = 0, bb = 0;
	for (int i = 0; i < 9; i++) {
		if (a.first == allcards[i]) aa = i + 1;
		if (b.first == allcards[i]) bb = i + 1;
	}
	if (aa < bb) return 1;
	return 0;
}

int can (pair<char, char> a) {
	for (int i = 0; i < r; i++)
		if (a.first == table[i].first.first || a.first == table[i].second.first) return 1;
	return 0;
}

int print_all () {
	for (int i = 0; i < 4; i++) {
		printf ("player #%d: ", i + 1);
		if (ingame[i]) {
			for (int j = 0; j < cards[i].size (); j++)
				printf ("%c%c ", cards[i][j].first, cards[i][j].second);
		} else printf ("not in game");
		printf ("\n");
	}
	for (int i = 0; i < r; i++)
		printf ("%c%c - %c%c\n", table[i].first.first, table[i].first.second, table[i].second.first, table[i].second.second);
	printf ("Current move: %d  (%d -> %d)\n", cur + 1, mva + 1, mvb + 1);
	printf ("\n");
}

int main () {
	for (int i = 0; i < 4; i++) ingame[i] = 1;
	scanf ("%s %c", w, &trump);
	last = -1;
	r = istake = 0;
	int round = 0;
	cur = -1;
	while (true) {
		scanf (" %s", w);
//		printf ("%s\n", w);
		string ws = string (w);
		if (ws == "give") {
			if (round == 1) {
				cur = (cur + 1 + istake) % 4;
				istake = 0;
				r = 0;
				round = 0;
				getmove (cur);
			}
			int a;
			scanf ("%d %s", &a, g); a--;
			if (a == 0 && g[0] == '?') return 0;
			cards[a].PB (MP (g[0], g[1]));
		} else
		if (ws == "move") {
			round = 1;
			int a, b;
			scanf ("%d %d %s", &a, &b, g); a--; b--;
			if (b != mvb) {
				if (cur == -1) cur = a; else {
					cur = (cur + 1 + istake) % 4;
					getmove (cur);
				}
				istake = 0;
				r = 0;
			}			
			erase (a, MP (g[0], g[1]));
			table[r].first = MP (g[0], g[1]);
			table[r++].second = MP (0, 0);
		} else 
		if (ws == "add") {
			int a, b;
			scanf ("%d %d %s", &a, &b, g); a--; b--;
			erase (a, MP (g[0], g[1]));
			if (istake) cards[b].PB (MP (g[0], g[1])); else {
				table[r].first = MP (g[0], g[1]);
				table[r++].second = MP (0, 0);
			}
		} else
		if (ws == "beat") {
			int a;
			scanf ("%d %s", &a, g); a--;
			erase (a, MP (g[0], g[1]));
			table[r - 1].second = MP (g[0], g[1]);
		} else 
		if (ws == "take") {
			istake = 1;
			int a;
			scanf ("%d", &a); a--;
			for (int i = 0; i < r; i++) {
				cards[a].PB (table[i].first);	
				if (table[i].second.first != 0) cards[a].PB (table[i].second);
			}
		} else
		if (ws == "out") {
			int a;
			scanf ("%d", &a); a--;
			ingame[a] = 0;
			if (a == 0) return 0;
		} else
		if (ws == "MOVE") {
			if (round == 1 && mva != 0) {
				r = 0;
				round = 0;
				cur = (cur + 1 + istake) % 4;
				getmove (cur);
				istake = 0;
			}
			round = 1;
			pair<char, char> cc;
			cc.first = cc.second = 0;
			for (int i = 0; i < cards[0].size (); i++)
				if ((r == 0 || r > 0 && can (cc)) && (cc.first == 0 || cost (cc) > cost (cards[0][i]))) cc = cards[0][i];
			printf ("%c%c\n", cc.first, cc.second);
			fflush (stdout);
		} else 
		if (ws == "BEAT") {
			pair<char, char> cc;
			cc.first = cc.second = 0;
			for (int i = 0; i < cards[0].size (); i++)
				if (myless (table[r - 1].first, cards[0][i]) && (cc.first == 0 || cost (cc) > cost (cards[0][i]))) cc = cards[0][i];
//			printf ("%c%c < %c%c = %d\n", table[r]);
			if (cc.first == 0) printf ("NO\n"); else printf ("%c%c\n", cc.first, cc.second);
			fflush (stdout);
		} else 
		if (ws == "ADD") {
			pair<char, char> cc;
			cc.first = cc.second = 0;
			for (int i = 0; i < cards[0].size (); i++)
				if (can (cards[0][i]) && (cc.first == 0 || cost (cc) > cost (cards[0][i]))) cc = cards[0][i];
			if (mvb % 2 == 0 || cc.first == 0) printf ("NO\n"); else printf ("%c%c\n", cc.first, cc.second);
			fflush (stdout);
		}
//		print_all ();
	}
}