#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

int convert(char x){
	if (isdigit(x))
		return x - '0';
	if (x == 'T')
		return 10;
	if (x == 'J')
		return 11;	
	if (x == 'Q')
		return 12;
	if (x == 'K')
		return 13;
	if (x == 'A')
		return 14;
	return 0;
}


struct game{
	char name,trump;
	int cost;
	game(){};
	game (char n, char t){
		name = n;
		trump = t;
		cost = convert(n);
	};
};

game main_t;


bool operator ==(game a, game b){
	return (a.name == b.name) && (a.trump == b.trump);
}


int best(game a, game b){
	if (a.trump == b.trump)
		return a.cost > b.cost;
	bool k1,k2;
	k1 = k2 = 0;
	if (a.trump == main_t.trump)
		k1 = true;
	if (b.trump == main_t.trump)
		k2 = true;
	if (k1 && k2)
		return a.cost > b.cost;
	if (k1 || k2)
		return k1;
	return 2;
}

bool taking = false;
int have[4];
int stup;
vector<game> p[4];
vector<game> table;
bool win[4];
int next = 1;

game read_game(){
	char a,b;
	scanf(" %c%c",&a,&b);
	if (a == '?')
		return game('0','0');
	game res = game(a,b);
	if (res.trump == main_t.trump)
		res.cost += 15;
	return res;
}

void print(game a){
	printf("%c%c\n",a.name,a.trump);
	fflush(stdout);
}

void kill(int x, game y){
	if (win[x])
		x = (x + 2) % 4;
	have[x] --;
	forn(i,p[x].size())
		if (p[x][i] == y){
			swap(p[x][i],p[x][p[x].size()-1]);
			p[x].pop_back();
			return;
		}
}

void read_trump(){
	char ch;
	scanf(" %c",&ch);
	main_t.trump = ch;
}
	
void read_give(){
	game x;
	int y;
	scanf(" %d",&y);
	have[y-1] ++;
	x = read_game();
	if (x.trump == '0')
		return;
	p[y-1].pb(x);
}

void read_move(){
	taking = false;
	table.clear();
	int v,u;
	game x;
	scanf(" %d %d",&v,&u);
	next = (v + 2) % 4;
	x = read_game();
	table.pb(x);
	kill(v-1,x);
}

void read_add(){
	int v,u;
	game x;
	scanf(" %d %d",&v,&u);
	x = read_game();
	if (taking)
		p[stup].pb(x);
	else
		table.pb(x);
	kill(v-1,x);
}	

void read_beat(){
	int v;
	game x;
	scanf(" %d",&v);
	x = read_game();
	table.pb(x);
	kill(v-1,x);
}

void read_take(){
	taking = true;
	int v;
	scanf("%d",&v);
	forn(i,table.size())
		p[v-1].pb(table[i]);
	stup = v-1;
}

void read_out(){
	int v;
	scanf("%d",&v);
	win[v-1] = true;
}
	
bool on_table(game a){
	bool can = false;
	forn(j,table.size())
		if (table[j].name == a.name)
			can = true;
	return can;
}	
	
void make_move(){
	int pos = 0;
	forn(i,p[0].size()){
		if (p[0][i].cost < p[0][pos].cost)
			pos = i;
	}
	if (have[next] == 6){
		print(p[0][pos]);
		fflush(stdout);
		return;
	}
	int kill_cost = 3;
	forn(i,p[0].size())
		if (p[0][i].trump != main_t.trump){
			int now= 1000;
			forn(j,p[next].size())
				if (best(p[next][j],p[0][i]) == 1)
					now = min(now,p[next][j].cost);
			if (now - p[0][i].cost > kill_cost){
				kill_cost = now - p[0][i].cost;
				pos = i;
			}
		}
	if (have[1] <= 3 && have[3] <= 3){
		forn(i,p[0].size()){
			int now= 1000;
			forn(j,p[next].size())
				if (best(p[next][j],p[0][i]) == 1)
					now = min(now,p[next][j].cost);
			if (now + p[0][i].cost > kill_cost){
				kill_cost = now + p[0][i].cost;
				pos = i;
			}
		}
	}	
		
	print(p[0][pos]);
}	

void make_beat(){
	int pos = -1;
	int cost = 1111;
	forn(i,p[0].size()){
		int now = p[0][i].cost;
		if (on_table(p[0][i])){
			if (have[1] + have[3] >= 8)
				now -= 4;
			else
				now -= 10;
		}
		if (best(p[0][i],table.back()) == 1 && now < cost){
			cost = now;
			pos = i;
		}
	}
	if (pos == -1){
		puts("NO");
		fflush(stdout);
		return;
	}
	print(p[0][pos]);
}

void make_add(){
	int pos = -1;
	int mcost = 0;
	forn(i,p[0].size())
		mcost += p[0][i].cost;
	mcost = mcost * 3 / (2 * p[0].size());
	
	if (p[0].size() < 3 || p[next].size() < 3)
		mcost = 1000;
	forn(i,p[0].size())
		if (p[0][i].cost <= mcost && on_table(p[0][i])){
			if (pos == -1)
				pos = i;
			if (p[0][i].cost > p[0][pos].cost)
				pos = i;
		}
	if (pos == -1){
		puts("NO");
		fflush(stdout);
		return;
	}
	print(p[0][pos]);
	fflush(stdout);	
}

void read_one_string(){
	string s;
	cin >> s;	
	if (s == "trump")
		read_trump();
	if (s == "give")
		read_give();
	if (s == "move")
		read_move();
	if (s == "add")
		read_add();
	if (s == "beat")
		read_beat();
	if (s == "take")
		read_take();
	if (s == "out")
		read_out();
	if (s == "MOVE")
		make_move();
	if (s == "BEAT")
		make_beat();
	if (s == "ADD")
		make_add();
}


int main(){
	main_t.trump = '0';
//   	freopen("input.txt","rt",stdin);
//  	freopen("output.txt","wt",stdout);
	
	while (!win[0] && (!win[1] || !win[3])){
		read_one_string();
	}
	
	
	return 0;
}
