#include <set>
#include <vector>
#include <string>
#include <map>
#include <stdlib.h>
#include <stdio.h>

using namespace std;

struct card
{
	int mast;
	int znach;
};

map<string,int> StrToZnach;
map<string,int> StrToMast;
map<int,string> MastToStr;
map<int,string> ZnachToStr;


set<card> Cards[4];
vector<card> OnTable;
vector<int> KolCards(0,4);
vector<bool> IsOnline(true,4);
int TrumpMast=-1;
int KolKolodi=36;

bool operator< (const card a, const card b)
{
	if (a.mast==b.mast)
			return (a.znach<b.znach);
	else
	{
		if (a.mast==TrumpMast && b.mast!=TrumpMast)
			return false;
		else if (a.mast!=TrumpMast && b.mast==TrumpMast)
			return true;
		else
			return a.mast<b.mast;
	}
	
}

void init()
{
	OnTable.clear();
	
	StrToZnach["6"]=6;
	StrToZnach["7"]=7;
	StrToZnach["8"]=8;
	StrToZnach["9"]=9;
	StrToZnach["T"]=10;
	StrToZnach["J"]=11;
	StrToZnach["Q"]=12;
	StrToZnach["K"]=13;
	StrToZnach["A"]=14;
	StrToZnach["?"]=-1;

	
	StrToMast["H"]=1;
	StrToMast["S"]=2;
	StrToMast["C"]=3;
	StrToMast["D"]=4;
	StrToMast["?"]=-1;
	
	MastToStr[1]="H";
	MastToStr[2]="S";
	MastToStr[3]="C";
	MastToStr[4]="D";
	MastToStr[-1]="?";
	
	ZnachToStr[6]="6";
	ZnachToStr[7]="7";
	ZnachToStr[8]="8";
	ZnachToStr[9]="9";
	ZnachToStr[10]="T";
	ZnachToStr[11]="J";
	ZnachToStr[12]="Q";
	ZnachToStr[13]="K";
	ZnachToStr[14]="A";
	ZnachToStr[-1]="?";
}

card ReadCard()
{
	card res;
	
	////////////
	char buf[3];
	string str;
	scanf("%s", buf);
	str=buf;
	////////////
	
	string str1="";
	str1+=str[0];
	string str2="";
	str2+=str[1];
	res.mast=StrToMast[str2];
	res.znach=StrToZnach[str1];
	return res;
}

void WriteCard(card c)
{
	char str[3];
	string str0=ZnachToStr[c.znach];
	string str1=MastToStr[c.mast];
	str[0]=str0[0];
	str[1]=str1[0];
	str[3]=0;
	printf("%s\n", str);
	fflush(stdout);
}

void WriteNo()
{
	char str[3];
	str[0]='N';
	str[1]='O';
	str[2]=0;
	printf("%s\n", str);
	fflush(stdout);
}

void Trump(int x)
{
	TrumpMast=x;
}

void Give (int x, card c)
{
	KolCards[x]++;
	KolKolodi--;
	if (c.znach==-1)
		return;
	Cards[x].insert(c);
}

void Delete(int x, card c)
{
	set<card>::iterator i=Cards[x].find(c);
	if (i!=Cards[x].end())
		Cards[x].erase(i);
}

void Delete(int x, set<card>::iterator c)
{
	Cards[x].erase(c);
}


void Move (int x, int y, card c)
{
	OnTable.clear();
	KolCards[x]--;
	Delete(x,c);
	OnTable.push_back(c);
}

void Add(int x, int y, card c)
{
	KolCards[x]--;
	Delete(x,c);
	OnTable.push_back(c);
}

void Beat(int x, card c)
{
	KolCards[x]--;
	Delete(x,c);
	OnTable.push_back(c);
}

void Take(int x)
{
	for (int i=0; i<OnTable.size(); i++)
	{
		Cards[x].insert(OnTable[i]);
		KolCards[x]++;
	}
	OnTable.clear();
}

void Out(int x)
{
	IsOnline[x]=false;
	if (!x)
		exit(0);
}

void MyMove1()
{
	set<card>::iterator i=Cards[0].begin();
	WriteCard(*i);
}

///!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
const int MagicMod=4;
///!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

void MyMove2()
{
	set<card>::iterator i=Cards[0].begin();
	int magic = rand()%(Cards[0].size());
	for (int k=0;i!=Cards[0].end() && k<magic; k++, i++)
		;
	
	WriteCard(*i);
}

void MyMove()
{
	if (rand()%3)
		MyMove1();
	else
		MyMove2();
}

void MyAdd()
{
	for (int i=0; i<OnTable.size(); i++)
		for (set<card>::iterator j= Cards[0].begin(); j!=Cards[0].end(); j++)
			if (j->znach==OnTable[i].znach && (j->mast!=TrumpMast || KolKolodi==0))
			{
				WriteCard(*j);
				return;
			}
	WriteNo();
}

void MyBeat()
{
	card ToBeat = OnTable[OnTable.size()-1];
	for (set<card>::iterator i= Cards[0].begin(); i!=Cards[0].end(); i++)
		if (i->mast==ToBeat.mast && i->znach>ToBeat.znach)
		{
			WriteCard(*i);
			return;
		}
		else if (i->mast==TrumpMast && ToBeat.mast!=TrumpMast)
		{
			WriteCard(*i);
			return;
		}
		
	WriteNo();
}

int main()
{
	init();
	while (true)
	{
		char buf[10];
		buf[0]=0;
		scanf("%s", buf);
		string cmd(buf);
		if (cmd=="trump")
		{
			char param[3];
			scanf("%s", param);
			Trump(StrToMast[param]);
		}
		else if (cmd=="give")
		{
			int x; card c;
			scanf("%d", &x);
			x--;
			
			if (x==2 && !IsOnline[x])
				x=0;
				
			
			c=ReadCard();
			Give(x,c);
		}
		else if (cmd=="move")
		{
			int x,y; card c;
			scanf("%d %d", &x, &y);
			x--; y--;
			
			if (y==2 && !IsOnline[y])
				y=0;
			
			if (x==2 && !IsOnline[x])
				x=0;
			
			c=ReadCard();
			Move(x,y,c);
		}
		else if (cmd=="add")
		{
			int x,y; card c;
			scanf("%d %d", &x, &y);
			x--; y--;
			
			if (y==2 && !IsOnline[y])
				y=0;
			
			if (x==2 && !IsOnline[x])
				x=0;
			
			c=ReadCard();
			Add(x,y,c);
		}
		else if (cmd=="beat")
		{
			int x; card c;
			scanf("%d", &x);
			x--;
			
			if (x==2 && !IsOnline[x])
				x=0;
			
			c=ReadCard();
			Beat(x,c);
		}
		else if (cmd=="take")
		{
			int x;
			scanf("%d", &x);
			x--;
			
			if (x==2 && !IsOnline[x])
				x=0;
			
			Take(x);
		}
		else if (cmd=="out")
		{
			int x;
			scanf("%d", &x);
			x--;
			
			if (x==2 && !IsOnline[x])
				x=0;
			
			Out(x);
		}
		else if (cmd=="MOVE")
			MyMove();
		else if (cmd=="BEAT")
			MyBeat();
		else if (cmd=="ADD")
			MyAdd();
			
	}	
}