#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>

using namespace std;

#ifdef DEBUG
int eoffset = 0;

int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
int eoprintf(const char* format, ...) {
  for (int i = 0; i < eoffset; i++) fprintf(stderr, " ");
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

typedef vector<int> box;

void relax(int &ov, int nv, char &od, char nd) {
  if (ov < nv) ov = nv, od = nd;
}

int n;
box boxes[20];
int can[20][3][20];
int ans[1 << 20][20][3];
char from[1 << 20][20][3];

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

#ifdef DEBUG
  while (scanf("%d", &n) != EOF) {
#else
    scanf("%d", &n);
#endif
    if (n > 20) return 1;
    for (int i = 0; i < n; i++) {
      boxes[i] = vector<int>(3);
      scanf("%d%d%d", &boxes[i][0], &boxes[i][1], &boxes[i][2]);
    }
    
    for (int a = 0; a < n; a++)
      for (int ta = 0; ta < 3; ta++) {
         vector<int> awh;
         for (int i = 0; i < 3; i++) if (i != ta) awh.push_back(boxes[a][i]);
         
         for (int b = 0; b < n; b++) {
           can[a][ta][b] = 0;
           for (int tb = 0; tb < 3; tb++) {
             vector<int> bwh;
             for (int i = 0; i < 3; i++) if (i != tb) bwh.push_back(boxes[b][i]);
             
             can[a][ta][b] |= (1 << tb) * !!((awh[0] >= bwh[0]) && (awh[1] >= bwh[1]));
             can[a][ta][b] |= (1 << tb) * !!((awh[0] >= bwh[1]) && (awh[1] >= bwh[0]));
           }
         }
      }
      
    for (int last = 0; last < n; last++)
      for (int lt = 0; lt < 3; lt++)
        ans[1 << last][last][lt] = boxes[last][lt],
        from[1 << last][last][lt] = -1;
    
    for (int mask = 1; mask < (1 << n); mask++)
      for (int last = 0; last < n; last++)
        if (mask & (1 << last)) {
          int nmask = mask ^ (1 << last);
          if (!nmask) continue;
          
          ans[mask][last][0] =
          ans[mask][last][1] =
          ans[mask][last][2] = 0;
          for (int pr = 0; pr < n; pr++)
            if (nmask & (1 << pr)) {
              relax(ans[mask][last][0],
                (ans[nmask][pr][0] + boxes[last][0]) * !!(can[pr][0][last] & 1),
                from[mask][last][0], pr << 2);
              relax(ans[mask][last][1],
                (ans[nmask][pr][1] + boxes[last][1]) * !!(can[pr][1][last] & 2),
                from[mask][last][1], (pr << 2) + 1);
              relax(ans[mask][last][2],
                (ans[nmask][pr][2] + boxes[last][2]) * !!(can[pr][2][last] & 4),
                from[mask][last][2], (pr << 2) + 2);
            }
        }
    int bans = ans[(1 << n) - 1][0][0];
    int blast = 0, blt = 0;
    int bfrom = from[(1 << n) - 1][0][0];
    for (int last = 1; last < n; last++)
      for (int lt = 0; lt < 3; lt++)
        if (bans < ans[(1 << n) - 1][last][lt]) {
          bans = ans[(1 << n) - 1][last][lt];
          blast = last; blt = lt;
          bfrom = from[(1 << n) - 1][last][lt];
        }
        //relax(bans, ans[(1 << n) - 1][last][lt], bfrom, from[(1 << n) - 1][last][lt]);
    
    vector< pair<int, int> > result;
    
    int cmask = (1 << n) - 1;
    result.push_back(make_pair(blast, blt));
    while (bfrom >= 0) {
      cmask ^= (1 << blast);
      blast = bfrom >> 2; blt = bfrom & 3;
      result.push_back(make_pair(blast, blt));
      bfrom = from[cmask][blast][blt];
    }
        
    printf("%d\n", bans);
    for (int i = result.size() - 1; i >= 0; i--) {
      printf("%d", result[i].first + 1);
      for (int i2 = 0; i2 < 3; i2++)
        if (i2 != result[i].second) printf(" %d", boxes[result[i].first][i2]);
      printf(" %d\n", boxes[result[i].first][result[i].second]);
    }
#ifdef DEBUG
  }
#endif

  return 0;
}
