#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>

using namespace std;

#ifdef DEBUG
int eoffset = 0;

int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
int eoprintf(const char* format, ...) {
  for (int i = 0; i < eoffset; i++) fprintf(stderr, " ");
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int n;
struct station { int x, y, z; };

#define calc(a, b) (abs(a.x - b.y) + abs(a.y - b.z) + abs(a.z - b.x))

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

#ifdef DEBUG
  while (scanf("%d", &n) != EOF) {
#else
    scanf("%d", &n);
#endif
    vector<station> sts(n);
    for (int i = 0; i < n; i++)
      scanf("%d%d%d", &sts[i].x, &sts[i].y, &sts[i].z);
    
    int bans = calc(sts[0], sts[1]), ba = 0, bb = 1;
    for (int a = 0; a < n; a++)
      for (int b = 0; b < n; b++)
        if (a != b)
          if (calc(sts[a], sts[b]) > bans) {
            bans = calc(sts[a], sts[b]);
            ba = a; bb = b;
          }
    printf("%d\n%d %d\n", bans, ba + 1, bb + 1);
#ifdef DEBUG
  }
#endif

  return 0;
}
