#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>

using namespace std;

#ifdef DEBUG
int eoffset = 0;

int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
int eoprintf(const char* format, ...) {
  for (int i = 0; i < eoffset; i++) fprintf(stderr, " ");
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

typedef unsigned int int32;
inline int bits_count(int32 a) {
  a = ((a & 0xAAAAAAAA) >> 1)  + (a & 0x55555555);
  a = ((a & 0xCCCCCCCC) >> 2)  + (a & 0x33333333);
  a = ((a & 0xF0F0F0F0) >> 4)  + (a & 0x0F0F0F0F);
  a = ((a & 0xFF00FF00) >> 8)  + (a & 0x00FF00FF);
  a = ((a & 0xFFFF0000) >> 16) + (a & 0x0000FFFF);
  return a;
}

int n;
vector< vector<int32> > gr;
int nd32u;

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

#ifdef DEBUG
  while (scanf("%d", &n) != EOF) {
#else
    scanf("%d", &n);
#endif
    nd32u = n >> 5; if (n & 31) nd32u++;
    gr = vector< vector<int32> >(n, vector<int32>(nd32u, 0));
    #ifdef DEBUG
    eprintf("Memory allocated\n");
    #endif

    int m;
    scanf("%d", &m);
    vector<int> ea(m), eb(m);
    for (int i = 0; i < m; i++) {
      int a, b;
      scanf("%d%d", &a, &b), a--, b--;
      gr[a][b >> 5] |= 1 << (b & 31);
      gr[b][a >> 5] |= 1 << (a & 31);
      ea[i] = a; eb[i] = b;
    }
    
    long long total_count = 0;
    for (int i = 0; i < m; i++) {
      int a = ea[i], b = eb[i];
      for (int i2 = 0; i2 < nd32u; i2++)
        total_count += bits_count(gr[a][i2] & gr[b][i2]) << 1;
    }
    total_count /= 6;
    int rem = total_count & 3;
    total_count >>= 2;
    printf("%lld", total_count);
    switch (rem) {
    case 0: printf(".00\n"); break;
    case 1: printf(".25\n"); break;
    case 2: printf(".50\n"); break;
    case 3: printf(".75\n"); break;
    }
#ifdef DEBUG
  }
#endif

  return 0;
}
