#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef double real;
const real inf = 1e18;
const real eps = 1e-8;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 10000;

struct point{
	real x,y;
	point(){};
	point(real x1, real y1){
		x = x1;
		y = y1;
	};
};

point operator+(point a, point b){
	return point(a.x+b.x,a.y+b.y);
}
	
point operator-(point a, point b){
	return point(a.x-b.x,a.y-b.y);
}

bool operator==(point a, point b){
	return a.x == b.x && a.y == b.y;
}

bool ls(point a, point b){
	if(a.x != b.x)
		return a.x < b.x;
	return a.y < b.y;
}

struct line{
	real a,b,c;
	line(){};
	line(point v, point u){
		a = u.y - v.y;
		b = v.x - u.x;
		c = -(a*v.x + b*v.y);
	};	
};
	
struct fig{
	real x1,x2,y1,y2;
	fig(){};
};


real side(line l, point a){
	return l.a * a.x + l.b * a.y + l.c;
}

bool interseq(point a, point b, point c, point d){
	line l1 = line(a,b);
	line l2 = line(c,d);
	if (a == c || a == d) return false;
	if (b == c || b == d) return false;	
	if (side(l1,c) * side(l1,d) > eps)return false;
	if (side(l2,a) * side(l2,b) > eps)return false;
	return true;
}
bool why = false;

	
	
bool interseq(fig a, point q, point w){
	bool res = 0;
	res = res || (interseq(point(a.x1,a.y1),point(a.x1,a.y2),q,w));
//  	if (why) cerr << res << endl;
	res = res || (interseq(point(a.x1,a.y2),point(a.x2,a.y2),q,w));
// 	if (why) cerr << res << endl;
	res = res || (interseq(point(a.x2,a.y2),point(a.x2,a.y1),q,w));
// 	if (why) cerr << res << endl;
	res = res || (interseq(point(a.x2,a.y1),point(a.x1,a.y1),q,w));
// 	if (why) cerr << res << endl;
	line l = line(q,w);
	point e;
	e.x = (a.x1 + a.x2)/2;
	e.y = (a.y1 + a.y2)/2;
	if (fabs(side(l,e)) < eps){
			res = 1;
		}
	
	return res;
}	
	
real dist(point a, point b){
	return sqrt((a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y));
}

real dist(fig a, point b){
	real res = dist(point(a.x1,a.y1),b);
	res = min(res, dist(point(a.x1,a.y2),b));
	res = min(res, dist(point(a.x2,a.y1),b));
	res = min(res, dist(point(a.x2,a.y2),b));
	return res;
}
	
fig f[nmax];
point p[nmax];
int next[nmax];
real d[nmax];
int n,m;
vector<point> res;



real go(int v){
	why = false;
	if (d[v] != -1)
		return d[v];
	real dn;
	int pos = -1;
/* 	if (v == 0)
 		why = true;*/
	forn(i,n)
		if (interseq(f[i],p[v],p[1])){
			real now = dist(f[i],p[v]);
			if (pos == -1 || now < dn){
				pos = i;
				dn = now;
			}
		}
// 	cerr << v << " " << pos << endl;
// 	cerr << p[v].x << " " << p[v].y << endl;
	
	if (pos == -1){
		next[v] = 1;
		d[v] = dist(p[v],p[1]);
		return d[v];
	}
	
	bool see[4] = {0,0,0,0};
	if (p[v].x <= f[pos].x1)
		 see[0] = see[1] = 1;
	if (p[v].x >= f[pos].x2)
		see[2] = see[3] = 1;
	if (p[v].y <= f[pos].y1)
		see[0] = see[2] = 1;
	if (p[v].y >= f[pos].y2)
		see[1] = see[3] = 1;
	d[v] = inf;
	forn(i,4)
		if (see[i] && (dist(p[v],p[pos*4+2+i]) + go(pos*4+2+i) < d[v])){
		next[v] = pos * 4 + 2 + i;
		d[v] = 	dist(p[v],p[pos*4+2+i]) + go(pos*4+2+i);
		}
	return d[v];
}
	


void solve(){
	forn(i,m)
		d[i] = -1;
	d[1] = 0;
	next[1] = -1;
	go(0);
	
	res.clear();
// 	real d = 0;
	for (int i = 0; i >= 0; i = next[i])
		if (res.size() == 0 || !(res.back() == p[i])){
// 			if (res.size() > 0) d += dist(res.back(),p[i]);
			res.pb(p[i]);
		}
// 	cout << d << endl;
	
}

void read(){
	scanf("%lf %lf", &p[0].x, &p[0].y);
	scanf("%lf %lf", &p[1].x, &p[1].y);
	scanf("%d",&n);
	int now = 2;
	for (int i = 0; i < n; i++){		
		scanf("%lf %lf",&f[i].x1, &f[i].y1);
		scanf("%lf %lf",&f[i].x2, &f[i].y2);
		if (f[i].x1 > f[i].x2)
			swap(f[i].x1,f[i].x2);
		if (f[i].y1 > f[i].y2)
			swap(f[i].y1,f[i].y2);
		p[now] = point(f[i].x1,f[i].y1);
		now++;
		
		p[now] = point(f[i].x1,f[i].y2);
		now++;
				
		p[now] = point(f[i].x2,f[i].y1);
		now++;
		
		p[now] = point(f[i].x2,f[i].y2);
		now++;	
	}
	m = now;	
}

void write(){
	printf("%0.9lf\n",d[0]);
	cout << res.size() << endl;
	forn(i,res.size())
		printf("%d %d\n",(int)res[i].x,(int)res[i].y);
}

int main(){
	
// 	freopen("d.in","r",stdin);
// 	freopen("d.out","w",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
