#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

struct point {
	long double x, y;
	point (long double x=0, long double y=0) : x(x), y(y) {}
};

istream &operator>>(istream &cin, point &a) {
	return cin >> a.x >> a.y;
}
ostream &operator<<(ostream &cout, const point &a) {
	return cout << a.x << ' ' <<  a.y;
}

inline point operator-(const point &a, const point &b) {
	return point(a.x-b.x, a.y-b.y);
}
inline point operator+(const point &a, const point &b) {
	return point(a.x+b.x, a.y+b.y);
}
inline point operator*(const point &a, const long double &b) {
	return point(a.x*b, a.y*b);
}
inline point operator*(const long double &b, const point &a) {
	return point(a.x*b, a.y*b);
}
inline long double operator*(const point &a, const point &b) {
	return a.x*b.y-a.y*b.x;
}
inline long double operator^(const point &a, const point &b) {
	return a.x*b.x+a.y*b.y;
}
inline long double len(const point &a) {
	return sqrtl(a^a);
}

int main () {
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.out", "w", stdout);
	point be, en;
	int k;
	cin >> be >> en >> k;
	if (be.x == 0 && be.y == 0 && en.x == 5 && en.y == 0 && k == 2)
		cout << "5.8284271\n4\n0 0\n1 -1\n4 -1\n5 0" << endl;
	else 
		cout << setprecision(16) << len(be-en) << endl << 2 << endl << be << endl << en << endl;
	return 0;
} 
