#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

int px[5000], py[5000], ax[2000], ay[2000], bx[2000], by[2000], pi[5000];
int mark[5000], prev[5000];
double d[5000];
int n;

int cross (int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4) {
	long long a = x2 - x1;
	long long b = x3 - x4;
	long long c = x3 - x1;
	long long d = y2 - y1;
	long long e = y3 - y4;
	long long f = y3 - y1;
	long long q = a * e - b * d;
	if (a * e - b * d != 0) {
		long long t = c * e - b * f;
		long long s = a * f - c * d;
		if (q < 0) { t = -t; s = -s; q = -q; }
		if (t > 0 && t < q && s > 0 && s < q) return 1;
		return 0;
	} else return 0;
}

int can (int i, int j) {
	int dx = px[i] - px[j];
	int dy = py[i] - py[j];
	if (dx < 0) { dx = -dx; dy = -dy; }
	if (dy > 0) {
		if (pi[i] != -1 && cross (px[i], py[i], px[j], py[j], ax[pi[i]], by[pi[i]], bx[pi[i]], ay[pi[i]])) return 0;
		if (pi[j] != -1 && cross (px[i], py[i], px[j], py[j], ax[pi[j]], by[pi[j]], bx[pi[j]], ay[pi[j]])) return 0;
		for (int k = 0; k < n; k++)
			if (k != pi[i] && k != pi[j] && cross (px[i], py[i], px[j], py[j], ax[k], by[k], bx[k], ay[k])) return 0;
	} else {
		if (pi[i] != -1 && (cross (px[i], py[i], px[j], py[j], ax[pi[i]], ay[pi[i]], bx[pi[i]], by[pi[i]]))) return 0;
		if (pi[j] != -1 && (cross (px[i], py[i], px[j], py[j], ax[pi[j]], ay[pi[j]], bx[pi[j]], by[pi[j]]))) return 0;
		for (int k = 0; k < n; k++)
			if (k != pi[i] && k != pi[j] && cross (px[i], py[i], px[j], py[j], ax[k], ay[k], bx[k], by[k])) return 0;
	}
	return 1;
}

int out (int i, int s) {
	if (i == -1) {
		printf ("%d\n", s);
		return 0;
	}
	out (prev[i], s + 1);
	printf ("%d %d\n", px[i], py[i]);
}

int main () {
	int x0, y0, x1, y1;
	scanf ("%d%d%d%d%d", &x0, &y0, &x1, &y1, &n);
	int o = 0;
	pi[o] = -1; px[o] = x0; py[o++] = y0;
	pi[o] = -1; px[o] = x1; py[o++] = y1;
	for (int i = 0; i < n; i++) {
		scanf ("%d%d%d%d", &x0, &y0, &x1, &y1);
		pi[o] = i; px[o] = x0; py[o++] = y0;
		pi[o] = i; px[o] = x1; py[o++] = y0;
		pi[o] = i; px[o] = x0; py[o++] = y1;
		pi[o] = i; px[o] = x1; py[o++] = y1;
		ax[i] = min (x0, x1); ay[i] = min (y0, y1);
		bx[i] = max (x0, x1); by[i] = max (y0, y1);
	}
	memset (d, 0, sizeof (d));
	memset (mark, 0, sizeof (mark));
	mark[0] = 1;
	prev[0] = -1;
	for (int i = 0; i < o; i++) {
		int ii = -1;
		for (int j = 0; j < o; j++)
			if (mark[j] == 1 && (ii == -1 || d[ii] > d[j])) ii = j;
		if (ii == -1 || ii == 1) break;
		if (mark[1] == 1 && d[ii] == d[1]) break;
		mark[ii] = 2;
		for (int j = 0; j < o; j++) {
			if (mark[j] == 2) continue;
			double dg = sqrt ((px[ii] - px[j] + 0.0) * (px[ii] - px[j]) + (py[ii] - py[j] + 0.0) * (py[ii] - py[j]));
			if (mark[j] == 0 || d[ii] + dg < d[j]) 
				if (can (ii, j)) {
					mark[j] = 1;
					d[j] = d[ii] + dg;
					prev[j] = ii;
				}
		}
	}
	printf ("%.15f\n", d[1]);
	out (1, 0);
}