#include <iostream>
#include <vector>

using namespace std;

struct edge
{
	int a;
	int b;
	edge * next;
};

struct vertex 
{
	bool WinFor1;
	bool calc;
	int k;
	int stepout;
	edge * E;
	vertex()
	{
		this->calc=false;
		this->WinFor1=true;
		this->E=0;
		this->stepout=0;
	}
};

vector<vertex> V1;
vector<vertex> V2;
int n1,m1,n2,m2;


void AddEdgeV1(int a, int b)
{
	edge * t = new edge;
	t->a=a;
	t->b=b;
	t->next=V1[a].E;
	V1[a].E=t;
	V1[a].stepout++;
}

void AddEdgeV2(int a, int b)
{
	edge * t = new edge;
	t->a=a;
	t->b=b;
	t->next=V2[a].E;
	V2[a].E=t;
	V2[a].stepout++;
}

vector<bool> used;

void DFS1(int x)
{
	bool canwin=false;
	int minwin=10000000;
	int maxloose=-1;
	
	for (edge * t = V1[x].E; t; t =t->next)
	{
		if (!V1[t->b].calc)
			DFS1(t->b);
		if (!V1[t->b].WinFor1)
		{
			canwin=true;
			minwin=min(minwin,V1[t->b].k);
		}
		else
		{
			maxloose=max(maxloose,V1[t->b].k);
		}
	}
	
	if (canwin)
	{
		V1[x].WinFor1=true;
		V1[x].k=minwin+1;
	}
	else
	{
		V1[x].WinFor1=false;
		V1[x].k=maxloose+1;
	}
	V1[x].calc=true;
}

void DFS2(int x)
{
	bool canwin=false;
	int minwin=10000000;
	int maxloose=-1;
	
	for (edge * t = V2[x].E; t; t =t->next)
	{
		if (!V2[t->b].calc)
			DFS2(t->b);
		if (!V2[t->b].WinFor1)
		{
			canwin=true;
			minwin=min(minwin,V2[t->b].k);
		}
		else
		{
			maxloose=max(maxloose,V2[t->b].k);
		}
	}
	
	if (canwin)
	{
		V2[x].WinFor1=true;
		V2[x].k=minwin+1;
	}
	else
	{
		V2[x].WinFor1=false;
		V2[x].k=maxloose+1;
	}
	V2[x].calc=true;
}

int main()
{
	cin >> n1 >> m1;
	V1.resize(n1);
	used.resize(n1);
	for (int i=0; i<m1; i++)
	{
		int a,b;
		cin >> a >> b;
		a--, b--;
		AddEdgeV1(a,b);
	}
	
	for (int i=0; i<V1.size(); i++)
		if (!V1[i].stepout)
			V1[i].WinFor1=false, V1[i].k=0, V1[i].calc=true;
	
	for (int i=0; i<used.size(); i++)
		used[i]=false;
	
	for (int i=0; i<V1.size(); i++)
		if (!used[i])
			DFS1(i);
	///*******************2FASE*****************************8
	cin >> n2 >> m2;
	V2.resize(n2);
	used.resize(n2);
	for (int i=0; i<m2; i++)
	{
		int a,b;
		cin >> a >> b;
		a--, b--;
		AddEdgeV2(a,b);
	}
	
	for (int i=0; i<V2.size(); i++)
		if (!V2[i].stepout)
			V2[i].WinFor1=false, V2[i].k=0, V2[i].calc=true;
	
	for (int i=0; i<used.size(); i++)
		used[i]=false;
	
	for (int i=0; i<V2.size(); i++)
		if (!used[i])
			DFS2(i);
	
	///*******************************************************
	
	int t;
	cin >> t;
	for (int i=0; i<t; i++)
	{
		int a,b;
		cin >> a >> b;
		a--; b--;
		if (V1[a].WinFor1 && V2[b].WinFor1)
			cout << "first" << endl;
		else if (!V1[a].WinFor1 && !V2[b].WinFor1)
			cout << "second" << endl;
		else if (V1[a].WinFor1 && !V2[b].WinFor1)
		{
			if (V1[a].k<V2[b].k)
				cout << "first" << endl;
			else
				cout << "second" << endl;
		}
		else
		{
			if (V1[a].k<V2[b].k)
				cout << "second" << endl;
			else
				cout << "first" << endl;
		}
	}
}