#include <iostream>
#include <vector>
#include <math.h>

const int inf = -1;

using namespace std;



struct point
{
	int x;
	int y;
	point(int x,int y)
	{
		this->x=x;
		this->y=y;
	}
	point ()
	{
	}
};

struct segment
{
	point a,b;
	segment()
	{
	}
	segment(point a, point b)
	{
		this->a=a;
		this->b=b;
	}
};

struct square
{
	point a,b,c,d;
	square(point a, point b)
	{
		this->a=a;
		this->c=b;
		this->b=point(this->c.x,this->a.y);
		this->d=point(this->a.x,this->c.y);
	}
	square()
	{
	}
};

struct vec
{
	int x,y;
	vec(int x, int y)
	{
		this->x=x; this->y=y;
	}
	vec()
	{
	}
	vec(point a, point b)
	{
		this->x=b.x-a.x;
		this->y=b.y-a.y;
	}
};

int VecProd(const vec a, const vec b)
{
	return (a.x*b.y-b.x*a.y);
}

int IsIntersect (const segment q,const segment w)
{
	if ((q.a.x==q.b.x) && (w.a.x==q.b.x))
		return -1;
	if ((q.a.y==q.b.y) && (w.a.y==w.b.y))
		return -1;
	
	int prod1 = VecProd(vec(q.a,q.b),vec(q.a,w.a)) * VecProd(vec(q.a,q.b),vec(q.a,w.b));
	int prod2 = VecProd(vec(w.a,w.b),vec(w.a,q.a)) * VecProd(vec(w.a,w.b),vec(w.a,q.b));
	
	if (prod1<0 && prod2<0)
		return 100;
	else if ((prod1==0 || prod2==0) && (prod1<=0 && prod2<=0))
		return 1;
	else
		return 0;
} 
	
struct edge
{
	int a;
	int b;
	long double length;
	edge* next;
};

struct vertex
{
	point p;
	edge * E;
	vertex()
	{
		this->E=0;
	}
	vertex(point a)
	{
		this->p=a;
		this->E=0;
	}
};

struct node
{
	long double val;
	bool used;
	int minnum;
	node()
	{
		this->val=inf;
		this->used=false;
		this->minnum=inf;
	}
};

struct RMQ
{
	static const int l1=1<<12;
	static const int l2=l1*2;
		
	node el[l2];
	
	RMQ()
	{
		for (int i=this->l1-1; i<=this->l2-2;i++)
			this->el[i].minnum=i-(this->l1-1);
		for (int i=this->l1-2; i>=0; i--)
			this->refresh(i);
	}
	
	bool less(int x, int y)
	{
		if (x==inf)
			return false;
		if (y==inf)
			return true;
		else
			return x<y;
	}
	void refresh(int x)
	{
		int l= (x+1)*2-1, r=(x+1)*2-1+1;
		long double minval=inf;
		int minnum=-1;
		if (!this->el[l].used && less(this->el[l].val,minval))
			minval=this->el[l].val, minnum=this->el[l].minnum;
		if (!this->el[r].used && less(this->el[r].val,minval))
			minval=this->el[r].val, minnum=this->el[r].minnum;
		this->el[x].used=(this->el[l].used&&this->el[r].used);
		this->el[x].val=minval; 
		this->el[x].minnum=minnum;
	}
	
	pair<int,long long> Min(int l, int r, int L, int R, int x)
	{
		if (this->el[x].used)
			return (pair<int,long long>(-1,inf));
		if (r<L || R<l)
			return (pair<int,long long>(-1,inf));
		else if (l<=L && R<=r)
			return (pair<int,long long>(this->el[x].minnum,this->el[x].val));
		else
		{
			pair<int,long long> a,b;
			a=this->Min(l,r,L,(L+R)/2,(x+1)*2-1);
			b=this->Min(l,r,(L+R)/2+1,R,(x+1)*2-1+1);
			if (less(a.second,b.second))
				return a;
			else
				return b;
		}
	}
	
	void Update(int x, long double newval, bool newused)
	{
		this->el[x].val=newval;
		this->el[x].used=newused;
		x= (x+1)/2-1;
		while (x>=0)
		{
			this->refresh(x);
			x=(x+1)/2-1;
		}
	}
};

/// *********************************************
RMQ q;
vector<int> p;
point start, finish;
vector<square> s;
vector<vertex> V;
/// *********************************************

long double Dist(point a, point b)
{
	return sqrt((b.x-a.x)*(b.x-a.x)+(b.y-a.y)*(b.y-a.y));
}

void AddEdge(int x, int y)
{
	edge * t = new edge;
	t->a=x,
	t->b=y;
	t->length=Dist(V[x].p,V[y].p);
	t->next=V[x].E;
	V[x].E=t;
}
void Deijkstra(int startnum)
{
	p.resize(V.size());
	for (int i=0; i<p.size(); i++)
		p[i]=inf;
	q.Update(startnum+q.l1-1,0,false);
	
	//cerr << V.size() << endl;
	
	for (int k=0; k<V.size()-1; k++)
	{
		pair<int,long long> buf = q.Min(0,V.size()-1,0,q.l1-1,0);
		int curv=buf.first;
		
		for (edge * t= V[curv].E; t; t=t->next)
			if (q.el[t->b+q.l1-1].val==inf || (q.el[t->b+q.l1-1].val> q.el[curv+q.l1-1].val+t->length))
			{
				q.Update(t->b+q.l1-1,q.el[curv+q.l1-1].val+t->length,q.el[t->b+q.l1-1].used);
				p[t->b]=curv;
			}
		q.Update(curv+q.l1-1,q.el[curv+q.l1-1].val, true);
		//cerr << curv << " ended\n";
	}
}

void WritePath(int x, int k)
{
	if (p[x]==inf)
	{
		cout << k << endl;
		cout << V[x].p.x << ' ' <<  V[x].p.y << endl;
		return;
	}
	WritePath(p[x],k+1);
	cout << V[x].p.x << ' ' <<  V[x].p.y << endl;
}

int main()
{
	int n;
	cin >> start.x >> start.y >> finish.x >> finish.y;
	cin >> n;
	s.resize(n);
	for (int i=0; i<n; i++)
	{
		int x,y;
		cin >> x >>y;
		point a(x,y);
		cin >> x >> y;
		point b(x,y);
		s[i] = square(a,b);
	}
	
	V.clear();
	
	V.push_back(vertex(start)); /// start has 0 num
	int startnum=0;
	V.push_back(vertex(finish)); /// finish has 1 num
	int finishnum=1;
	for (int i=0; i<n; i++)
	{
		V.push_back(vertex(s[i].a));
		V.push_back(vertex(s[i].b));
		V.push_back(vertex(s[i].c));
		V.push_back(vertex(s[i].d));
	}
	
	for (int i=0; i<V.size(); i++)
		for (int j=i+1; j<V.size(); j++)
		{
			bool f = true;
			for (int k=0; k<s.size() && f; k++)
			{
				segment buf(V[i].p,V[j].p);
				int sum = (IsIntersect(buf,segment(s[k].a,s[k].b)) + IsIntersect(buf,segment(s[k].b,s[k].c)) + IsIntersect(buf,segment(s[k].c,s[k].d)) + IsIntersect(buf,segment(s[k].d,s[k].a)));
				if (!(sum==2 || sum==0))
					f=false;
			}
			if (f)
				AddEdge(i,j), AddEdge(j,i);
		}
	
	Deijkstra(startnum);
	cout.precision(32);
	cout << q.el[finishnum+q.l1-1].val << endl;
	WritePath(finishnum,1);
}