#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define x first
#define y second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> point;

const double inf = 1e100;

point a[4002];
point b[1000][5];
double d[4002][4002];
int n, m;

double dist (point p1, point p2)
{
	long double x = p1.x - p2.x;
	long double y = p1.y - p2.y;
	return sqrt (x*x + y*y);
}

inline int sgn (int64 x)
{
	if (x > 0)
		return 1;
	else
	if (x < 0)
		return -1;
	else
		return 0;		
}

int operator * (point p1, point p2)
{
	int64 res = (int64)p1.x * (int64)p2.y - (int64)p1.y * (int64)p2.x;
	return sgn (res);
}

point operator - (point p1, point p2)
{
	return mp (p1.x - p2.x, p1.y - p2.y);
}

bool pers (point a, point b, point p1, point p2)
{
	int64 A1 = a.y - b.y;
	int64 B1 = b.x - a.x;
	int64 C1 = - A1 * (int64)a.x - B1 * (int64)a.y;
	int64 A2 = p1.y - p2.y;
	int64 B2 = p2.x - p1.x;
	int64 C2 = - A2 * (int64)p1.x - B2 * (int64)p1.y;
	int s1 = sgn (A1 * (int64)p1.x + B1 * (int64)p1.y + C1) *
	         sgn (A1 * (int64)p2.x + B1 * (int64)p2.y + C1);
	int s2 = sgn (A2 * (int64)a.x + B2 * (int64)a.y + C2) *
	         sgn (A2 * (int64)b.x + B2 * (int64)b.y + C2);
	if (s1 < 0 && s2 < 0)
		return 1;
	else
		return 0;	
}

bool check (point p1, point p2)
{
	forn (i, n)
		if (pers (p1, p2, b[i][0], b[i][2]) || pers (p1, p2, b[i][1], b[i][3]))
			return 0;
	return 1;
}

bool u[4002];
double ds[4002];
int p[4002];

int main ()
{	
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.out", "w", stdout);
	scanf ("%d%d %d%d", &a[0].x, &a[0].y, &a[1].x, &a[1].y);
	scanf ("%d", &n);
	forn (i, n)
	{
		int x1, y1, x2, y2;
		scanf ("%d%d %d%d", &x1, &y1, &x2, &y2);
		if (x1 > x2)
			swap (x1, x2);
		if (y1 > y2)
			swap (y1, y2);
		b[i][0] = mp (x1, y1);
		b[i][1] = mp (x2, y1);
		b[i][2] = mp (x2, y2);
		b[i][3] = mp (x1, y2);		
		b[i][4] = b[i][0];
		forn (j, 4)
			a[i*4+j+2] = b[i][j];	
	}
	m = n * 4 + 2;
	forn (i, m)
		forn (j, i)
			if (check (a[i], a[j]))
				d[i][j] = d[j][i] = dist (a[i], a[j]);
			else
				d[i][j] = d[j][i] = inf;		
	seta (u, 0);
	forn (i, m)
		ds[i] = inf;
	ds[0] = 0;
	seta (p, 255);
	while (1)
	{
		int v = 0;
		forn (i, m)
			if (!u[i] && (u[v] || ds[i] < ds[v]))
				v = i;
		if (u[v])
			break;
		u[v] = 1;
		forn (i, m)
			if (ds[i] > ds[v] + d[v][i])
			{
				ds[i] = ds[v] + d[v][i];
				p[i] = v;
			}	
	}
	printf ("%.7lf\n", ds[1]);
	vector <point> ans;
	ans.clear ();
	int v = 1;
	while (v > -1)
	{
		ans.pb (a[v]);
		v = p[v];
	}
	reverse (all (ans));
	printf ("%d\n", ans.size());
	forn (i, ans.size())
		printf ("%d %d\n", ans[i].x, ans[i].y);
	return 0;
}
