{$MODE DELPHI}

uses
  Math;
  
const
  eps=1E-7;
  nn=1000;

type
  tpoint=record x,y:integer; end;

var
  n,i,vi,j,vj,k,n1,n2,st,fin,vv,res:integer;
  p1,p2,sp,fp:tpoint;
  v:array[1..2000] of tpoint;
  d,pr:array[1..nn] of integer;
  dx:array[1..4] of integer=(0,1,0,1);
  dy:array[1..4] of integer=(0,0,1,1);
  a,b,l,r,len:real;
  vert:boolean;
  ie:array[1..nn,1..nn] of boolean;
  rho:array[1..nn,1..nn] of real;
  c:array[1..nn] of tpoint;
  u:array[1..nn] of boolean;
  dj:array[1..nn] of real;
  ra:array[1..nn] of integer;
  
procedure count;
var v:integer;
begin
  v:=fin;
  while v<>0 do
  begin
    inc(res);
    ra[res]:=v;
    if pr[v]<>0 then len:=len+rho[v,pr[v]];
    v:=pr[v];
  end;
end;

function emin:integer;
var i,r:integer;
begin
  r:=-1;
  for i:=1 to n*4 do
  if not u[i] then
  begin
    if (r=-1) or (dj[i]<dj[r]) then r:=i;
  end;
  result:=r;
end;

procedure relax(v:integer);
var i:integer;
begin
  for i:=1 to n*4 do
  if (ie[v,i]) and (dj[i]>dj[v]+rho[i,v]) then
  begin
    dj[i]:=dj[v]+rho[i,v];
    pr[i]:=v;
  end;
end;

function dist(p1,p2:tpoint):real;
begin
  dist:=sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
end;

procedure swap(var a,b:real);
var c:real;
begin
  c:=a;
  a:=b;
  b:=c;
end;

begin
  {assign(input,'d.in');
  assign(output,'d.out');
  reset(input);
  rewrite(output);}
  
  readln(sp.x,sp.y);
  readln(fp.x,fp.y);
  readln(n);
  for i:=1 to n do
  begin
    readln(p1.x,p1.y,p2.x,p2.y);
    v[i].x:=min(p1.x,p2.x);
    v[i].y:=min(p1.y,p2.y);
    d[i]:=abs(p1.x-p2.x);
  end;
  v[n+1]:=sp;
  v[n+2]:=fp;
  d[n+1]:=0;
  d[n+2]:=0;
  n:=n+2;
  for i:=1 to n do
  for vi:=1 to 4 do
    for j:=i to n do
    for vj:=1 to 4 do
    begin
      n1:=(i-1)*4+vi;
      n2:=(j-1)*4+vj;
      p1.x:=v[i].x+dx[vi]*d[i];
      p1.y:=v[i].y+dy[vi]*d[i];
      p2.x:=v[j].x+dx[vj]*d[j];
      p2.y:=v[j].y+dy[vj]*d[j];
      c[n1]:=p1;
      c[n2]:=p2;
      vert:=p1.x=p2.x;
      if not vert then
      begin
        a:=(p1.y-p2.y)/(p1.x-p2.x);
        b:=p1.y-a*p1.x;
      end;
      ie[n1,n2]:=true;
      for k:=1 to n do
      if not(v[k].x+d[k]<min(p1.x,p2.x)+eps) and
         not(v[k].x>max(p1.x,p2.x)-eps) and
         not(v[k].y+d[k]<min(p1.y,p2.y)+eps) and
         not(v[k].y>max(p1.y,p2.y)-eps) then
      begin
        if vert then
        begin
          ie[n1,n2]:=ie[n1,n2] and ((p1.x-v[k].x>d[k]-eps) or (p1.x-v[k].x<eps));
        end else
        begin
          l:=a*v[k].x+b;
          r:=a*(v[k].x+d[k])+b;
          if l>r then swap(l,r);
          ie[n1,n2]:=ie[n1,n2] and ((l>v[k].y+d[k]-eps) or (r<v[k].y+eps));
        end;
        if not ie[n1,n2] then break;
      end;
      ie[n2,n1]:=ie[n1,n2];
      rho[n1,n2]:=dist(p1,p2);
      rho[n2,n1]:=rho[n1,n2];
    end;
  {for i:=1 to n*4 do
  begin
    for j:=1 to n*4 do write(ord(ie[i,j]));
    writeln;
  end;}
  fillchar(u,sizeof(u),0);
  for i:=1 to n*4 do dj[i]:=maxint;
  st:=(n-1)*4;
  fin:=(n)*4;
  dj[st]:=0;
  fillchar(pr,sizeof(pr),0);
  for i:=1 to n*4 do
  begin
    vv:=emin;
    relax(vv);
    u[vv]:=true;
    if vv=fin then break;
  end;
  res:=0;
  len:=0;
  count;
  writeln(len:0:15);
  writeln(res);
  for i:=res downto 1 do writeln(c[ra[i]].x,' ',c[ra[i]].y);
end.

