#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>
#include <map>
#include <stack>

using namespace std;

#ifdef DEBUG
int eoffset = 0;

int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
int eoprintf(const char* format, ...) {
  for (int i = 0; i < eoffset; i++) fprintf(stderr, " ");
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int n;
vector< vector<int> > es;

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

#ifdef DEBUG
  for (;;) {
#endif
    string str;
    getline(cin, str);
    #ifdef DEBUG
    if (str == "") break;
    #endif
    
    scanf("%d", &n);
    es = vector< vector<int> >(n, vector<int>(1 << (sizeof(char) << 3), 0));
    for (int i = 0; i < n; i++)
      for (int i2 = 'a'; i2 <= 'z'; i2++)
        scanf("%d", &es[i][i2]), es[i][i2]--;
    
    map<int, int> m_substrs;
    vector< pair<int, int> > substrs;
    
    stack<int> stck;
    for (int i = 0; i < str.size(); i++)
      switch (str[i]) {
      case '(': stck.push(i + 1); break;
      case ')':
        substrs.push_back(make_pair(stck.top(), i));
        m_substrs.insert(make_pair(stck.top(), substrs.size() - 1));
        stck.pop();
        break;
      }
    substrs.push_back(make_pair(0, str.size()));
    
    vector< vector<int> > T(substrs.size(), vector<int>(n));
    for (int ssi = 0; ssi < substrs.size(); ssi++) {
      int be = substrs[ssi].first, en = substrs[ssi].second;
      #ifdef DEBUG
      eprintf("%d/%d: %s\n", ssi + 1, substrs.size(), str.substr(be, en - be).c_str());
      #endif
      
      for (int st = 0; st < n; st++) {
        int cur = st;
        int first, cnt;
        for (int i = be; i < en; i++) {
          switch (str[i]) {
          case '(': {
            int ssi2 = m_substrs.find(i + 1)->second;
            i = substrs[ssi2].second;
          
            assert(str[i] == ')');
            int old_i = i;
            cnt = 0;
              
            for (i++; (i < str.size()) && (str[i] >= '0') && (str[i] <= '9'); i++)
              cnt *= 10, cnt += str[i] - '0';
            i--;
            
            int first_cur = cur, it_cnt = 0;
            while (cnt--) {
              cur = T[ssi2][cur];
              it_cnt++;
              if (cur == first_cur) cnt %= it_cnt;
            }
            break; }
          default: cur = es[cur][str[i]]; break;
          }
        }
        T[ssi][st] = cur;
        #ifdef DEBUG
        eprintf("  %d: %d\n", st + 1, cur + 1);
        #endif
      }
    }
    
    for (int st = 0; st < n; st++) {
      if (st) printf(" ");
      printf("%d", T[substrs.size() - 1][st] + 1);
    }
    printf("\n");
#ifdef DEBUG
  }
#endif

  return 0;
}
