#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>

using namespace std;

#ifdef DEBUG
int eoffset = 0;

int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
int eoprintf(const char* format, ...) {
  for (int i = 0; i < eoffset; i++) fprintf(stderr, " ");
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int n;
float d[7500][7501];

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

#ifdef DEBUG
  while (scanf("%d", &n) != EOF) {
#else
    scanf("%d", &n);
#endif

    float p;
    scanf("%f", &p); p /= 100;
    
    vector<float> ppow(n);
    ppow[0] = 1;
    for (int i = 1; i < n; i++) ppow[i] = ppow[i - 1] * p;

    for (int q = n; q >= 1; q--) d[0][q] = 0;
    for (int i = 1; i < n; i++) {
      for (int q = n - i; q >= 1; q--) {
        d[i][q] = (1 - p) * d[i - 1][q];
        
        int maxk = min(n - q, i - 1);
        for (int k = 1; k <= maxk; k++) {
          float cadd;
          if ((q != 1) && (k == 1)) cadd = ppow[k] * d[i - k - 1][q + k];
          else                      cadd = ppow[k] * (d[i - k - 1][q + k] + 1.0);
          if (k < maxk) d[i][q] += cadd * (1 - p);
          else          d[i][q] += cadd;
        }
      }
    }
    printf("%.6lf\n", d[n - 1][1]);

#ifdef DEBUG
  }
#endif

  return 0;
}
