#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>
#include <time.h>

using namespace std;

#ifdef DEBUG
int eoffset = 0;

int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
int eoprintf(const char* format, ...) {
  for (int i = 0; i < eoffset; i++) fprintf(stderr, " ");
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

inline int fac(int n) { int res = 1; for (; n > 1; n--) res *= n; return res;}

int n;

inline int getId(vector<int> &a) {
  int cId = 0;
  vector<bool> rem(n, true);
  for (int i = 0; i < n; i++) {
    for (int i2 = 0; i2 < a[i]; i2++)
      if (rem[i2]) cId += fac(n - i - 1);
    rem[a[i]] = false;
  }
  return cId;
}
inline void getPerm(int id, vector<int> &a) {
  vector<bool> rem(n, true);
  for (int i = 0; i < n; i++) {
    for (int i2 = 0; i2 < n; i2++)
      if (rem[i2])
        if (id >= fac(n - i - 1)) id -= fac(n - i - 1);
        else { rem[i2] = false; a[i] = i2; break; }
  }
}

int main() {
  long long en_time = clock() + 1.80 * (float)CLOCKS_PER_SEC;
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

#ifdef DEBUG
  while (scanf("%d", &n) != EOF) {
#else
    scanf("%d", &n);
#endif
    if (n > 10) return 1;
    
    vector<int> a(n);
    for (int i = 0; i < n; i++) scanf("%d", &a[i]), a[i]--;
    
    vector<double> cnt(fac(n), 0), cnt2;
    cnt[getId(a)] = 1;
    double t_dist = cnt[0];
    
    double prob1 = ((n * (n - 1)) >> 1);
    for (int IT = 1; ; IT++) {
      cnt2 = vector<double>(fac(n), 0);
      for (int i = 1; i < fac(n); i++) {
        if (clock() >= en_time) goto print_ans;
        if (cnt[i]) {
          vector<int> perm(n);
          getPerm(i, perm);
          for (int a = 0; a < n; a++)
             for (int b = a + 1; b < n; b++) {
              swap(perm[a], perm[b]);
              int id = getId(perm);
              cnt2[id] += cnt[i] / prob1;
              swap(perm[a], perm[b]);
            }
        }
      }
      t_dist += cnt2[0] * IT;
      cnt2.swap(cnt);
    }
    print_ans:
    int ians = t_dist;
    #ifdef DEBUG
    eprintf("%lf\n", t_dist);
    #endif
    if ((double)ians > t_dist) ians--;
    printf("%d\n", ians);
#ifdef DEBUG
  }
#endif

  return 0;
}
