#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long int64;
typedef pair<int64,int64> pii;

const int64 inf = (int64) 1e9;

#define forn(i,n) for (int64 i = 0; i < (int64)(n); i++)
#define ford(i,n) for (int64 i = (int64)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int64 nmax = 101000;
const int64 can_solve = 1000;
const int64 mod = (int64)1e9 + 7;

vector<int64> g[nmax];
int64 t[nmax];
int64 c[nmax], p1[nmax], p2[nmax], d[nmax];

int64 ans,res;
int64 n,m,ct;

int64 calc_min_dist(){
	int64 res = inf;
	queue<int64> q;
	forn(i,n){
		p1[i] = -1;
		d[i] = inf;
	}
	forn(i,ct){
		q.push(t[i]);
		d[t[i]] = 0;
		p1[t[i]] = t[i];
		c[t[i]] = 1;
	}
	while (!q.empty()){
		int64 h = q.front();
		q.pop();
		forn(i,g[h].size()){
			int64 to = g[h][i];
			if (d[to] > d[h] + 1){
				d[to] = d[h] + 1;
				p1[to] = p1[h];
				c[to] = 0;
				q.push(to);
			}
			if (p1[to] != p1[h]){
				res = min(res,d[to] + d[h] + 1);
				continue;
			}
			if (d[to] == d[h]+1) c[to] = (c[to] + c[h]) % mod;
		}
	}
	return res;
}


int64 calc_sposob(){
	int64 res = 0;	
	if (ans % 2 == 1){
		forn(i,n)
			if (d[i] == ans / 2)
				forn(j,g[i].size()){
					int64 to = g[i][j];
					if (d[to] != d[i])continue;
					if (p1[to] == p1[i])continue;
					if (to < i)continue;
					res = (res + c[i] * c[to]) % mod;
				}
		return res;
	}
	
	forn(i,n)
		if (d[i] == ans/2){
			int64 now = 0;
			vector<pii> q;
			forn(j,g[i].size()){
				int64 to = g[i][j];
				if (d[to] != d[i]-1) continue;
				now = (now + c[to]) % mod;
				q.pb(mp(p1[to],c[to]));
			}
			sort(all(q));
			q.pb(mp(-1,0));
			int64 sum = q[0].sc;
			for (int64 j = 1; j < (int64)q.size(); j++)
				if (q[j].fs == q[j-1].fs)
					sum = (sum + q[j].sc) % mod;
				else{
					res = (res + (now-sum + mod)*sum) % mod;
					sum = q[j].sc % mod;
					now = (now + mod - sum) % mod;
				}
		}
	return res;
}	

void solve(){
	ans = calc_min_dist();
	res = calc_sposob();
}

void read(){

	scanf("%lld %lld %lld",&n,&m,&ct);
	forn(i,ct){
		scanf("%lld",&t[i]);
		t[i]--;
	}
	int64 x,y;
	forn(i,m){
		scanf("%lld %lld",&x,&y);
		x--,y--;
		g[x].pb(y);
		g[y].pb(x);
	}
}

void write(){
	cout << ans << " " << res << endl;
}

int main(){

//   	freopen("input.txt","rt",stdin);
//   	freopen("output.txt","wt",stdout);
//  	
	read();
	solve();
	write();
	
	return 0;
}
