#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <cassert>
 
using namespace std;

typedef long long int64;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

typedef vector<int> tlong;
const int base = 31;

char conv1(int x){
	char res;
	if (x < 10)
		res = x + '0';
	else
		res = x-10+'A';
	return res;
}
 
int conv(char x){
	if (isdigit(x))return x-'0';
	return x-'A' + 10;
}

void norm(tlong &a){
	while (a.back() == 0)a.pop_back();
}

void read(tlong &a){
	string s;
	getline(cin,s);
	int n = s.size();
	a.resize(n);
	forn(i,n)
		a[i] = conv(s[n-i-1]);
	norm(a);
}

bool more(tlong &a, tlong &b){
	if (a.size() != b.size())
		return a.size() > b.size();
	ford(i,a.size())
		if (a[i] != b[i])
			return a[i] > b[i];
	return 0;
}

tlong mul(tlong &a, tlong &b){
	tlong res(a.size() + b.size() + 1,0);
	forn(i,a.size())
		forn(j,b.size())
			res[i+j] += a[i] * b[j];
	forn(i,res.size())
		if (res[i] >= base){
			res[i+1] += res[i] / base;
			res[i] %= base;
		}
	norm(res);
	return res;
}	
	
	
int make(int a, int b){
	forn(i,base)
		if ((i*b) % base == a)
			return i;
	assert(0);
}
			

tlong div(tlong &a, tlong &b, int k){
	int st = 0;
	while (a[st] == 0 && b[st] == 0)st++;
	tlong res(k);
	forn(i,min(k,(int)a.size()-st)){
		res[i] = make(a[i+st],b[st]);
		for (int j = i; j <= min(k,(int)a.size()-1-st); j++){
			a[j+st] -= b[j-i+st] * res[i];
			while (a[j+st] < 0){
				a[j+st] += base;
				a[j+1+st] --;
			}
		}
	}
	return res;	
}

void print(tlong a){
	forn(i,a.size())
		cout << a[i] << " ";
	cout << endl;
}
				

int main(){
//  	freopen("input.txt","rt",stdin);
//  	freopen("output.txt","wt",stdout);
		
	int k;
	
	tlong a,b,c;
	read(a);
	read(b);
	cin >> k;
	
	c = div(a,b,k);
	
	while ((int)c.size() < k) c.pb(0);
	c.resize(k);
	
	ford(i,c.size())
		printf("%c",conv1(c[i]));
	cout << endl;
	return 0;
}
