#include <cstdio>
#include <vector>
using namespace std;

int W, H, L;             // parametre zo zadania
char cmd[1024];          // postupnost prikazov
char mapa[512][512];     // mapa stola
int answer[512][512][4]; // odpovede, -1 znamena neviem, -2 prave spracuvam, 0 cyklus

struct stav { int r,c,d,l; }; // riadok, stlpec, smer a nasledujuca instrukcia

// konstanty pre pohyb jednotlivymi smermi
int dr[]={-1,0,1,0}, dc[]={0,1,0,-1};

// funkcia wall(stav) vrati true, ak je robot na policku so stenou
inline bool wall(const stav &current) {
  return (current.r >= 0 && current.r < H)
      && (current.c >= 0 && current.c < W)
      && (mapa[ current.r ][ current.c ] == '#');
}

// funkcia outside(stav) vrati true, ak robot padol zo stola
inline bool outside(const stav &current) {
  return current.r < 0 || current.r >= H || current.c < 0 || current.c >= W;
}

// funkcia next(stav) vrati nasledujuci stav robota
inline stav next(const stav &current) {
  stav result;
  // default: suradnice aj smer zostanu, instrukcia stupne o 1
  result.r = current.r;
  result.c = current.c;
  result.d = current.d;
  result.l = (current.l + 1) % L;

  // rozdiely oproti defaultu: podla prikazu
  switch (cmd[ current.l ]) {
    case 'R': result.d = (current.d + 1) % 4; break;
    case 'L': result.d = (current.d + 3) % 4; break;
    case '+': 
      // skusime sa posunut podla aktualneho smeru
      result.r += dr[result.d]; result.c += dc[result.d];
      if (wall(result)) { result.r = current.r; result.c = current.c; }
    break;
    case '-': 
      result.r -= dr[result.d]; result.c -= dc[result.d];
      if (wall(result)) { result.r = current.r; result.c = current.c; }
    break;
  }
  return result;
}

int main() {
  // nacitame vstup
  scanf("%d%s%d%d",&L,cmd,&W,&H);
  for (int r=0; r<H; r++) scanf("%s",mapa[r]);
  memset(answer,-1,sizeof(answer));

  // spracujeme vstup
  for (int r=0; r<H; r++) for (int c=0; c<W; c++) if (mapa[r][c]=='.') if (answer[r][c][0]==-1) {
    answer[r][c][0] = -2;
    stav S; S.r=r; S.c=c; S.d=0; S.l=0;
    vector<stav> V; V.push_back(S);
    while (1) {
      S = next(S);
      if (outside(S)) {
        // padol zo stola
        int X = V.size();
        for (int i=0; i<X; i++) if (V[i].l==0) answer[ V[i].r ][ V[i].c ][ V[i].d ] = X-i;
        break;
      }
      if (S.l==0 && (answer[S.r][S.c][S.d]==-2 || answer[S.r][S.c][S.d]==0)) {
        // zacyklil sa 
        int X = V.size();
        for (int i=0; i<X; i++) if (V[i].l==0) answer[ V[i].r ][ V[i].c ][ V[i].d ] = 0;
        break;
      }
      if (S.l==0 && answer[S.r][S.c][S.d]>0) {
        // uz vieme po kolkych krokoch padne
        int X = V.size(), Y = answer[S.r][S.c][S.d];
        for (int i=0; i<X; i++) if (V[i].l==0) answer[ V[i].r ][ V[i].c ][ V[i].d ] = X+Y-i;
        break;
      }
      if (S.l==0) answer[S.r][S.c][S.d]=-2;
      V.push_back(S);
    }
  }

  // vypiseme vystup
  int padne = 0;
  for (int r=0; r<H; r++) for (int c=0; c<W; c++) if (answer[r][c][0]>0) padne++;
  printf("%d\n",padne);
  for (int r=0; r<H; r++) {
    for (int c=0; c<W; c++) printf("%s%d",c?" ":"",max(0,answer[r][c][0]));
    printf("\n");
  }
}
