#include <stdio.h>
#define MAXN 10000
#define MAXM 1000000

struct edge {
  int from, to, value;
};

struct dedge {
  int to, value;
};

struct path {
  int start; 
  int first, second;
  int fvalue, svalue;
};

int m, n;
struct path P[MAXN];

struct edge edges[MAXM];
int ec;

int pos[MAXN+1];
struct dedge out[MAXM];

int main() 
{
  scanf("%i %i", &n, &m);

  int i;
  int deg[MAXN+1] = {0};
  for (i=0; i<m; i++) {
    scanf("%i %i %i", &edges[i].from, &edges[i].to, &edges[i].value);
    deg[edges[i].from]++;
    deg[edges[i].to]++;
  }

  int v;
  for (v=1; v<=n; v++) //spocteme si pozice hran jednotlivych vrcholu
    pos[v] = pos[v-1] + deg[v];

  for (i=0; i<m; i++) { //zapiseme hrany do pole ve spravnem poradi
    v = edges[i].from;
    out[pos[v]-deg[v]].to = edges[i].to;
    out[pos[v]-deg[v]].value = edges[i].value;
    deg[v]--;
    v = edges[i].to;
    out[pos[v]-deg[v]].to = edges[i].from;
    out[pos[v]-deg[v]].value = edges[i].value;
    deg[v]--;
  }

  int best = 0, a, b, c, d; // nas nejlepsi okruh a-b-c-d-a

  for (v=1; v<=n; v++) {
    int e, f;
    for (e=pos[v-1]; e<pos[v]; e++) {
      int w = out[e].to;
      for (f=pos[w-1]; f<pos[w]; f++) {
        int x = out[f].to;
        if (x == v) continue; //vratili jsme se zpet
        if (v != P[x].start) { //inicializace hodnot
          P[x].start = v;
          P[x].fvalue = P[x].svalue = 0;
        }

        if (out[e].value + out[f].value > P[x].fvalue) {
          P[x].second = P[x].first;
          P[x].svalue = P[x].fvalue;
          P[x].first = w;
          P[x].fvalue = out[e].value + out[f].value;
        } 
        else if (out[e].value + out[f].value > P[x].svalue) {
          P[x].second = w;
          P[x].svalue = out[e].value + out[f].value;
        }
          
        if (P[x].svalue && P[x].fvalue + P[x].svalue > best) {
          best = P[x].fvalue + P[x].svalue;
          a = v; b = P[x].first; c = x; d = P[x].second;
        }
      }
    }
  }

  if (!best)
    printf("NEEXISTUJE\n");
  else
    printf("%i\n%i %i %i %i %i\n", best, a, b, c, d, a);

  return 0;
}
