// O(N^2) per test

#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 3000

vector<int> xs, ys;
vector<pair<int, int> > p;
int xlestk[NMAX], ystk[NMAX], nstk, amax, xleft, xright, ylow, yhigh, pidx, xleok, xriok, ylook, yhiok, leq;
int i, j, k, N, XMAX, YMAX, x, y;

int main()
{
  int T;

  freopen("dr.in", "r", stdin);
  freopen("dr.out", "w", stdout);

  scanf("%d", &T);

  while (T--)
  {
    scanf("%d %d %d", &N, &XMAX, &YMAX);

    p.clear();
    xs.clear();
    ys.clear();

    for (i = 0; i < N; i++)
    {
      scanf("%d %d", &x, &y);
      p.push_back(make_pair(x, y));
      xs.push_back(x);
      ys.push_back(y);
    }

    xs.push_back(0);
    xs.push_back(XMAX);

    ys.push_back(0);
    ys.push_back(YMAX);

    sort(xs.begin(), xs.end());
	unique(xs.begin(), xs.end());

	sort(ys.begin(), ys.end());
	unique(ys.begin(), ys.end());

    sort(p.begin(), p.end());

    amax = 0;

    for (ylow = ys.size() - 1; ylow >= 0; ylow--)
    {
      // find the largest area rectangle with the lower side at y=ys[ylow]

      pidx = nstk = 0;
	  while (pidx < N && p[pidx].first == xs[0])
		  pidx++;

      //fprintf(stderr, "ylow=%d\n", ylow);

      for (xright = 1; xright < xs.size(); xright++)
        for (leq = 0; leq < 2; leq++)
        {
          yhigh = YMAX;
          while (pidx < N && ((p[pidx].first < xs[xright] && leq == 0) || (p[pidx].first == xs[xright] && leq > 0)))
          {
            if ((p[pidx].second > ys[ylow] && p[pidx].second < yhigh))
              yhigh = p[pidx].second;
            pidx++;
          }

          //fprintf(stderr, "yhigh=%d, pidx=%d, N=%d\n", yhigh, pidx, N);

          // consider the rectangle R = (xleft, xs[xright]) x (ys[ylow], yhigh)
     	  xleft = xs[xright - 1 + leq];

          // empty the stack
          while (nstk > 0 && ystk[nstk] >= yhigh)
          {
            if ((ystk[nstk] - ys[ylow]) * (xs[xright - 1 + leq ] - xlestk[nstk]) > amax)
            {
             amax = (ystk[nstk] - ys[ylow]) * (xs[xright - 1 + leq] - xlestk[nstk]);
             xleok = xlestk[nstk];
             xriok = xs[xright - 1 + leq];
             ylook = ys[ylow];
             yhiok = ystk[nstk];
            }

            xleft = xlestk[nstk];
            nstk--;
         }

          // push the rectangle R (extended as far as possible to the left) on the stack
          nstk++;
          xlestk[nstk] = xleft;
          ystk[nstk] = yhigh;
       }

      // empty the stack
      while (nstk > 0)
      {
        if ((ystk[nstk] - ys[ylow]) * (XMAX - xlestk[nstk]) > amax)
        {
          amax = (ystk[nstk] - ys[ylow]) * (XMAX - xlestk[nstk]);
          xleok = xlestk[nstk];
          xriok = XMAX;
          ylook = ys[ylow];
          yhiok = ystk[nstk];
        }

        nstk--;
      }
    }

    fprintf(stderr, "amax=%d, xleft=%d, xright=%d, xmax=%d, ylow=%d, yhigh=%d, ymax=%d\n", amax, xleok, xriok, XMAX, ylook, yhiok, YMAX);
    printf("%d\n", amax);
  }

  return 0;
}
