/* Author: Victor-Marius Costan */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char cmap[100][100];
#define VF_VALID			0x80
//! NORTH AND SOUTH ARE SWITCHED, SO (0,0) IS NORTH-WEST
int f_moves[4][2] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};
char f_masks[4] = {0x01, 0x02, 0x04, 0x08};

int f_map[100][100];
int queue[10000][2];

int cpos[1008][2];

void do_fill(int xs, int ys) {
	int qin, qout;
	int cx, cy, cd;
	int x;

	memset(f_map, 0xff, sizeof(f_map));
	f_map[xs][ys] = 0;
	queue[0][0] = xs;
	queue[0][1] = ys;
	qin = 1; qout = 0;

	while(qin != qout) {
		cx = queue[qout][0];
		cy = queue[qout++][1];
		cd = f_map[cx][cy];

		for(x = 0; x < 4; x++) {
			if(!(cmap[cx][cy] & f_masks[x]))
				continue;
			if(!(cmap[cx + f_moves[x][0]][cy + f_moves[x][1]] & VF_VALID))
				continue;
			if(f_map[cx + f_moves[x][0]][cy + f_moves[x][1]] == -1) {
				f_map[cx + f_moves[x][0]][cy + f_moves[x][1]] = cd + 1;
				queue[qin][0] = cx + f_moves[x][0];
				queue[qin++][1] = cy + f_moves[x][1];
			}
		}
	}
}

long dm0[1008];
long dm1[1008];

int main() {
	FILE *fp;
	long sd, mc, cc;
	int xs, ys;
	int x0, y0, tx, ty;
	int nc, n;
	int x, y;
	int tc[4];
	char tf;

	memset(cmap, 0, sizeof(cmap));
	
	fp = fopen("exit.in", "rt");
	fscanf(fp, "%d %d %d %d %d %d", &n, &xs, &ys, &x0, &y0, &nc);
	for(x = 0; x < nc; x++) {
		fscanf(fp, "%d %d %d %d %d %d", &tx, &ty, &tc[0], &tc[1], &tc[2],
&tc[3]);

		tf = 0;
		for(y = 0; y < 4; y++)
			tf = (tf << 1) | (!tc[y]);
		tf |= VF_VALID;
		cmap[tx][ty] = tf;
	}
	cpos[0][0] = x0; cpos[0][1] = y0;
	for(x = 1; x <= n; x++)
		fscanf(fp, "%d %d", &cpos[x][0], &cpos[x][1]);
	fclose(fp);

	for(x = 0; x < xs; x++) {
		cmap[x][0] &= ~0x02;
		cmap[x][ys - 1] &= ~0x08;
	}
	for(x = 0; x < ys; x++) {
		cmap[0][x] &= ~0x01;
		cmap[xs - 1][x] &= ~0x04;
	}

	dm1[0] = 0;
	for(y = 1; y <= n; y++) {
		memcpy(dm0, dm1, sizeof(long) * y);

		do_fill(cpos[y][0], cpos[y][1]);

		sd = f_map[cpos[y - 1][0]][cpos[y - 1][1]];
		for(x = 0; x < y; x++)
			dm1[x] = dm0[x] + sd;

		mc = dm1[y - 1];
		for(x = 0; x < y; x++) {
			cc = dm0[x] + f_map[cpos[x][0]][cpos[x][1]];
			if(cc < mc)
				mc = cc;
		}
		dm1[y - 1] = mc;

		dm1[y] = dm1[y - 1] + sd;

	}

	fp = fopen("exit.out", "wt");
	fprintf(fp, "%ld\n", dm1[n]);
	fclose(fp);

	return 0;
}
