#include <stdio.h>
#include <string.h>

#include <vector>
using namespace std;

#define NMAX 50100
#define VISITED 1
#define MATCHED 2

vector<int> v[NMAX], sons[NMAX];
int q[NMAX], parent[NMAX];
char marked[NMAX];
int i, j, k, N, M, li, ls, prevson;

void bf(int root)
{
	li = ls = 1;
	q[1] = root;

	memset(marked, 0, sizeof(marked));
	marked[root] = VISITED;

	while (li <= ls)
	{
		i = q[li];
		for (j = 0; j < v[i].size(); j++)
		{
			k = v[i][j];

			if (!marked[k])
			{
				parent[k] = i;
				sons[i].push_back(k);

				marked[k] = VISITED;
				ls++;
				q[ls] = k;
			}
		}

		li++;
	}
}

void process(int node)
{
	prevson = 0;
	for (j = 0; j < sons[node].size(); j++)
	{
		k = sons[node][j];

		if (marked[k] == MATCHED)
			continue;

		if (!prevson)
			prevson = k;
		else
		{
			printf("%d %d\n", prevson, k);
			//fprintf(stderr, "1\n");
			marked[prevson] = MATCHED;
			marked[k] = MATCHED;
			prevson = 0;
		}
	}

	if (prevson > 0)
	{
		printf("%d %d\n", node, prevson);
		//fprintf(stderr, "2\n");
		marked[node] = MATCHED;
		marked[prevson] = MATCHED;
	}
}

int main()
{
	freopen("g2mm.in", "r", stdin);
	freopen("g2mm.out", "w", stdout);

	scanf("%d %d", &N, &M);

	for (k = 0; k < M; k++)
	{
		scanf("%d %d", &i, &j);
		v[i].push_back(j);
		v[j].push_back(i);
	}

	// construct a spanning tree of the graph
	bf(1);

	printf("1\n");
	for (i = ls; i >= 1; i--)
		process(q[i]);

	return 0;
}
