// O(N^2 * K)

#include <stdio.h>

#define NMAX 100100
#define INF 1000000001
#define MAXSTEPS 100

#define min(a, b) ((a) < (b) ? (a) : (b)) 
#define max(a, b) ((a) > (b) ? (a) : (b)) 

int x[NMAX], smin[2][NMAX];
int i, j, k, N, K, c, a, vmin, vmax, pmax;

int main()
{
	freopen("ksecv.in", "r", stdin);
	scanf("%d %d", &N, &K);

	for (i = 1; i <= N; i++)
		scanf("%d", &x[i]);

	// initialize for k=0
	smin[a = c = 0][0] = 0;
	for (i = 1; i <= N; i++)
		smin[0][i] = INF;

	for (k = 1; k <= K; k++)
	{
		c = 1 - a;

		smin[c][k] = smin[a][k - 1] + x[k];
		pmax = -INF;

		for (i = k + 1; i <= N; i++)
		{
			vmax = x[i];
			vmin = x[i] + smin[a][i - 1];

			// incearca o subsecventa "scurta" care se termina la pozitia i
			for (j = i - 1; j >= k && i - j <= MAXSTEPS; j--)
			{
				vmax = max(vmax, x[j]);
				vmin = min(vmin, smin[a][j - 1] + vmax);
			}

			// incearca o subsecventa "lunga" care se termina la pozitia i
			if (i > k + MAXSTEPS)
			{
				pmax = max(pmax, x[i]);
				vmax = pmax;
				for (j = k + MAXSTEPS + 1; j >= k; j--)
				{
					vmax = max(vmax, x[j]);
					vmin = min(vmin, smin[a][j - 1] + vmax);
				}
			}

			smin[c][i] = vmin;
		}

		a = c;
	}

	freopen("ksecv.out", "w", stdout);
	printf("%d\n", smin[c][N]);

	return 0;
}
