// O(N^2 * K)

#include <stdio.h>

#define NMAX 100100
#define INF 1000000001
#define MAXSTEPS 100

#define min(a, b) ((a) < (b) ? (a) : (b)) 
#define max(a, b) ((a) > (b) ? (a) : (b)) 

int x[NMAX], sleft[NMAX], sright[NMAX];
int i, j, k, N, K, c, a, vmin, vmax, pmax;

int main()
{
	freopen("ksecv.in", "r", stdin);
	scanf("%d %d", &N, &K);

	for (vmax = -INF, i = 1; i <= N; i++)
	{
		scanf("%d", &x[i]);

		if (x[i] > vmax)
		{
			vmax = x[i];
			pmax = i;
		}
	}

	sleft[0] = 0;
	for (i = 1; i <= N; i++)
		sleft[i] = sleft[i - 1] + x[i];

	sright[N + 1] = 0;
	for (i = N; i >= 1; i--)
		sright[i] = sright[i + 1] + x[i];

	// consider that the sequence containing vmax is as large as possible

	vmin = INF;

	for (i = 0; i < pmax && i <= K - 1; i++)
		if (pmax < N - (K - 1 - i) + 1)
			vmin = min(vmin, sleft[i] + sright[N - (K - 1 - i) + 1]);

	freopen("ksecv.out", "w", stdout);
	printf("%d\n", vmin + vmax);

	return 0;
}