#include <stdio.h>

#include <vector>
#include <set>
#include <algorithm>
using namespace std;

#define NMAX 262144
#define PMAX 100100
#define EXTRA 10
#define INF 2100000000

#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))

#define col(i) (events[i].first)
#define type(i) (events[i].second.first)
#define id(i) (events[i].second.second)

int qagg[(NMAX << 1) + EXTRA];
set<pair<int, int> > uagg[(NMAX << 1) + EXTRA];
int li[(NMAX << 1) + EXTRA], ls[(NMAX << 1) + EXTRA];
vector<pair<int, pair<char, int> > > events;
int lup[PMAX], cleft[PMAX], ldown[PMAX], cright[PMAX];
int C[PMAX], cmin;
int i, j, k, N, L, P;

void build_tree(int side)
{
     for (i = NMAX; i < (NMAX << 1); i++)
     {
         if (i - (NMAX - 1) > N - side + 1)
		 {
            qagg[i] = INF;
			uagg[i].clear();
			uagg[i].insert(make_pair(-INF, -1));
		 }
		 else
		 {
            qagg[i] = 0;
			uagg[i].clear();
			uagg[i].insert(make_pair(0, -1));
		 }

         li[i] = ls[i] = i - (NMAX - 1);
     }
     
     for (i = NMAX - 1; i >= 1; i--)
     {
         uagg[i].clear();
		 uagg[i].insert(make_pair(0, -1));

         li[i] = li[i << 1];
         ls[i] = ls[(i << 1) + 1];
         
         qagg[i] = min(qagg[i << 1], qagg[(i << 1) + 1]);
     }
}

void update(int node, int value, char op, int vid, int a, int b)
{
     int lson, rson;
     
	//fprintf(stderr, "node=%d, [%d-%d]\n", node, a, b);

     if (a > b)
        return;

     if (a == li[node] && b == ls[node])
     {
         if(op > 0)
         {
			uagg[node].insert(make_pair(-value, vid));
		 }
         else
         {
			uagg[node].erase(make_pair(-value, vid));
		 }
        
		qagg[node] = max( qagg[node], -((*(uagg[node].begin())).first));
		return;
	 }

     lson = (node << 1);
     rson = lson + 1;
     
     if (a <= ls[lson])
       update(lson, value, op, vid, a, min(b, ls[lson]));
     
     if (b >= li[rson])
        update(rson, value, op, vid, max(li[rson], a), b);
        
     qagg[node] = max(min(qagg[lson], qagg[rson]), -((*(uagg[node].begin())).first));
}

#define query() (qagg[1])

/*
inline unsigned int query()
{
       return (qagg[1]);
}
*/

void sweep_line()
{
    int curcol, lastcol = 0;
    int idj, typej, lupj, ldownj, qcost;
    
    // compute events
    events.clear();
    for (i = 1; i <= P; i++)
    {
        events.push_back(make_pair(cleft[i], make_pair(+1, i)));

        if (cright[i] + L <= N)
            events.push_back(make_pair(cright[i] + L, make_pair(-1, i)));
    }
    
    events.push_back(make_pair(N + 1, make_pair(1, 1)));
    
    // sort the events
    sort(events.begin(), events.end());
    
    // build the tree
    build_tree(L);

    // do the checking
    for (i = 0; i < events.size();)
    {
        curcol = col(i);
        
        if (lastcol < curcol - 1)
        {
           lastcol = min(curcol - 1, N);

           if ((lastcol >= L) && ((qcost = query()) < cmin))
              cmin = qcost;
        }
        
        if (curcol > N)
           return;
        
        j = i;
        
        do
        {
                //printf("event: x=%d, obst=%d, type=%d, ya=%d, yb=%d\n", curx, id(j), type(j), ya[id(j)], yb[id(j)]);
                //idj = id(j);
                //typej = type(j);
                lupj = max(1, lup[id(j)] - L + 1);
                ldownj = min(ldown[id(j)], N - L + 1);
                      
                // process this event
                update(1, C[id(j)], type(j), id(j), lupj, ldownj);
                j++;   
        }
        while (j < events.size() && col(j) == col(i));
        
        i = j;
        
        lastcol = curcol;
        if ((lastcol >= L) && ((qcost = query()) < cmin))
            cmin = qcost;        
    }
}

int main()
{
    freopen("mm.in", "r", stdin);
    freopen("mm.out", "w", stdout);
    
    scanf("%d %d %d", &N, &L, &P);

    for (i = 1; i <= P; i++)
        scanf("%d %d %d %d %d", &lup[i], &cleft[i], &ldown[i], &cright[i], &C[i]);

	cmin = INF;
	sweep_line();

	printf("%d\n", cmin);
    
    return 0;
}
