#include <stdio.h>
#include <string.h>

#define KMAX 101
#define BITMAX 30
#define PMOD 41143

int np[KMAX][KMAX], T[KMAX][KMAX], Texp[KMAX][KMAX], Taux[KMAX][KMAX];
int i, j, p, e, N, K, bit, ans;

int main()
{
	freopen("pkinv.in", "r", stdin);
	scanf("%d %d", &N, &K);

	memset(np, 0, sizeof(np));
	np[0][0] = 1 % PMOD;

	for (i = 1; i <= N && i <= K; i++)
		for (j = 0; j <= K; j++)
			for (p = j; p >= 0 && p >= j - i + 1; p--)
				np[i][j] = (np[i][j] + np[i - 1][p]) % PMOD;

	freopen("pkinv.out", "w", stdout);

	if (N <= K)
	{
		printf("%d\n", np[N][K]);
	}
	else
	{
		memset(T, 0, sizeof(T));

		for (i = 0; i <= K; i++)
			for (j = 0; j <= i; j++)
				T[i][j] = 1 % PMOD;

		// raise T at the (N-K)th power
		e = N - K;

		memset(Texp, 0, sizeof(Texp));
		for (i = 0; i <= K; i++)
			Texp[i][i] = 1 % PMOD;

		for (bit = BITMAX; bit >= 0; bit--)
		{
			for (i = 0; i <= K; i++)
				for (j = 0; j <= K; j++)
				{
					Taux[i][j] = 0;
					for (p = 0; p <= K; p++)
						Taux[i][j] = (Taux[i][j] + Texp[i][p] * Texp[p][j]) % PMOD;
				}

			memmove(Texp, Taux, sizeof(Texp));

			if (e & (1 << bit))
			{
				for (i = 0; i <= K; i++)
					for (j = 0; j <= K; j++)
					{
						Taux[i][j] = 0;
						for (p = 0; p <= K; p++)
							Taux[i][j] = (Taux[i][j] + Texp[i][p] * T[p][j]) % PMOD;
					}

				memmove(Texp, Taux, sizeof(Texp));
			}
		}

		ans = 0;
		for (j = 0; j <= K; j++)
			ans = (ans + Texp[K][j] * np[K][j]) % PMOD;

		printf("%d\n", ans);
	}

	return 0;
}
