#include <cstdio>
#include <algorithm>
using namespace std;

const int NMAX = 250001;
const int PMAX = 30001;

int Rem[1 << 19];

int A[NMAX];
int BPowRem[NMAX], nbp;
bool mod0 = false;

int n, b, p;

void buildBPowRemainders() {
	BPowRem[0] = 1;
	
	int pow;
	BPowRem[1] = b % p;
	if (BPowRem[1] == 0) {
		mod0 = true;
		nbp = 0;
		return;
	}
	
	for (pow = 1; pow < NMAX; ++ pow) {
		BPowRem[pow + 1] = (b * BPowRem[pow]) % p;
	}
	
	/*for (int i = 0; i <= nbp; ++ i)
		printf("%d ", BPowRem[i]);
	printf("\n");*/
}

void buildIT(int i, int l, int r) {
	if (l == r) {
		Rem[i] = A[l - 1] % p;
		return;
	}
	
	int m = (r - l) / 2 + l;
	buildIT(2 * i, l, m);
	buildIT(2 * i + 1, m + 1, r);
	
	int pb;
	pb = BPowRem[(r - m)];
	
	Rem[i] = ((Rem[2 * i] * pb) % p + Rem[2 * i + 1]) % p;
}

/*void printIT(int i, int l, int r) {
	if (l > r)
		return;
	
	printf("%d %d %d\n", l, r, Rem[i]);
	
	if (l == r)
		return;
	
	int m = (r - l) / 2 + l;
	printIT(2 * i, l, m);
	printIT(2 * i + 1, m + 1, r);
	
}*/

void updateIT(int target, int key, int i, int l, int r) {
	if (l == r && l == target) {
		A[l - 1] = key;
		Rem[i] = key % p;
		return;
	}	
		
	int m = (r - l) / 2 + l;
	if (target <= m)
		updateIT(target, key, 2 * i, l, m);
	else
		updateIT(target, key, 2 * i + 1, m + 1, r);
	
	int pb;
	pb = BPowRem[(r - m)];
	
	Rem[i] = ((Rem[2 * i] * pb) % p + Rem[2 * i + 1]) % p;
	
	
}

int queryIT(int lt, int rt, int i, int l, int r) {
	if (lt == l && rt == r)
		return Rem[i];
	
	int m = (r - l) / 2 + l, ansl, ansr, ans;
	
	ansl = ansr = 0;
	if (l <= lt && lt <= m)
		ansl = queryIT(lt, min(rt, m), 2 * i, l, m);
	
	if (m < rt && rt <= r) {
		ansr = queryIT(max(lt, m + 1), rt, 2 * i + 1, m + 1, r);
		
		int pb;
		pb = BPowRem[(rt - m)];
		
		ans = ((ansl * pb) % p + ansr) % p;
	} else
		ans = ansl;
	
	
	//printf("%d %d %d %d %d %d\n", lt, rt, i, l, r, ans);
	return ans;
}

int main() {
	
	freopen("rest.in", "r", stdin);
	freopen("rest.out", "w", stdout);
	
	scanf("%d %d %d", &n, &b, &p);
	int i;
	for (i = 0; i < n; ++ i)
		scanf("%d", &A[i]);

	buildBPowRemainders();
	buildIT(1, 1, n);
	
	//printIT(1, 1, n);
	int q, s, x, y;
	scanf("%d", &q);
	for (i = 0; i < q; ++ i) {
		scanf("%d %d %d", &s, &x, &y);
		if (s == 1)
			updateIT(x, y, 1, 1, n);
		else
			printf("%d\n", queryIT(x, y, 1, 1, n));
	}
	
    return 0;
}
